' This script can be used to upgrade applications

Dim oUpgradeHelper       'As UpgradeEng_73.UpgradeHelper
Dim oFactory             'As ObjectFactory
Dim oSrcConnectionDoc    'As ConnectionDocument_73.Document
Dim oDestConnectionDoc   'As ConnectionDocument_73.Document
Dim oAmHelper            'As CPACCMANLib_73.CPAccManAPI
Dim oDestProviderOptions 'As Scripting.Dictionary

Set oFactory = CreateObject("Factory_73.ObjectFactory")
Set oUpgradeHelper = oFactory.CreateObject("UpgradeEng_%v.UpgradeHelper")
Set oAmHelper = oFactory.CreateObject("CPAccMan_%v.CPAccManAPI")
Set oDestProviderOptions = oFactory.CreateObject("Scripting.Dictionary")

'Access Manager Credentials: Login via one of the lines below
Call oAmHelper.Login("xxxx", "xxxx")  'Login via username and password. 
'Call oAmHelper.OSLogon()     'Login via OS Signon. No parameters needed.


'---------------------------------------------------------
' Set-up parameters for SOURCE database connections
'---------------------------------------------------------
set oSrcConnectionDoc = oFactory.CreateObject("ConnectionDocument_%v.Document")
' SQL Server options follow, Oracle and DB2 are lower down---------

'oSrcConnectionDoc.Trusted = true                     'use trusted connection
'oSrcConnectionDoc.Provider = 0                       'SQL Server
'oSrcConnectionDoc.ProviderDriverString = "SQLOLEDB"  'OLEDB data provider identifier
'oSrcConnectionDoc.DataSource = "(local)"             'name of SQL server instance - default is (local)
'oSrcConnectionDoc.ApplicationName = "tutorial"      'name of database on the SQL server


' --Use the following options if you are NOT using trusted connection----

'oSrcConnectionDoc.Trusted = false                    'set other connection properties: see product documentation
'oSrcConnectionDoc.Username = "xxxx"                  'for further information.
'oSrcConnectionDoc.EncryptedPassword = "xxxx"         
'OR
'oSrcConnectionDoc.UnEncryptedPassword = "xxxx"

'---End of SQL Server Setup ---


'ORACLE options--------------------------------------------

'oSrcConnectionDoc.Trusted = true                           'use trusted connection
'oSrcConnectionDoc.Provider = 1                             'ORACLE is the database provider
'oSrcConnectionDoc.ProviderDriverString = "OraOLEDB.Oracle" 'OLEDB data provider identifier
'oSrcConnectionDoc.DataSource = "DATABASE_INSTANCE_NAME"    'name of Oracle Database Instance
'oSrcConnectionDoc.ApplicationName = "tutorial"            'name of Oracle application container

' --Use the following options if you are NOT using trusted connection----

'oSrcConnectionDoc.Trusted = false                          'set other connection properties: see product documentation
'oSrcConnectionDoc.Username = "xxxx"                        'for further information.
'oSrcConnectionDoc.EncryptedPassword = "xxxx"         
'OR
'oSrcConnectionDoc.UnEncryptedPassword = "xxxx"

'---End of Oracle Server Setup ---


'DB2 UDB options--------------------------------------------

'oSrcConnectionDoc.Trusted = true                     'use trusted connection
'oSrcConnectionDoc.Provider = 3                       'DB2 for UDB is the database provider
'oSrcConnectionDoc.ProviderDriverString = "IBMDADB2"  'OLEDB data provider identifier
'oSrcConnectionDoc.DataSource = "INSTANCE_NAME"       'name of DB2 Instance
'oSrcConnectionDoc.ApplicationName = "tutorial"       'name of DB2 application container 

' --Use the following options if you are NOT using trusted connection----

'oSrcConnectionDoc.Trusted = false                    'set other connection properties: see product documentation
'oSrcConnectionDoc.Username = "xxxx"                  'for further information.
'oSrcConnectionDoc.EncryptedPassword = "xxxx"         
'OR
'oSrcConnectionDoc.UnEncryptedPassword = "xxxx" 

'---End of DB2 UDB Setup ---


'---------------------------------------------------------
' Set-up parameters for DESTINATION database connections
'---------------------------------------------------------
set oDestConnectionDoc = oFactory.CreateObject("ConnectionDocument_%v.Document")
' SQL Server options follow, Oracle and DB2 are lower down---------

'oDestConnectionDoc.Trusted = true                    'use trusted connection
'oDestConnectionDoc.Provider = 0                      'SQL Server
'oDestConnectionDoc.ProviderDriverString = "SQLOLEDB" 'OLEDB data provider identifier
'oDestConnectionDoc.DataSource = "(local)"            'name of SQL server instance - default is (local)
'oDestConnectionDoc.ApplicationName = "tutorial"     'name of database on the SQL server


' --Use the following options if you are NOT using trusted connection----

'oDestConnectionDoc.Trusted = false                   'set other connection properties: see product documentation
'oDestConnectionDoc.Username = "xxxx"                 'for further information.
'oDestConnectionDoc.EncryptedPassword = "xxxx"        
'OR
'oDestConnectionDoc.UnEncryptedPassword = "xxxx"

'---End of SQL Server Setup ---


'ORACLE options--------------------------------------------

'oDestConnectionDoc.Trusted = true                          'use trusted connection
'oDestConnectionDoc.Provider = 1                            'ORACLE is the database provider
'oDestConnectionDoc.ProviderDriverString = "OraOLEDB.Oracle"'OLEDB data provider identifier
'oDestConnectionDoc.DataSource = "DATABASE_INSTANCE_NAME"   'name of Oracle Database Instance
'oDestConnectionDoc.ApplicationName = "tutorial3"           'name of Oracle application container

' --Use the following options if you are NOT using trusted connection----

'oDestConnectionDoc.Trusted = false                         'set other connection properties: see product documentation
'oDestConnectionDoc.Username = "xxxx"                       'for further information.
'oDestConnectionDoc.EncryptedPassword = "xxxx"        
'OR
'oDestConnectionDoc.UnEncryptedPassword = "xxxx"

' --Set Table Space Options (Uncomment if Oracle is the Destination Provider - required)
'oDestProviderOptions.Add "DATA_TABLESPACE",   "USERS"
'oDestProviderOptions.Add "INDEX_TABLESPACE",  "INDX"
'oDestProviderOptions.Add "BLOB_TABLESPACE",   "USERS"
'oDestProviderOptions.Add "TEMP_TABLESPACE",   "TEMP"

'---End of Oracle Server Setup ---


'DB2 UDB options--------------------------------------------

'oDestConnectionDoc.Trusted = true                    'use trusted connection
'oDestConnectionDoc.Provider = 3                      'DB2 for UDB is the database provider
'oDestConnectionDoc.ProviderDriverString = "IBMDADB2" 'OLEDB data provider identifier
'oDestConnectionDoc.DataSource = "INSTANCE_NAME"      'name of DB2 Instance
'oDestConnectionDoc.ApplicationName = "tutorial"      'name of DB2 application container 

' --Use the following options if you are NOT using trusted connection----

'oDestConnectionDoc.Trusted = false                   'set other connection properties: see product documentation
'oDestConnectionDoc.Username = "xxxx"                 'for further information.
'oDestConnectionDoc.EncryptedPassword = "xxxx"        
'OR
'oDestConnectionDoc.UnEncryptedPassword = "xxxx"   

'--Set Table Space Options (Uncomment if DB@ UDB is the Destination Provider - required)
'oDestProviderOptions.Add "DATA_TABLESPACE",  "USERSPACE1"
'oDestProviderOptions.Add "INDEX_TABLESPACE", "USERSPACE1"
'oDestProviderOptions.Add "BLOB_TABLESPACE",  "USERSPACE1"

'---End of DB2 UDB Setup ---



'---Begin Import\Upgrade Function Call

'Function Parameters

'Call oUpgradeHelper.Upgrade(SrcConnectionDoc, _      'String: Source Connection Document. Do not change this line.
'                       DestConnectionDoc, _          'String: Destination Connection Document. Do not change this line.
'                       DestAppDisplayName, _         'String: Destination Application Display Name
'                       oDestProviderOptions, _       'Object: Destination Provider Options. Do not change this line.
'                       DestDsFileLocation, _         'String: Destination SQL Server Data Store File Location
'                       DestDsBackupLocation, _       'String: Destination Data Store Backup Location
'                       DestDsbackupIfExists, _       'Boolean: (True/False): Backup Destination Data Store if it Exists
'                       ReUseApplication, _           'Boolean: (True/False): Drop Destination Data Store and Recreate it if it Exists
'                       DestUpGradeSecurity, _        'Boolean: (True/False): Upgrade from Native to Access Manager Security.
'                       DestSecurityClassPrefix, _    'String: If Upgrading Security, new Access Manager Class Name Prefix
'                       DestSecurityClassSuffix, _    'String: If Upgrading Security, new Access Manager Class Name Suffix
'                       DestGenerateImportFiles, _    'Boolean: (True/False): Generate eList, Class, and Rights Import Files in Temp Directory
'                       oAmHelper.CreateTicket)       'String: Access Manager Ticket - Generated after login above. Do not change this line.



'SAMPLE
'Call oUpgradeHelper.Upgrade(oSrcConnectionDoc.Serialise(), _
'                       oDestConnectionDoc.Serialise(), _    
'                       "tutorial", _        
'                       oDestProviderOptions, _ 
'                       "d:\dbs", _          
'                       "d:\dbs", _          
'                       True, _                  
'                       True, _                  
'                       True, _                  
'                       "Prefix", _                 
'                       "Suffix", _                
'                       True, _                  
'                       oAmHelper.CreateTicket())  

' You will have to manually Link to the new application from within 
'  the Contributor Administration Console and assign it to a job server or cluster

'---Uncomment below if you would like a Message Box notification when complete ---
'If Err.Number > 0 Then
'' MsgBox "Error: " & Err.Description, vbInformation
'Else
'  MsgBox "Upgrade(s) Complete.", vbInformation
'End If