18!:55 <'Errors'
18!:4 <'Errors'
(copath<'base')copath<'Errors'
('Errors';copath<'base')copath<'base'

NB.-----------------------------------------------------------------------------
NB.  Errors and warnings
NB.-----------------------------------------------------------------------------
NB.  creates a matrix of error, warning and info
NB.-----------------------------------------------------------------------------

Join =: }.@:;@:(,&.>)

V2TabString =: TAB&Join

M2TabLfString =: LF&Join@:((<@V2TabString)"1)

Return =: 0 0$0

ClearCurrentObject =: 3 : 0
	OBJECT_TYPE =: OBJECT_ID =: ''
	Return
)

ClearMessages =: 3 : 0
NB.	Object Type - Object Id - Info - Problem(3) - Action(3)
	ERRORS_EXIST =: 0
	Messages =: 0 9$<''
	ClearCurrentObject''
)

ClearMessages ''

AddMessage =: 3 : 0
	(3{::y.)AddMessage y.
:
	type =. x.
	message =. y.
	if. -. message e. Messages_base_ do.
		Messages_base_ =: Messages_base_ , message
smoutput type;message
	end.
	Return
)

GetCurrentObject =: 3 : 0
	old =. OBJECT_TYPE;OBJECT_ID
)

SetCurrentObject =: 4 : 0
	old =. OBJECT_TYPE;OBJECT_ID
	OBJECT_TYPE =: x.
	map =. y.
	if. 2 = #$map do.
		if. 2 = {:$map do.
			'names values' =. <"1|:map
			OBJECT_ID =: (names i. <'TextId') {:: values,<''
			if. ''-:OBJECT_ID do.
				Warn EW_WARNING_ID_MISSING , EW_ACTION_CONTINUE
			end.
			old
			return.
		end.
	end.
	InternalError EW_INTERNAL_INVALID_MAP
)

RestoreCurrentObject =: 3 : 0
	'OBJECT_TYPE OBJECT_ID' =: y.
	Return
)

ewcheckrx =: 3 : 0
	if. -. (0 {:: ,y.)e.0 1 2 do.
		message =. M2TabLfString ":&.>ExceptionInformation 1 {:: y.
		message InternalError EW_INTERNAL_JCE_EXCEPTIONS
	end.
	>@{.^:(3=#y.)2}.,y.
)

InternalError =: 3 : 0
	'' InternalError y.
:
	extraInfo =. x.
	error =. y.
	'Internal Error' AddMessage OBJECT_TYPE ; OBJECT_ID ; extraInfo ; error , EW_ACTION_ABORT
	ERRORS_EXIST =: 1
	'INTERNAL ERROR - execution aborted' 13!:8 [ 18
)
	

Stop =: 3 : 0
	lx =. 13!:14''
	lxx =. lx #~ >: lx = ''''
	dblxs '(0 0$0) [ dblxs ''',lxx,''' [ dbr 1+0=9!:30'''''
	y. 13!:8[ 18
)

Error =: 3 : 0
	'' Error y.
:
	extraInfo =. x.
	error =. y.
	'Error' AddMessage OBJECT_TYPE ; OBJECT_ID ; extraInfo ; error , EW_ACTION_STOP
	ERRORS_EXIST =: 1
	Stop 'ERROR - execution stopped'
)

SetErrorTrap =: 3 : 0
	if. 0 ~: ERRORLOGGING_ErrorLog_ do.
		if. _1 = 4!:0 < 'LATENT_EXPRESSION_Errors_' do.
			LATENT_EXPRESSION_Errors_ =: 13!:14 ''
		end.
		13!:15 'ErrorTrap_Errors_ '''''
	end.
	Return
)

RestoreErrorTrap =: 3 : 0
	13!:15 LATENT_EXPRESSION_Errors_
	Return
)

ErrorTrap =: 3 : 0
	13!:15 LATENT_EXPRESSION_Errors_
	em =. 13!:12''
	(em,M2TabLfString ,.<"1 ] 4 }. 13!:18'')InternalError EW_INTERNAL_EXCEPTION
	Return
)

SetErrorTrap ''

Warn =: 3 : 0
	'' Warn y.
:
	extraInfo =. x.
	warning_action =. y.
	'Warning' AddMessage OBJECT_TYPE ; OBJECT_ID ; extraInfo ; warning_action
	Return
)

INFO_ON =: 0

Info =: 3 : 0
	'' Info y.
:
	if. INFO_ON do.
		extraInfo =. x.
		info =. y.
		'Info' AddMessage OBJECT_TYPE ; OBJECT_ID ; extraInfo ; info , EW_ACTION_CONTINUE
		Return
	end.
)

GetMessageXml =: 3 : 0
	xml =. ''
	for_message. Messages do.
		'objtype objid extra msgtype msgid msgdesc acttype actid actdesc' =. message
		msgxml =. MESSAGE_XML ParmSubString 'objectType';objtype;'objectId';objid;'extra';extra;'messageType';msgtype;'messageId';msgid;'messageDescription';msgdesc;'actionType';acttype;'actionId';actid;'actionDescription';actdesc
		xml =. xml , msgxml
	end.
	}.xml
)

MESSAGE_XML =: 0 : 0
<message>
	<objectType>%objectType%</objectType>
	<objectId>%objectId%</objectId>
	<extraInfo>
		<![CDATA[%extra%]]> 
	</extraInfo>
	<%messageType%>
		<id>%messageId%</id>
		<description>%messageDescription%</description>
	</%messageType%>
	<%actionType%>
		<id>%actionId%</id>
		<description>%actionDescription%</description>
	</%actionType%>
</message>
)

NB. Internal Errors

EW_INTERNAL_JCE_EXCEPTIONS		=:'ERROR';'1000';'JCE exceptions returned'
EW_INTERNAL_INVALID_MAP			=:'ERROR';'1001';'Internal map has invalid structure'
EW_INTERNAL_EXCEPTION			=:'ERROR';'1002';'An internal error has occured'


NB. Errors

EW_ERROR_NO_ELIST				=:'ERROR'	;'2001';'No ContributionDimensionId specified'
EW_ERROR_ELIST_NOT_DEFINED		=:'ERROR'	;'2002';'Specified contribution dimension not defined'
EW_ERROR_NO_IMPORT_CUBES		=:'ERROR'	;'2003';'There are no measures or contributions that vary by the contribution dimension'
EW_ERROR_NO_CONTRIBUTION_CUBES	=:'ERROR'	;'2004';'There are no contributions'
EW_ERROR_CONT_MULTIELISTLEVEL	=:'ERROR'	;'2005';'All contribution must be at the same level on the contribution dimension'
EW_ERROR_TEST_FAILED_LEVELS		=:'ERROR'	;'3041';'Wrong dimensionality'
EW_ERROR_NO_ELIST_CONTRIBUTION	=:'ERROR'	;'3042';'There are no contributions that vary by the contribution dimension'

NB. Warnings

EW_WARNING_UUID_MISSING			=:'WARNING'	;'3000';'UUID is missing'
EW_WARNING_ID_MISSING			=:'WARNING' ;'3001';'TextId is missing'
EW_WARNING_CAPTION_MISSING		=:'WARNING' ;'3002';'Caption is missing'
EW_WARNING_INVALID_DATES		=:'WARNING'	;'3003';'Invalid dates'
EW_WARNING_INVALID_TYPE			=:'WARNING'	;'3004';'Invalid data-type'
EW_WARNING_REFERENCE_NOT_FOUND	=:'WARNING'	;'3005';'Reference dimension level not defined'
EW_WARNING_AGG_TYPES			=:'WARNING'	;'3006';'Aggregation type not supported'
EW_WARNING_MISSING_COLUMNS		=:'WARNING' ;'3007';'Columns missing from data table'
EW_WARNING_DUPLICATE_COLUMNS	=:'WARNING'	;'3008';'Duplicate columns in table'
EW_WARNING_NO_TABLE_COLUMNS		=:'WARNING'	;'3009';'No columns in table'
EW_WARNING_GAPS_IN_LEVELS		=:'WARNING'	;'3010';'Level numbers of dimension are not contiguous'
EW_WARNING_ORPHAN_LEVELS		=:'WARNING'	;'3011';'Levels with no key columns'
EW_WARNING_NO_TABLE_DATA		=:'WARNING'	;'3012';'No Data section'
EW_WARNING_NO_TABLE_ROWS		=:'WARNING'	;'3012';'No rows in table'
EW_WARNING_REFDIMKEY_NOT_ALLOWED=:'WARNING'	;'3013';'Reference type not allowed in dimension keys'
EW_WARNING_NO_MEASURE_COLUMNS	=:'WARNING'	;'3014';'No measure data columns'
EW_WARNING_BAD_ROWS				=:'WARNING'	;'3015';'Data rows not matched to keys'
EW_WARNING_USERS_LEVEL_MISSING	=:'WARNING'	;'3016';'Level in user assignment table not found in contribution dimension'
EW_WARNING_NO_USERS				=:'WARNING'	;'3017';'No user assignment table'
EW_WARNING_USERS_INCOMPLETE_KEY	=:'WARNING'	;'3018';'Incomplete key information for users at level'
EW_WARNING_USERS_NO_CAMID		=:'WARNING'	;'3019';'No user column for users at level'
EW_WARNING_USERS_ITEMS_MISSING	=:'WARNING'	;'3020';'Items not found in contribution dimension'
EW_WARNING_ACCESS_NO_MEASURES	=:'WARNING'	;'3021';'No measures specified for access table' 
EW_WARNING_ACCESS_OVERLAP		=:'WARNING'	;'3022';'Measure dimensions in multiple access tables'
EW_WARNING_ACCESS_TOO_FINE		=:'WARNING'	;'3023';'Access specified over too many dimensions for measure'
EW_WARNING_ACCESS_EXCL_NOTIMPL	=:'WARNING'	;'3024';'Exclusion access not yet implemented'
EW_WARNING_PREVIOUS_MODEL_BAD	=:'WARNING'	;'3025';'Failed to read previous model definition, all previous data will be lost'
EW_WARNING_NO_ENDDATES			=:'WARNING'	;'3026';'No period end dates'
EW_WARNING_INVALID_CAPTIONS		=:'WARNING'	;'3027';'Invalid multi-lingual caption table'
EW_WARNING_AGG_TYPE_COUNT		=:'WARNING'	;'3028';'Aggregation "count" not supported'
EW_WARNING_AGG_TIME_MISMATCH	=:'WARNING' ;'3029';'Aggregation rule incompatible with specific time aggregation'
EW_WARNING_AGG_TIME_NOT_SUPP	=:'WARNING' ;'3030';'Time aggregation rule not supported'
EW_WARNING_NO_COLSOL_CURR		=:'WARNING'	;'3031';'No consolidation currency specified'
EW_WARNING_NO_LOCAL_CURR_ATT_ID	=:'WARNING'	;'3032';'No dimension attribute specified as local currency'
EW_WARNING_NO_LOCAL_CURR_ATT	=:'WARNING'	;'3033';'Dimension attribute specified as local currency specifier does not exist'
EW_WARNING_LOCAL_CURR_ATT_BAD	=:'WARNING'	;'3034';'Local currency attribute is not of currency type'
EW_WARNING_MULTIPLE_EXCH_RATES	=:'WARNING'	;'3035';'Multiple attributes in exchange rate table'
EW_WARNING_EXP_INVALID_CONSTANT	=:'WARNING'	;'3036';'Invalid constant in expression'
EW_WARNING_EXP_INVALID			=:'WARNING'	;'3037';'Invalid expression'
EW_WARNING_EXP_INVALID_CONTROL	=:'WARNING'	;'3038';'Invalid control structure in expression'
EW_WARNING_EXP_INVALID_OPERATOR	=:'WARNING'	;'3039';'Invalid operator position in expression'
EW_WARNING_GRID_LEVEL_ELIST		=:'WARNING' ;'3040';'Non-contribution level specified for eList in grid parameter'
EW_WARNING_GRID_CON_BAD_DIM		=:'WARNING' ;'3041';'Contribution item dimensionality incompatible with other contribution on this grid'
EW_WARNING_GRID_LEVEL_NON_CON	=:'WARNING'	;'3042';'Level does not conform to dimensionality of contribution on this grid'
EW_WARNING_MEASURE_ELIST_LEVEL	=:'WARNING'	;'3043';'Measure must be at the contribution grain on the contribution dimension'
EW_WARNING_MEASURE_NOT_FOUND	=:'WARNING'	;'3044';'Measure parameter not found'
EW_WARNING_GRID_NO_MEASURES		=:'WARNING'	;'3045';'Grid has no measures'
EW_WARNING_CURR_NO_CONSOL		=:'WARNING'	;'3046';'No consolidated currency specified'
EW_WARNING_CURR_NO_CURRS		=:'WARNING'	;'3047';'No currency table specified'
EW_WARNING_CURR_NO_EXCHANGE		=:'WARNING'	;'3048';'No exchange rates specified'
EW_WARNING_CURR_BAD_EXCHANGE	=:'WARNING'	;'3049';'Invalid exchange rate table'
EW_WARNING_CONTRIB_NO_ELIST		=:'WARNING'	;'3050';'Contribution does not vary by the contribution dimension'
EW_WARNING_INVALID_LEVEL_NUMBER	=:'WARNING'	;'3051';'Invalid level number'
EW_WARNING_MULTIKEY_LU_CON		=:'WARNING'	;'3052';'Contribution of look-up values from a composite-key dimension is not supported'
EW_WARNING_DUPLICATE_DIM_ITEMS	=:'WARNING'	;'3053';'Duplicate dimension items'
EW_WARNING_DIMENSION_NOT_FOUND	=:'WARNING'	;'3054';'Dimension parameter not found'
EW_WARNING_DIMENSION_PARM_ELIST	=:'WARNING'	;'3055';'The contribution dimension cannot be used as a dimension parameter to a derivation'


NB. Information

EW_DEBUG_CREATE_OBJECT			=:'DEBUG'	;'5000';'Creating JCE object'


NB. Actions

EW_ACTION_CONTINUE				=:'ACTION'	;'8000';'Continue'
EW_ACTION_STOP					=:'ACTION'	;'8001';'Execution stopped'
EW_ACTION_ABORT					=:'ACTION'	;'8002';'Execution aborted - see latest %TEMP%\JCE?.TMP for details'
EW_ACTION_IGNORE				=:'ACTION'	;'8003';'Ignored'
EW_ACTION_DIMENSION_IGNORED		=:'ACTION'	;'8004';'Dimension ignored'
EW_ACTION_NEW_UUID				=:'ACTION'	;'8005';'New UUID generated'
EW_ACTION_USE_ZERO_DATES		=:'ACTION'	;'8006';'Use zero - 1900-01-01'
EW_ACTION_USE_NUMBER			=:'ACTION'	;'8007';'Use plain numeric type'
EW_ACTION_USE_TEXT				=:'ACTION'	;'8008';'Use plain text type'
EW_ACTION_USE_SUM				=:'ACTION'	;'8009';'Use simple summation'
EW_ACTION_USE_EMPTY_STRINGS		=:'ACTION'	;'8010';'Use zero length strings'
EW_ACTION_USE_FIRST				=:'ACTION'	;'8011';'Use first occurences'
EW_ACTION_LEAVE_EMPTY			=:'ACTION'	;'8012';'Leave cube empty'
EW_ACTION_USE_PCU				=:'ACTION'	;'8013';'Use built in "Planning Contributor Users" group for all nodes'
EW_ACTION_USE_MODE				=:'ACTION'	;'8014';'Use most frequent period length for last period'
EW_ACTION_USE_ID				=:'ACTION'	;'8015';'Use text id'
EW_ACTION_USE_NO_AGG			=:'ACTION'	;'8016';'Use no aggregation'
EW_ACTION_USE_ZERO				=:'ACTION'	;'8017';'Use zero'
EW_ACTION_USE_CONTRIB_LEVEL		=:'ACTION'	;'8018';'Use level at which data is contributed'
EW_ACTION_GRID_CON_DEFERRED		=:'ACTION'	;'8019';'Contribution deferred'
EW_ACTION_GRID_LEVEL_CONFORMED	=:'ACTION'	;'8020';'Level of dimension conformed to contribution level'
EW_ACTION_PARAMETER_IGNORED		=:'ACTION'	;'8021';'Parameter ignored'
EW_ACTION_NO_MULTI_CURR			=:'ACTION'	;'8022';'Local currency data entry disabled'