cocurrent 'base'

WideStack_z_ =: 3 : 0
	truncate =. (101&<.@$ {.!.'.' ({.~100&<.@$))@":
	header =. ;:'Name Error Line Class Args Locals'
	stack =. 1 1 1 1 0 0 1 1 #"1 }. 13!:13''
	stack =. (,.@(truncate&.>)&.> 4 {"1 stack) 4 }"0 1 stack
	stack =. (truncate&.>&.> 5 {"1 stack) 5 }"0 1 stack
	header,stack
)

ShowLocals_z_ =: 3 : 0
	if. 0=#y. do.
		depth =. 1
	else.
		depth =. >:y.
	end.
	smoutput 0 {:: |. depth { 13!:13''
	0 0$0
)

TestBase =: 3 : 0
	Test '..\pcmapp'
:
	x. Test '..\pcmapp'
)

TestAll =: 3 : 0
	extension =. y.
	if. 0 = # extension do.
		extension =. 'txt'
	end.
	tests =. extension GetFiles '..\Tests'
	if. _1 = 4!:0 <'TestResults' do.
		TestResults =: 0 2$<''
	end.
	if. 0 = 4!:0 <'CurrentTest' do.
		TestResults =: TestResults , CurrentTest ; < Messages
		ClearMessages''
		4!:55 <'CurrentTest'
	end.
	tests =. tests #~ -. ({."1 tests) e. {."1 TestResults
	ClearMessages''
	for_test. tests do.
		'name spec' =. test
		CurrentTest =: name
smoutput 'Testing: ',name
		Test name
		TestResults =: TestResults , name ; < Messages
		4!:55 <'CurrentTest'
		ClearMessages''		
	end.
	results =. TestResults
	4!:55 <'TestResults'
	results
:
	4!:55 <'TestResults'
	4!:55 <'CurrentTest'
	ClearMessages''
	TestAll y.
)

Test =: 3 : 0
	1 Test y.
:
	(SCRIPT_PATH,'..\..\phoenix.xml') FileWrite~ (SCRIPT_PATH,'..\..\phoenix.xml') TransformModel&FileRead SCRIPT_PATH,'..\..\Tests\',y.,'.txt'
	if. 0 -: x. do.
		Return
		return.
	end.
	ClearModel''
	hModel =: ewcheckrx 0 Unpack FileRead SCRIPT_PATH,'..\..\phoenix.xml'
	hEList =: ewcheckrx hModel GetNodeList_IModelEdit_''
	vgEListItems =: ewcheckrx hEList GetAllColumn_ITableRead_ TABLE_ITEMGUID
	ewcheckrx hModel SetNodeGuids_IModelEdit_ 1{.vgEListItems
	ewcheckrx hModel Load_IModelEdit_ ''
	xml =: ewcheckrx Pack hModel
	Return
)

TransformModel =: 3 : 0
	'' TransformModel y.
:
	ResetJCE''
	LoadTemplates''
	ClearMessages''
	ClearRegistration''
	previousdefinition =. x.
	specification =. y.
	ExtractConsistencyInformationFromModel previousdefinition
	Specification =: MapFromString specification
	ReadDebugSettings''
	LoadCaptions''
	'Application'SetCurrentObject Specification
	ResetJCE''
	DetermineEListLevelNum''
	CreateModel''
	CreateBaseFormats''
	DetermineCurrencyConversion ''
	CreateObjects 'Currencies'
	CreateObjects L:0 'Dimension';'Timescale'
	IdentifyEList''
	CreateAttributeTables''
	CompleteCorrespondences''
	ImplementCurrencyConversion ''
	CreateObjects 'Access Table'
	CreateObjects 'Contribution'
	CreateObjects 'Measure'
	LoadDerivationTemplates''
	CreateDerivedCubesInSequence''
	CreateObjects'Grid'
	AddCubesToModel ''
	GetImportData''
	DeclarePublishCubes''
	SetModelEList''
	definition =. ewcheckrx Pack hModel
	CreateTranslations''
	definition
)

NB.-----------------------------------------------------------------------------
NB.  JCE Utils
NB.-----------------------------------------------------------------------------

ShowList =: 3 : 0
	list =. y.
	colnames =. ewcheckrx list GetAllColumnNames_ITableRead_ ''
	values =. ewcheckrx list GetTextAll_ITableRead_''
	W2U colnames,values
)

ShowCube =: 3 : 0
	cube =. y.
	ds =. ewcheckrx cube GetDatasetAll_ICube_ 0 0
	data =. W2U ewcheckrx ds GetTextAll_IArrayRead_ ARRAY_LINK_VALUE
	0 Release ds
	if. (2 = #$data) *. 0<#,data do.
		dims =. ewcheckrx cube GetDimensions_ICube_''
		'rows cols' =. dims GetColumn&.> <TABLE_ITEMCAPTION
		data =. ((W2U >GetObjectCaption cube);rows),"0 1 cols,data
	end.
	data
)

ClearModel =: 3 : 0
	ResetJCE''
	hModel =: 0
	ClearRegistration''
)

ReadDebugSettings =: 3 : 0
	if. Specification IsKey 'Debug'do.
		DEBUG_MODEL =: 'Yes' -: Specification GetValue 'Debug'
	else.
		if. _1 = 4!:0 <'DEBUG_MODEL' do.
			DEBUG_MODEL =: 0
		end.
	end.
)

ResetJCE =: 3 : 0
	JCEReset ''
	SetErrorTrap''
)

GetUUID =: 3 : 0
	try.
		uuid =. toupper '{', (y. GetValue 'UUID'),'}'
	catch.
		uuid =. CoCreateGuid 0
		uuid Warn EW_WARNING_UUID_MISSING , EW_ACTION_NEW_UUID
	end.
	uuid
)

CreateObjectCopy =: 3 : 0
	0 CreateObjectCopy y.
:
	hHolder =. x.
	hObj =. y.
	holding =. bx hObj e.&> HOLDERS_obj_
	hCopy =. hHolder CreateObject >GetObjectClass hObj
	ewcheckrx hCopy Unpack_IUnpack_ ewcheckrx hObj Pack_IPack_ ''
	HOLDERS_obj_ =: ((holding{HOLDERS_obj_)([,(-.~))&.>hCopy) holding } HOLDERS_obj_
	hCopy
)

CreateFreeObject =: 3 : 0
	obj =. 0 CreateObject y.
)

CreateNamedObject =: 4 : 0
	class =. x.
	select. L.y.
	case. 0 do.
		name =. textid =. y.
		uuid =. class GetObjectGuid name
	case. 1 do.
		select. #y.
		case. 3 do.
			'uuid textid suffix' =. y.
			name =. (GetShortName textid),ROLE_SUFFIX_MAX_LENGTH GetShortName suffix
		case. 2 do.
			'textid suffix' =. y.
			name =. (GetShortName textid),ROLE_SUFFIX_MAX_LENGTH GetShortName suffix
			uuid =. class GetObjectGuid name
		case. 1 do.
			textid =. >y.
			name =. GetShortName textid
			uuid =. class GetObjectGuid name
		end.
	end.
	caption =. GetBaseCaption textid
	'name caption' =. U2W name;caption
	hObj =. (0;name;uuid)CreateObject class
	(<caption) SetObjectCaption hObj
	ObjObjs =: ObjObjs , hObj
	ObjTextIds =: ObjTextIds , < textid
	hObj
)

ObjectName =: 3 : 0
	W2U > GetObjectName y.
)

GetAllocationTableColumnIds =: 3 : 0
NB. Returns the GUIDs of the Left, Right and Negate columns of an allocation table in that order
	hAllocTab =. y.
	allcolnames =. ewcheckrx hAllocTab GetAllColumnNames_ITableRead_''
	allcolids =. ewcheckrx hAllocTab GetAllColumnIds_ITableRead_''
	colids =. allcolids {~ allcolnames i. U2W ;: 'Left Right Negate'
	colids
)

GetAccessTableColumnIds =: 4 : 0
	hAccessTable =. x.
	vhDimensions =. y.
	allcolnames =. ewcheckrx hAccessTable GetAllColumnNames_ITableRead_ ''
	allcolids =. ewcheckrx hAccessTable GetAllColumnIds_ITableRead_ ''
	colids =. (allcolnames i. GetObjectName vhDimensions) { allcolids
	colids
)

FindInColumn =: 4 : 0
	hTable =. x.
	'values gColumn' =. y.
	if. gColumn -: TABLE_ITEMNAME do.
		values =. GetShortName values
	end.
	if. 'S' = {.; ewcheckrx hTable GetColumnTypes_ITableRead_ ,: gColumn do.
		values =. U2W values
	end.
	inds =. ewcheckrx hTable FindInColumn_ITableRead_ values ; < gColumn
)

PopulateList =: 4 : 0
	hTable =. x.
	'values gColumns' =. y.
	gColumns EnsureColumnInTable hTable
	if. TABLE_ITEMNAME e. gColumns do.
		index =. gColumns i. TABLE_ITEMNAME
		values =. (GetShortName index { values) index } values
	end.
	if. TABLE_ITEMCAPTION e. gColumns do.
		index =. gColumns i. TABLE_ITEMCAPTION
		values =. (TABLE_ITEMCAPTION_MAXIMUM_CHARACTERS_systemcolumn_ ((<.#){.])L:0 index { values) index } values
	end.
	widecolinds =. bx 'S'= {.&> ewcheckrx hTable GetColumnTypes_ITableRead_ gColumns
	values =. (U2W widecolinds { values) widecolinds } values
	ewcheckrx hTable Append_ITableEdit_ values;<gColumns
	Return
)

PopulateTimescale =: 4 : 0
	hTimescale =. x.
	'ids iids caps guids pinds starts lengths' =. y.

	TABLE_ITEMCAPTION EnsureColumnInTable hTimescale
	DLIST_CALCULATION EnsureColumnInTable hTimescale
	ewcheckrx hTimescale SetTimeScale_IDListEdit_ 'Specific'

	child =. pinds ~: i.# pinds
	parent =. (i.#pinds) e. child # pinds
	top =. -.child
	leaf =. -. parent

	'starts lengths' =. leaf *L:0 _1 starts;<lengths

	priority =. CALCPRIORITY_MEDIUM * parent
	calcs =. a: #~# guids
	if. +./ parent do.
		children =. (child#pinds) </. bx child
		calcs =. ('I:',L:0 (,&.>children{L:0 guids),L:0 ';F:sum') (~.child#pinds) } calcs
		topdown =. ; (]`(](,;)&.>$:&.>@({&(children(~.pinds)}a:#~#pinds)))@.(*@#)) bx top NB. from the top recursively append children to their parents
		calcsequence =. leaf -~ /:&.((-.leaf)&#)\:topdown
	else.
		calcsequence =. -leaf
	end.

	values =. ids;iids;caps;guids;starts;lengths;calcs;priority;<calcsequence
	colids =. TABLE_ITEMNAME,TABLE_ITEMID,TABLE_ITEMCAPTION,TABLE_ITEMGUID,DLIST_TIME_START,DLIST_TIME_LENGTH,DLIST_CALCULATION,DLIST_CALCPRIORITY,:DLIST_CALCSEQUENCE
	hTimescale PopulateList values;<colids

	if. +./parent do.
		ewcheckrx hTimescale Reorder_ITableEdit_ topdown
	end.

	Return
)

PopulateHierarchy =: 4 : 0
	hHierarchy =. x.
	'guids ids caps pguids iids' =. y.
	ewcheckrx hHierarchy Import_IHierarchyEdit_ guids;(U2W ids);pguids;<iids
	TABLE_ITEMCAPTION EnsureColumnInTable hHierarchy
	inds =. hHierarchy FindInColumn iids;<TABLE_ITEMID
	ewcheckrx hHierarchy SetText_ITableEdit_ (,.U2W caps);inds;,:TABLE_ITEMCAPTION
	Return
)

GetColumn =: 4 : 0
	hTable =. x.
	gColumn =. y.
	values =. ewcheckrx hTable GetAllColumn_ITableRead_ gColumn
	if. 'S' = {.; ewcheckrx hTable GetColumnTypes_ITableRead_ ,: gColumn do.
		values =. W2U values
	end.
	values
)

EnsureColumnInTable =: 4 : 0
	gColumn =. x.
	hTable =. y.
	ewcheckrx hTable SetSystemColumnGuids_ITableColumns_ ~.gColumn,~ewcheckrx hTable GetSystemColumnGuids_ITableColumns_ ''
)

ItemNamesFromIndices =: 4 : 0
	list =. x.
	inds =. y.
	if. 0 = list do.
		names =. 0#<''
	else.
		names =. inds { list GetColumn TABLE_ITEMNAME
	end.
	names
)

ItemIdsFromNames =: 4 : 0
	hTab =. x.
	names =. y.
	names =. GetShortName names
	inds =. hTab FindInColumn names;TABLE_ITEMNAME
	iids =. inds { hTab GetColumn TABLE_ITEMID
	iids
)

ItemGuidsFromIds =: 4 : 0
	hTab =. x.
	iids =. y.
	inds =. hTab FindInColumn iids;TABLE_ITEMID
	guids =. inds { hTab GetColumn TABLE_ITEMGUID
	guids
)

ItemGuidsFromNames =: 4 : 0
	hTab =. x.
	names =. y.
	names =. GetShortName names
	inds =. hTab FindInColumn names;TABLE_ITEMNAME
	guids =. inds { hTab GetColumn TABLE_ITEMGUID
	guids
)

ItemFormatsFromNames =: 4 : 0
	hTab =. x.
	names =. y.
	if. TABLE_ITEMFORMAT e. ewcheckrx hTab GetAllColumnIds_ITableRead_ '' do.
		names =. GetShortName names
		inds =. hTab FindInColumn names;TABLE_ITEMNAME
		formats =. inds { hTab GetColumn TABLE_ITEMFORMAT
	else.
		formats =. 0 $~$ names
	end.
	formats
)

ReplaceItemCaptions =: 4 : 0
	hList =. x.
	'names captions' =. y.

	if. hList e. MeasureItemLists do.
		lv =. MeasureItemLists = hList
		measurenames =. lv # MeasureItemNames
		measureids =. (lv # MeasureItemMeasures){ MeasureIds
		inds =. names Find measureids
		lv =. inds ~: _1
		names =. lv # measurenames
		captions =. (lv#inds) { captions
	end.

	if. 0 < # names do.
		ids =. hList GetColumn TABLE_ITEMNAME
		capinds =. (GetShortName names) Find ids
		transitems =. bx capinds ~: _1
		if. 0 < # transitems do.
			transcaps =. (transitems { capinds) { captions
			ewcheckrx hList Set_ITableEdit_ (,<U2W transcaps);transitems;<,:TABLE_ITEMCAPTION
		end.
	end.
	Return
)

GetCubeAsText =: 3 : 0
	cube =. y.
	ds =. ewcheckrx cube GetDatasetAll_ICube_ 0 0
	data =. W2U ewcheckrx ds GetTextAll_IArrayRead_ ARRAY_LINK_VALUE
	0 Release ds
	data
)

GetCubeAsNumber =: 3 : 0
	cube =. y.
	ds =. ewcheckrx cube GetDatasetAll_ICube_ 0 0
	data =. ewcheckrx ds GetAll_IArrayRead_ ARRAY_LINK_VALUE
	0 Release ds
	data
)

ConvertDates =: 3 : 0
	0 ConvertDates y.
:
	baddatevalue =. x.
	strings =. y.
	'lv dates' =. ewcheckrx hDefaultDateFormat ValidateStrictly_IFormat_ (,'F');<U2W strings
	if. +./-.lv do.
		(}.;TAB,&.>(-.lv)#strings)Warn EW_WARNING_INVALID_DATES , EW_ACTION_USE_ZERO_DATES
		dates =. baddatevalue (bx -.lv) } dates
	end.
	dates
)

CreateObjects =: 3 : 0
	old =. GetCurrentObject ''
	for_spec. Specification GetValues y. do.
		y. SetCurrentObject >spec
		('Create',y.-.' ')~ 0 {:: , spec
	end.
	RestoreCurrentObject old
	Return
)

NB.-----------------------------------------------------------------------------
NB.  Metadata information
NB.-----------------------------------------------------------------------------

CUBE_TYPE_NONE			=: 0
CUBE_TYPE_KEY			=: 1
CUBE_TYPE_ATTRIBUTE		=: 2
CUBE_TYPE_FACT			=: 3
CUBE_TYPE_CONTRIBUTION	=: 4
CUBE_TYPE_FORMULA		=: 5
CUBE_TYPE_DERIVATION	=: 6
CUBE_TYPE_TEMPLATE		=: 7
CUBE_TYPE_GRID			=: 8
CUBE_TYPE_XRATE			=: 9

MEASURE_TYPE_INVALID	=: _1
MEASURE_TYPE_NONE		=: 0
MEASURE_TYPE_TEXT		=: 1
MEASURE_TYPE_REFERENCE	=: 2
MEASURE_TYPE_DATE		=: 3
MEASURE_TYPE_NUMBER		=: 4
MEASURE_TYPE_PERCENTAGE	=: 5
MEASURE_TYPE_MONETARY	=: 6
MEASURE_TYPE_COUNT		=: 7
MEASURE_TYPE_XRATE		=: 8
MEASURE_TYPE_LOCAL		=: 9
MEASURE_TYPE_GROUP		=: 10
MEASURE_TYPE_PUBKEY		=: 11
MEASURE_TYPE_LOOKUP		=: 12

MeasureTypeFromText =: 3 : 0
	select. <y.
	case. ''			do. MEASURE_TYPE_NONE
	case. 'Text'		do. MEASURE_TYPE_TEXT
	case. 'Reference'	do. MEASURE_TYPE_REFERENCE
	case. 'Date'		do. MEASURE_TYPE_DATE
	case. 'Number'		do. MEASURE_TYPE_NUMBER
	case. 'Percentage'	do. MEASURE_TYPE_PERCENTAGE
	case. 'Percent'		do. MEASURE_TYPE_PERCENTAGE
	case. 'Monetary'	do. MEASURE_TYPE_MONETARY
	case. 'Count'		do. MEASURE_TYPE_COUNT
	case.				do. MEASURE_TYPE_INVALID
	end.
)

MeasureTypeName =: 3 : 0
	select. y.
	case. MEASURE_TYPE_INVALID		do. 'Invalid'
	case. MEASURE_TYPE_NONE			do. ''
	case. MEASURE_TYPE_TEXT			do. 'Text'
	case. MEASURE_TYPE_REFERENCE	do. 'Reference'
	case. MEASURE_TYPE_DATE			do. 'Date'
	case. MEASURE_TYPE_NUMBER		do. 'Number'
	case. MEASURE_TYPE_PERCENTAGE	do. 'Percentage'
	case. MEASURE_TYPE_MONETARY		do. 'Monetary'
	case. MEASURE_TYPE_COUNT		do. 'Count'
	case. MEASURE_TYPE_XRATE		do. 'X-rate'
	case. MEASURE_TYPE_LOCAL		do. 'Local'
	case. MEASURE_TYPE_GROUP		do. 'Group'
	case.							do. InternalError EW_INTERNAL_EXCEPTION
	end.
)

ROLE_NONE				=: 0
ROLE_IMPORT				=: 1
ROLE_ATTRIBUTE			=: 2
ROLE_PUBLISH			=: 3
ROLE_PUBLISHLOCAL		=: 4
ROLE_PUBLISHGROUP		=: 5
ROLE_PUBLISHCURRENCY	=: 6
ROLE_XRATESOURCE		=: 7
ROLE_CALCINPUT			=: 8
ROLE_CALCINPUTXRATE	 	=: 9
ROLE_DATAENTRY			=: 10
ROLE_DATAENTRYLOCAL		=: 11
ROLE_DATAENTRYGROUP		=: 12
ROLE_DISPLAY			=: 13
ROLE_FORMULA			=: 14
ROLE_DERIVATION			=: 15
ROLE_PUBLISHLOOKUP		=: 16
ROLE_PUBLISHDIMKEY		=: 17
ROLE_DATAENTRYLOOKUP	=: 18

RoleName =: 3 : 0
	select. y.
	case. ROLE_NONE				do. 'none'
	case. ROLE_IMPORT			do. 'import'
	case. ROLE_ATTRIBUTE		do. 'attribute'
	case. ROLE_PUBLISH			do. 'publish'
	case. ROLE_PUBLISHLOCAL		do. 'publish local'
	case. ROLE_PUBLISHGROUP		do. 'publish group'
	case. ROLE_PUBLISHCURRENCY	do. 'publish currency'
	case. ROLE_XRATESOURCE		do. 'x-rate source'
	case. ROLE_CALCINPUT		do. 'calc input'
	case. ROLE_CALCINPUTXRATE	do. 'calc input x-rate'
	case. ROLE_DATAENTRY		do. 'data entry'
	case. ROLE_DATAENTRYLOCAL	do. 'data entry local'
	case. ROLE_DATAENTRYGROUP	do. 'data entry group'
	case. ROLE_DISPLAY			do. 'display'
	case. ROLE_FORMULA			do. 'formula'
	case. ROLE_DERIVATION		do. 'derivation'
	case. ROLE_PUBLISHLOOKUP	do. 'publish lookup'
	case. ROLE_PUBLISHDIMKEY	do. 'publish dim key'
	case. ROLE_DATAENTRYLOOKUP	do. 'data entry lookup'
	case. do. 'INVALID ROLE'
	end.
)

ClearRegistration =: 3 : 0
	integer =. boolean =. object =. index =. enum =. ,0
	integerlist =. indexlist =. enumlist =. ,<0#0
	string =. ,<''
	stringlist =. ,<0#<''
	stringmatrix =. ,<0 0$<''
	integer2rowmatrix =. ,<2 0$0
	indexpair =. 1 2$0
	guid =. ,:NULL_GUID
	box =. ,<''

	ObjObjs =: object
	ObjTextIds =: string

	DimensionIds =: string
	DimensionKeyLists =: object
	DimensionLevels =: indexlist
	DimensionIsTimescale =: boolean

	LevelIds =: string
	LevelDims =: index
	LevelNums =: integer
	LevelFormats =: object
	LevelItemLists =: object
	LevelAttLists =: object
	LevelAggLists =: object
	LevelNonAggLists =: object
	LevelKeyCubes =: object
	LevelAttCubes =: object

	CorrespondenceFromTo =: indexpair
	CorrespondenceTables =: integer2rowmatrix
	CorrespondenceDistances =: integer

	CubeIds	=: string
	CubeCubes =: object
	CubeTypes =: enum
	CubeLevels =: indexlist
	CubeMeasures =: indexlist
	CubeMeasureLists =: object

	MeasureIds =: string
	MeasureCaptions =: string
	MeasureCubes =: index
	MeasureTypes =: enum
	MeasureRoles =: enum
	MeasureGuids =: guid
	MeasureAggregates =: boolean
	MeasureFormats =: object
	MeasureAdjustments =: string

	MeasureItemMeasures =: index
	MeasureItemNames =: string
	MeasureItemLists =: object
	MeasureItemGuids =: guid
	MeasureItemRoles =: enum

	MaskNames =: string
	MaskCaptions =: string
	MaskDimensions =: indexlist
	MaskItems =: stringmatrix
	MaskCubeIds =: stringlist
	MaskTypes =: stringlist

	GridViews =: object
	GridCubes =: index
	GridContributions =: indexlist

	UserGuids =: guid
	UserCAMIDs =: string
	UserCaptions =: string

	LocaleIds =: string
	LocaleNames =: string
	LocaleGUIDs =: guid
	LocaleProductLocales =: string
	LocaleTranslations =: string
	LocaleProductStrings =: string
	LocaleLCIDs	=: integer

	CaptionTextIds =: string
	CaptionLocales =: index
	CaptionCaptions =: string

	ItemLevels =: index
	ItemLocales =: index
	ItemIds =: string
	ItemCaptions =: string

	XrateTimescales =: index
	XrateRatecubes =: object

	Return
)

PopulateCulturesAndCompLangs =: 3 : 0
	cultures =. MapFromFile '..\cultures.txt'
	CultureIds =: (<''),GetKeys cultures
	cultures =. 1{::"0 1 cultures
	CultureLCIDs =: 0,(256&#.)@(a.&i.)@fromhex_xml_@tolower@(2&}.)&> {."1 cultures
	CultureNames =: (<''),1{"1 cultures
	compstrings =. 'aox' GetFiles '..'
	CompLangIds =: (#'basestrings_')&}.@tolower&.>{."1 compstrings
	CompLangStrings =: {:"1 compstrings
)

PopulateCulturesAndCompLangs ''

PopulateCurrencies =: 3 : 0
	currencies =. MapFromTableFile 'currencies.txt'
	'CurrencyCodes CurrencySymbols CurrencyFormats CurrencyNames CurrencyDecimals' =: currencies GetValue ;:'Code Symbol Format Name Decimals'
)

PopulateCurrencies ''

ShowDimensions =: 3 : 0
	smoutput ('Index';'Id';'Timescale';'Key List';'Levels'),}.(<"0 i.#DimensionIds),.DimensionIds,.(DimensionIsTimescale{;:'No Yes'),.DimensionKeyLists;"0 >&.>DimensionLevels{L:0 _ LevelIds
)

ShowLevels =: 3 : 0
	smoutput ('Index';'Id';'Dim';'Num';'Format';'Item List';'Agg List';'Non-agg List';'Key Cube';'Att Cube'),}.(<"0 i.#LevelIds),.LevelIds,.(LevelDims{DimensionIds),.<"0 LevelNums,.LevelFormats,.LevelItemLists,.LevelAggLists,.LevelNonAggLists,.LevelKeyCubes,.LevelAttCubes
)

ShowCubes =: 3 : 0
	smoutput ('Index';'Id';'Cube';'Cube Name';'Levels';'Measures';'Type'),}.(<"0 i.#CubeCubes),.CubeIds,.(<"0 CubeCubes),.(W2U GetObjectName CubeCubes),.(>&.>CubeLevels{L:0 _ LevelIds),.(>&.>CubeMeasures{L:0 _ MeasureIds),.CubeTypes{;:'None Key Attribute Fact Contribution Formula Derivation Template Grid XRates'
)

ShowMeasures =: 3 : 0
	smoutput ('Index';'Id';'Caption';'Type';'Cube';'Guid';'Aggregates';'Adjustment';'Format'),}.(<"0 i.#MeasureIds),.MeasureIds,.MeasureCaptions,.(MeasureTypeName&.> MeasureTypes),.(MeasureCubes{W2U GetObjectName CubeCubes),.(<"1 MeasureGuids),.(MeasureAggregates{'No';'Yes'),.MeasureAdjustments,.<"0 MeasureFormats
)

ShowMeasureItems =: 3 : 0
	smoutput ('Measure';'Name';'List';'Guid';'Role'),}.(<"0 MeasureItemMeasures),.MeasureItemNames,.(<"0 MeasureItemLists),.(<"1 MeasureItemGuids),.RoleName &.> MeasureItemRoles
)

ShowMasks =: 3 : 0
	smoutput ('Index';'Id';'Caption';'Dimensions';'Cubes';'Types';'Items'),}.(<"0 i.#MaskNames),.MaskNames,.MaskCaptions,.(>&.>MaskDimensions{L:0 _ DimensionIds),.(>&.>MaskCubeIds),.MaskTypes,.MaskItems
)

ShowCorrespondences =: 3 : 0
	smoutput ('From/To';'Table';'Distance'),}.(<"1 CorrespondenceFromTo { LevelIds),.CorrespondenceTables;"0 CorrespondenceDistances
)

ShowLocales =: 3 : 0
	smoutput ('Index';'Id';'ProductLocale';'LCID';'Translation Length';'Product Strings Length'),}.(<"0 i.#LocaleIds),.LocaleIds,.LocaleProductLocales,.<"0 LocaleLCIDs,.#&>LocaleTranslations,.LocaleProductStrings
)

ShowCultures =: 3 : 0
	smoutput ('Id';'Name';'LCID'),}.CultureIds,.CultureNames;&>CultureLCIDs
)

ShowCompLangs =: 3 : 0
	smoutput ('Id';'Strings Length'),CompLangIds;&>#&>CompLangStrings
)

ShowCaptions =: 3 : 0
	smoutput ('TextId';'Locale';'Caption'),}.CaptionTextIds,.(CaptionLocales{LocaleIds),.CaptionCaptions
)

ShowItems =: 3 : 0
	smoutput ('Level';'Locale';'Item';'Caption'),}.(ItemLevels{LevelIds),.(ItemLocales{LocaleIds),.ItemIds,.ItemCaptions
)

ShowAll =: 3 : 0
	ShowDimensions''
	ShowLevels''
	ShowCubes''
	ShowMeasures''
	Return
)

ShowLinks =: 3 : 0
	for_cube. }.CubeCubes do.
		smoutput ''
		smoutput ; W2U GetObjectName cube
		links =. ewcheckrx cube GetUpdateLinks_IDCubeEdit_''
		if. 0 = #links do.
			smoutput IndentString 'no links'
		else.
			for_link. links do.
				src =. ewcheckrx link GetSource_IDLinkEdit_''
				corrs =. ewcheckrx link GetCorrespondences_IDLinkEdit_ ''
				classes =. GetObjectClass corrs
				srcdims =. {.@(1&{.)&>ewcheckrx corrs GetSourceDimensions_ICorrespondence_ <''
				tgtdims =. {.@(1&{.)&>ewcheckrx corrs GetTargetDimensions_ICorrespondence_ <''
				'srcinds tgtinds' =. ,L:0 }: ewcheckrx corrs Resolve_ICorrespondence_ 0 0
				srcnames =. srcdims >@ItemNamesFromIndices&.> srcinds
				tgtnames =. tgtdims >@ItemNamesFromIndices&.> tgtinds
				smoutput ('';classes),.(W2U GetObjectName src,srcdims),.(W2U GetObjectName cube,tgtdims),.(<''),srcnames,.tgtnames
NB.				smoutput (link,corrs);"0 1('';classes),.(src,srcdims);"0 1 (W2U GetObjectName src,srcdims),.(cube,tgtdims);"0 1 (W2U GetObjectName cube,tgtdims),.(<''),srcnames,.tgtnames
			end.
		end.
	end.
	Return
)

FindOrZero =: #@[ | i.

RegisterDimensionLevels =: 4 : 0
	'dimid timescale keylist' =. x.
	'ids nums formats itemlists attlists agglists nonagglists keycubes attcubes' =. y.

	levelinds =. (#LevelIds) + i.#ids

	dimind =. #DimensionIds
	DimensionIds =: DimensionIds , <dimid
	DimensionKeyLists =: DimensionKeyLists , keylist
	DimensionLevels =: DimensionLevels , < levelinds /: nums
	DimensionIsTimescale =: DimensionIsTimescale , timescale

	LevelIds =: LevelIds , ids
	LevelDims =: LevelDims , dimind #~# ids
	LevelNums =: LevelNums , nums
	LevelFormats =: LevelFormats , formats
	LevelItemLists =: LevelItemLists , itemlists
	LevelAttLists =: LevelAttLists , attlists
	LevelAggLists =: LevelAggLists , agglists
	LevelNonAggLists =: LevelNonAggLists , nonagglists
	LevelKeyCubes =: LevelKeyCubes , keycubes
	LevelAttCubes =: LevelAttCubes , attcubes

	levelinds
)

RegisterCubeMeasures =: 4 : 0
	'id type cube measurelist levels' =. x.
	'ids captions types roles guids aggregates formats adjustments'  =. y.
	if. 0 = #$roles do.
		roles =. roles #~# ids
	end.

	measureinds =. (#MeasureCubes) + i.#ids

	cubeind =. # CubeCubes
	CubeIds =: CubeIds , <id
	CubeCubes =: CubeCubes , cube
	CubeTypes =: CubeTypes , type
	CubeLevels =: CubeLevels , <levels
	CubeMeasures =: CubeMeasures , < measureinds
	CubeMeasureLists =: CubeMeasureLists , measurelist

	MeasureCubes =: MeasureCubes , cubeind#~#ids
	MeasureIds =: MeasureIds , ids
	MeasureCaptions =: MeasureCaptions , captions
	MeasureTypes =: MeasureTypes , types
	MeasureRoles =: MeasureRoles , roles
	MeasureGuids =: MeasureGuids , guids
	MeasureAggregates =: MeasureAggregates , aggregates
	MeasureFormats =: MeasureFormats , formats
	MeasureAdjustments =: MeasureAdjustments , adjustments

	cubeind
)

RegisterMask =: 3 : 0
	'name caption dims items cubeids types' =. y.
	MaskNames =: MaskNames , < name
	MaskCaptions =: MaskCaptions , < caption
	MaskDimensions =: MaskDimensions , < dims
	MaskItems =: MaskItems , < items
	MaskCubeIds =: MaskCubeIds , < cubeids
	MaskTypes =: MaskTypes , < types
	Return
)

RegisterCubes =: 4 : 0
	type =. x.
	'cubes measurelists' =. y.
	CubeIds =: CubeIds , (#cubes) # <''
	CubeCubes =: CubeCubes , cubes
	CubeTypes =: CubeTypes , (#cubes) # type
	CubeLevels =: CubeLevels , (#cubes) # <0#0
	CubeMeasures =: CubeMeasures , (#cubes) # <0#0
	CubeMeasureLists =: CubeMeasureLists , measurelists
	Return
)

RegisterCorrespondence =: 3 : 0
	'fromto table distance' =. y.
	CorrespondenceFromTo =: CorrespondenceFromTo , fromto
	CorrespondenceTables =: CorrespondenceTables , <table
	CorrespondenceDistances =: CorrespondenceDistances , distance
	Return
)

RegisterUsers =: 3 : 0
	'guids camids captions' =. y.
	UserGuids =: UserGuids , guids
	UserCAMIDs =: UserCAMIDs , camids
	UserCaptions =: UserCaptions , captions
	Return
)

RegisterGrid =: 4 : 0
	'id cube list view' =. x.
	'levels contributions' =. y.
	gridind =. #GridCubes
	GridCubes =: GridCubes , # CubeCubes
	GridViews =: GridViews , view
	GridContributions =: GridContributions , < contributions

	CubeIds =: CubeIds , <id
	CubeCubes =: CubeCubes , cube
	CubeTypes =: CubeTypes , CUBE_TYPE_GRID
	CubeLevels =: CubeLevels , <levels
	CubeMeasures =: CubeMeasures , <0#0
	CubeMeasureLists =: CubeMeasureLists , list
	gridind
)

CleanLocaleName =: 3 : 0
	locale =. y.
	locale =. (tolower 2{.locale),toupper 2}. locale
	if. locale -: 'en' do.
		locale =. 'en-US'
	end.	
	if. 2 = # locale do.
		if. (<locale,'-',toupper locale) e. CultureIds do.
			locale =. locale,'-',toupper locale
		else.
			if. (<locale) e. 2{.&.>CultureIds do.
				locale =. CultureIds {::~ (2{.&.>CultureIds) i: <locale
			end.
		end.
	end.
	locale
)

RegisterLocale =: 3 : 0
	'' RegisterLocale y.
:
	locale =. y.
	prodloc =. x.

	if. (<locale) e. LocaleIds do.
		Return
		return.
	end.

	locale =. CleanLocaleName locale

	if. (<locale) e. LocaleIds do.
		Return
		return.
	end.

	if. '' -: prodloc do.
		prodloc =. locale
	end.

	prodloc =. tolower 2{. prodloc

	if. -. (<prodloc) e. }. CompLangIds do.
		prodloc =. GetInstallationLanguage ''
	end.

	LocaleIds =: LocaleIds , <locale
	LocaleProductLocales =: LocaleProductLocales , <prodloc
	LocaleTranslations =: LocaleTranslations , <''
	LocaleProductStrings =: LocaleProductStrings , CompLangStrings {~ CompLangIds FindOrZero <prodloc
	LocaleLCIDs =: LocaleLCIDs , CultureLCIDs {~ CultureIds FindOrZero <locale
	LocaleNames =: LocaleNames , CultureNames {~ CultureIds FindOrZero <locale
	LocaleGUIDs =: LocaleGUIDs , CoCreateGuid 0
)

RegisterLocales =: RegisterLocale L:0

RegisterItemCaptions =: 4 : 0
	level =. x.
	'locales ids captions' =. y.
	ItemLevels =: ItemLevels , (#,captions) # level
	ItemLocales =: ItemLocales , (#ids) # locales
	ItemIds =: ItemIds , ; (#locales) # < ids
	ItemCaptions =: ItemCaptions , , captions
)

RegisterMeasureItems =: 4 : 0
	list =. x.
	'measures names roles guids' =. y.
	MeasureItemMeasures =: MeasureItemMeasures , measures
	MeasureItemNames =: MeasureItemNames , names
	MeasureItemRoles =: MeasureItemRoles , roles
	MeasureItemLists =: MeasureItemLists , list #~# measures
	MeasureItemGuids =: MeasureItemGuids , guids
)

FindOrAddLocale =: 3 : 0
	locales =. CleanLocaleName L:0 boxopen y.
	RegisterLocales ~. locales
	LocaleIds i. locales
)

AreMeasuresContributed =: 3 : 0
	y. e. ; GridContributions
)

FindDimensions =: 3 : 0
	if. 0 = # y. do.
		0#0
	else.
		DimensionIds FindOrZero boxopen y.
	end.
)

GetDimensionBaseLevel =: 3 : 0
	dimensioninds =. y.
	levels =. (,dimensioninds) { DimensionLevels
	maxlevels =. ((i.(>./))L:0 levels {L:0 LevelNums) {&> levels
	maxlevels $~$ y.
)

NB. monadic - from levelid
NB. dyadic  - from levelnum and dimid
FindLevels =: 3 : 0
	inds =. LevelIds FindOrZero boxopen y.
:
	inds =. (LevelNums,.LevelDims) FindOrZero x.,.FindDimensions y.
)

FindCubes =: 3 : 0
	inds =. CubeIds FindOrZero boxopen y.
)

GetCubeMeasureList =: 3 : 0
	hCube =. y.
	CubeMeasureLists {~ CubeCubes FindOrZero hCube
)

FindMeasures =: 3 : 0
	inds =. MeasureIds FindOrZero boxopen y.
)

FindListLevels =: 3 : 0
	(#LevelIds) | (LevelItemLists,LevelAggLists,LevelNonAggLists) FindOrZero y.
)

FindLevelCorrespondences =: 4 : 0
	from =. x.
	to =. y.
	pairs =. >,{x.;y.
	if. 0 e. $ pairs do.
		(0 2$0);<0#<2 0$0
		return.
	end.
	pairs =. pairs , |."1 pairs
	match =. bx CorrespondenceFromTo e. pairs
	match =. match /: match { CorrespondenceDistances
	fromto =. match { CorrespondenceFromTo
	reverse =. -. ({."1 fromto) e. from
	matchfrom =. reverse {"0 1 fromto
	inds =. matchfrom i. from #~ from e. matchfrom
	(inds { reverse |."0 1 fromto);<(inds{reverse) |.&.> (inds{match){CorrespondenceTables
)

CompleteCorrespondences =: 3 : 0
	whilst. anyadded do.
		anyadded =. 0
		'from to' =. <"1 |: CorrespondenceFromTo
		for_link. ~. to #~ (to e. from) *. to ~: from do.
			left =. bx to = link
			right =. bx from = link
			'left right' =. <"1 |: >,{left;right
			pairs =. (left { from) ,. right { to
			new =. -. pairs e. CorrespondenceFromTo
			for_newind. bx new do.
				leftind =. newind { left
				rightind =. newind { right
				lefttable =. leftind {:: CorrespondenceTables
				righttable =. rightind {:: CorrespondenceTables
				newtable =. ({.lefttable),:(({.righttable)i.{:lefttable) { {:righttable
				newdistance =. +/(leftind,rightind) { CorrespondenceDistances
				RegisterCorrespondence (newind { pairs);newtable;newdistance
				anyadded =. 1
			end.
		end.
	end.
	Return
)

NB.-----------------------------------------------------------------------------
NB.  Application
NB.-----------------------------------------------------------------------------

CreateModel =: 3 : 0
	old =. 'Model'SetCurrentObject Specification
	'id caption' =. GetIdentity Specification
	hModel =: 'AdaytumModel' CreateNamedObject (GetUUID Specification);id;''
	RestoreCurrentObject old
	Return
)

CreateDefaultCubeView =: 3 : 0
	hCube =. y.
	hView =. CreateFreeObject 'AdaytumCubeView'
	ewcheckrx hView SetCube_ICubeView_ hCube
	hView
)

AddCubesToModel =: 3 : 0
	ewcheckrx (}.CubeCubes) SetAccessLevel_IDCubeEdit_ (CUBE_TYPE_GRID = }.CubeTypes){ ACCESS_HIDDEN,ACCESS_WRITE
	ewcheckrx hModel SetCubes_IModelEdit_ }.CubeCubes
	if. DEBUG_MODEL do.
		vhCubes =. }. CubeCubes #~ CubeTypes ~: CUBE_TYPE_GRID
		ewcheckrx vhCubes SetAccessLevel_IDCubeEdit_ ACCESS_WRITE
		vhViews =. CreateDefaultCubeView"0 vhCubes
		ewcheckrx hModel SetCubeViews_IModelEdit_ vhViews,}.GridViews
	else.	
		ewcheckrx hModel SetCubeViews_IModelEdit_ }.GridViews
	end.
	Return
)

DetermineEListLevelNum =: 3 : 0
	if. Specification IsKey 'ContributionDimensionId' do.
		elistId =: Specification GetValue 'ContributionDimensionId'
	else.
		Error EW_ERROR_NO_ELIST
	end.
	levelnums =. 0#0
	contribspecs =. Specification GetValues 'Contribution'
	if. 0 = # contribspecs do.
		Error EW_ERROR_NO_CONTRIBUTION_CUBES
	end.
	for_spec. contribspecs do.
		spec =. > spec
		dimtab =. spec GetValue 'Dimensions'
		'dimids levels' =. dimtab GetValue 'TextId';'Level'
		elistind =. dimids Find <elistId
		if. elistind > _1 do.
			levelnum =. _. MakeNumber elistind {:: levels
			if. _. -: levelnum do.
				(elistind {:: levels) Warn EW_WARNING_INVALID_LEVEL_NUMBER,EW_ACTION_IGNORE
			else.
				levelnums =. ~. levelnums , levelnum
			end.
		end.
	end.
	elistDim =: FindDimensions elistId
	select. # levelnums
	case. 0 do.
		elistId Error EW_ERROR_NO_ELIST_CONTRIBUTION
	case. 1 do.
		elistLevelNum =: {. levelnums
	case. do.
		Error EW_ERROR_CONT_MULTIELISTLEVEL
	end.
)

IdentifyEList =: 3 : 0
	elistDim =: FindDimensions elistId
	if. 0 = elistDim do.
		elistId Error EW_ERROR_ELIST_NOT_DEFINED
	end.
	elistLevel =: elistLevelNum FindLevels elistId
	elistDim =: elistLevel { LevelDims
	hEList =: elistLevel { LevelAggLists
)

SIMPLE_ELIST_SPEC =: 0 : 0
TextId	_default_elist
Caption	Contribution Dimension
Columns	Table
	TextId	Caption	Role	Type	Level	Aggregation	Semi-Aggregate	Reference
	_default_elist_level	Contribution Level	Key	Text	0	unsupported	unsupported
Data	Table
	_default_elist_level
	Contribution Item
)

SetModelEList =: 3 : 0
	vgEListItems =. ewcheckrx hEList GetAllColumn_ITableRead_ TABLE_ITEMGUID
	if. Specification IsKey 'Administrators' do.
		admins =. Specification GetValue 'Administrators'
		if. admins IsKey 'CAMID' do.
			'camids captions' =. admins GetTextColumns ;:'CAMID Caption'
			RegisterUsers (vgEListItems $~ vgEListItems *&# camids);(camids #~# vgEListItems);<captions #~# vgEListItems
		else.
			Warn EW_USERS_NO_ADMIN_CAMID,EW_ACTION_IGNORE
		end.
	end.
	if. 1 = # UserGuids do.
		Warn EW_WARNING_NO_USERS,EW_ACTION_USE_PCU
		RegisterUsers vgEListItems;((#vgEListItems)#<'CAMID(":Planning Contributor Users")');<(#vgEListItems)#<'Planning Contributor Users'
	end.
	ewcheckrx hModel SetNodeList_IModelEdit_ hEList
	hLanguages =. ewcheckrx hModel GetLanguageTable_IModelEdit_''
	hAccess =. ewcheckrx hModel GetNodeAccessTable_IModelEdit_''
	hUsers =. ewcheckrx hModel GetCamObjectTable_IModelEdit_''
	sieve =. 0,~:}.UserCAMIDs
	if. DEBUG_MODEL +. 1 = # LocaleIds do.
		hLanguages PopulateList ((,:NULL_GUID);(,<'Base Language');(,<'Base Language');(,_1);<,<'NULL_CAMID');<TABLE_ITEMGUID,TABLE_ITEMNAME,TABLE_ITEMCAPTION,LANGUAGE_LCID,:CAMOBJECT_ID
	else.
		hLanguages PopulateList ((NULL_GUID,}.LocaleGUIDs);('Base Language';}.LocaleNames);('Base Language';}.LocaleNames);(_1,}.LocaleLCIDs);<(#LocaleIds)#<'NULL_CAMID');<TABLE_ITEMGUID,TABLE_ITEMNAME,TABLE_ITEMCAPTION,LANGUAGE_LCID,:CAMOBJECT_ID
	end.
	hUsers PopulateList ((sieve#UserCAMIDs);(sieve#UserCaptions);<sieve#UserGuids);<CAMOBJECT_ID,CAMOBJECT_NAME,:CAMOBJECT_LANGUAGEGUID
	hAccess PopulateList ((}.UserGuids);(}.UserCAMIDs);<(<:#UserGuids)#DECLAREDNODEACCESS_SUBMIT);<NODEACCESS_NODEGUID,NODEACCESS_CAMOBJECTID,:NODEACCESS_DECLAREDACCESS
	Return
)

DeclarePublishCubes =: 3 : 0
	lv =. CubeTypes = CUBE_TYPE_CONTRIBUTION
	if. +./ lv do.
		keycubes =. (~. ; lv # CubeLevels) { LevelKeyCubes
		pubcubes =. (lv # CubeCubes),keycubes
		pubdims =. GetCubeMeasureList pubcubes
		PublishCubes =: W2U GetObjectName pubcubes ,. pubdims
	else.
		PublishCubes =: 0 2$<''
	end.
)

NB.-----------------------------------------------------------------------------
NB.  Multi-lingual
NB.-----------------------------------------------------------------------------

LoadCaptions =: 3 : 0
	if. Specification IsKey 'Locale' do.
		locales =. Specification GetValue 'Locale'
		if. locales IsKey 'Locale' do.
			'ids prodlocs' =. locales GetTextColumns 'Locale';'Product Locale'
			prodlocs RegisterLocales ids
		end.
	end.
	if. Specification IsKey 'Translation' do.
		captions =. Specification GetValue 'Translation'
		if. *./ ; captions IsKey ;:'TextId Locale Caption' do.
			'CaptionTextIds CaptionLocales CaptionCaptions' =: captions GetValue ;:'TextId Locale Caption'
			CaptionLocales =: FindOrAddLocale CaptionLocales
		else.
			Warn EW_WARNING_INVALID_CAPTIONS,EW_ACTION_IGNORE
		end.
	end.
	if. Specification IsKey 'Base Locale' do.
		BaseLocale =: FindOrAddLocale CleanLocaleName Specification GetValue 'Base Locale'
	else.
		BaseLocale =: 0
	end.
	Return
)

GetBaseCaption =: 3 : 0
	textid =. y.
	caption =. ''
	if. (<textid) e. CaptionTextIds do.
		all =. bx CaptionTextIds e. < textid
		if. BaseLocale e. all { CaptionLocales do.
			caption =. (((all{CaptionLocales)i.BaseLocale){all){::CaptionCaptions
		end.
	end.
	if. '' -: caption do.
		caption =. textid
NB.		textid Warn EW_WARNING_CAPTION_MISSING , EW_ACTION_USE_ID
	end.
	caption
)

SetBaseCaption =: 4 : 0
	textid =. y.
	caption =. x.
	if. -. +./(CaptionLocales = BaseLocale)*. CaptionTextIds e. <textid do.
		CaptionTextIds =: CaptionTextIds , < textid
		CaptionLocales =: CaptionLocales , BaseLocale
		CaptionCaptions =: CaptionCaptions , < caption
	else.
		caption =. GetBaseCaption textid
	end.
	caption
)

GetIdentity =: 3 : 0
	spec =. y.
	if. spec IsKey 'TextId' do.
		id =. spec GetValue 'TextId'
		if. spec IsKey 'Caption' do.
			caption =. spec GetValue 'Caption'
			caption =. caption SetBaseCaption id
		else.
			caption =. GetBaseCaption id
		end.
	else.
		Warn EW_WARNING_ID_MISSING , EW_ACTION_CONTINUE
		id =. caption =. ''
	end.
	id;caption
)

GetInstallationLanguage =: 3 : 0
NB.	TODO
	'en'
)

CreateTranslations =: 3 : 0
	basetss =. CreateFreeObject 'AdaytumTranslatableStringSet'
	ewcheckrx basetss LoadStringsFromObject_ITranslatableStringSetEdit_ hModel,1
	basexml =. ewcheckrx Pack basetss
	LocaleTranslations =: (<basexml) BaseLocale } LocaleTranslations
	localetss =. CreateFreeObject 'AdaytumTranslatableStringSet'
	for_locale. (}.i.#LocaleIds)-.BaseLocale do.
		localecaps =. bx CaptionLocales = locale

		transobjs =. bx ObjTextIds e. localecaps { CaptionTextIds
		transcaps =. ((localecaps { CaptionTextIds)i.transobjs { ObjTextIds) { localecaps { CaptionCaptions
		(U2W transcaps) SetObjectCaption transobjs { ObjObjs

		grids =. bx CubeTypes = CUBE_TYPE_GRID
		gridcubes =. grids { CubeCubes
		gridlists =. grids { CubeMeasureLists
		for_measurelist. gridlists do.
			measurelist ReplaceItemCaptions (localecaps { CaptionTextIds) ; <  localecaps { CaptionCaptions
		end.

		modellists =. ewcheckrx hModel GetDimensions_IModelEdit_''
		listlevels =. FindListLevels modellists

		for_levellist. modellists #~ 0 < listlevels do.
			level =. FindListLevels levellist
			dimlevels =. (level { LevelDims){::DimensionLevels
			localeitems =. bx ( ItemLocales = locale ) *. ItemLevels e. dimlevels
			levellist ReplaceItemCaptions (localeitems { ItemIds ) ; < localeitems { ItemCaptions
		end.
		ewcheckrx localetss LoadStringsFromObject_ITranslatableStringSetEdit_ hModel,1
		localexml =. ewcheckrx Pack localetss
		LocaleTranslations =: (<localexml) locale } LocaleTranslations
		ewcheckrx basetss TranslateObject_ITranslatableStringSetEdit_ hModel,1
	end.
)

GetTranslationInfo =: 3 : 0
	('Id';'Name';'GUID';'Product Locale';'LCID';'Translation';'Product Strings'),}.LocaleIds,.LocaleNames,.(<"1 LocaleGUIDs),.LocaleProductLocales,.(":&.>LocaleLCIDs),.LocaleTranslations,.LocaleProductStrings
)

NB.-----------------------------------------------------------------------------
NB.  Import Data
NB.-----------------------------------------------------------------------------

PopulateInvalidLinkTargets =: 3 : 0
	for_cubeind. }.i.#CubeCubes do.
		if. elistLevel e. cubeind {:: CubeLevels do.
			cube =. cubeind { CubeCubes
			links =. ewcheckrx cube GetUpdateLinks_IDCubeEdit_ ''
			invalidlinks =. 0 #~# links
			for_link. links do.
				corrs =. ewcheckrx link GetCorrespondences_IDLinkEdit_''
				invalid =. 0
				for_corr. corrs do.
					srcdims =. ewcheckrx corr GetSourceDimensions_ICorrespondence_''
					tgtdims =. ewcheckrx corr GetTargetDimensions_ICorrespondence_''
					if. (hEList e. tgtdims) *. -. hEList e. srcdims do.
						select. GetObjectClass corr
						case. 'AdaytumSelectionCorrespondence' do.
							seln =. ewcheckrx corr GetSelection_ISelectionCorrespondenceEdit_''
							expr =. ewcheckrx seln GetSelectionExpression_IDimensionSelectionEdit_''
							if. -. expr -: 'F:all;F:detail' do.
								invalid =. 1
								break.
							end.
						case. do.
							invalid =. 1
							break.
						end.
					end.
				end.
				if. invalid do.
					invalidlinks =. 1 link_index } invalidlinks
					ewcheckrx link SetEnabled_IUpdate_ 1
					ewcheckrx link Execute_IDLinkExecute_''
					ewcheckrx link SetEnabled_IUpdate_ 0
				end.
			end.
			ewcheckrx cube SetUpdateLinks_IDCubeEdit_ links #~ -. invalidlinks
		end.
	end.
)

GetImportData =: 3 : 0
	targetcubes =. PopulateInvalidLinkTargets''
	ImportData =: 0 2$<''
	hExport =. CreateFreeObject 'AdaytumDCubeExport'
	ewcheckrx hExport SetSuppressZeroRows_IDCubeExport_ 1
	ewcheckrx hExport SetIncludeCalculated_IDCubeExport_ 0
	for_cubeind. bx CubeTypes e. CUBE_TYPE_KEY , CUBE_TYPE_ATTRIBUTE , CUBE_TYPE_FACT , CUBE_TYPE_GRID , CUBE_TYPE_XRATE do.
		cube =. cubeind { CubeCubes
		if. hEList e. ewcheckrx cube GetDimensions_ICube_ '' do.
			if. CUBE_TYPE_GRID = cubeind { CubeTypes do.
				data =. 0 0$<''
			else.
				ewcheckrx hExport SetCube_IDCubeExport_ cube
				data =. ewcheckrx hExport ExportAsMatrix_IDCubeExport_ ''
			end.
			ImportData =: ImportData , W2U (>GetObjectName cube);<data
		end.
	end.
	ewcheckrx 0 Release hExport
	if. 0 e. $ ImportData do.
		Error EW_NO_IMPORT_CUBES
	end.
	Return
)

NB.-----------------------------------------------------------------------------
NB.  Previous Application
NB.-----------------------------------------------------------------------------

ExtractConsistencyInformationFromModel =: 3 : 0
	ResetJCE''
	if. 0<#y. do.
NB.		try.
			hModel =. ewcheckrx 0 Unpack y.
			vhDims =. ewcheckrx hModel GetDimensions_IModelEdit_''
			vhCubes =. ewcheckrx hModel GetCubes_IModelEdit_''
			vhObjs =. hModel , vhDims , vhCubes
			classes =. GetObjectClass vhObjs
			OldObjectGuids =: (~.classes),.classes <@:(ObjectIdentity"0)/. vhObjs
			OldItemGuids =: (W2U GetObjectName vhDims),.GetListItemMap&.>vhDims
			ResetJCE''
NB.		catch.
NB.			Warn EW_WARNING_PREVIOUS_MODEL_BAD,EW_ACTION_IGNORE
NB.			OldObjectGuids =: OldItemGuids =: 0 2$<''
NB.		end.
	else.
		OldObjectGuids =: OldItemGuids =: 0 2$<''
	end.
	Return
)

GetObjectGuid =: 4 : 0
	class =. x.
	name =. y.
	guid =. CoCreateGuid''
	if. OldObjectGuids IsKey class do.
		map =. OldObjectGuids GetValue class
		if. map IsKey name do.
			guid =. map GetValue name
		end.
	end.
	guid
)

GetItemGuids =: 4 : 0
	listname =. ObjectName x.
	itemnames =. y.
	itemnames =. GetShortName itemnames
	itemguids =. ((i.~~.)itemnames) { CoCreateGuid"0 ~.itemnames
	if. OldItemGuids IsKey listname do.
		map =. OldItemGuids GetValue listname
		found =. ; map IsKey itemnames
		if. +./found do.
			itemguids =. (>map GetValue found#itemnames) (bx found) } itemguids
		end.
		if. +./ -. found do.
			if. DEBUG_MODEL do.
smoutput 'New GUIDs for ';(>(-.found)#itemnames);'of list';listname
			end.
		end.
	else.
		if. DEBUG_MODEL do.
smoutput 'New GUIDs for all items of list';listname
		end.
	end.
	itemguids
)

GetListItemMap =: 3 : 0
	hList =. y.
	'names guids'=. hList GetColumn L:0 TABLE_ITEMNAME;TABLE_ITEMGUID
NB.	'names guids' =. ewcheckrx (2#hList) GetAllColumn_ITableRead_ TABLE_ITEMNAME;TABLE_ITEMGUID
	names ,. <"1 guids
)

ObjectIdentity =: 3 : 0
	(W2U >GetObjectName y.);GetObjectId y.
)

NB.-----------------------------------------------------------------------------
NB.  Formats
NB.-----------------------------------------------------------------------------

CreateBaseFormats =: 3 : 0
	BaseFormats =: 0 2$0
	BaseFormats =: BaseFormats , MEASURE_TYPE_NUMBER	, CreateNumberFormat	DECIMALSEP_REGIONAL;	THOUSANDSEP_REGIONAL;	2;	0;	 ,&.>	'';		'';		'(';	')'
	BaseFormats =: BaseFormats , MEASURE_TYPE_MONETARY	, CreateNumberFormat	DECIMALSEP_REGIONAL;	THOUSANDSEP_REGIONAL;	2;	0;	 ,&.>	'#';	'';		'(#';	')'
	BaseFormats =: BaseFormats , MEASURE_TYPE_COUNT		, CreateNumberFormat	DECIMALSEP_REGIONAL;	THOUSANDSEP_REGIONAL;	0;	0;	 ,&.>	'';		'';		'(';	')'
	BaseFormats =: BaseFormats , MEASURE_TYPE_PERCENTAGE, CreateNumberFormat	DECIMALSEP_REGIONAL;	THOUSANDSEP_REGIONAL;	0;	2;	 ,&.>	'';		'%';	'(';	'%)'
	BaseFormats =: BaseFormats , MEASURE_TYPE_TEXT		, CreateFreeObject 'AdaytumTextFormat'
	BaseFormats =: BaseFormats , MEASURE_TYPE_DATE		, CreateFreeObject 'AdaytumDateFormat'
	Return
)

CreateNumberFormat =: 3 : 0
	hFmt =. CreateFreeObject 'AdaytumNumberFormat'
	'decsep thousep decplc scale pospre possuf negpre negsuf' =. y.
	ewcheckrx hFmt SetDecimalSeparatorType_INumberFormatEdit_ decsep
	ewcheckrx hFmt SetThousandSeparatorType_INumberFormatEdit_ thousep
	ewcheckrx hFmt SetDecimalPlaces_INumberFormatEdit_ decplc
	ewcheckrx hFmt SetScaleFactor_INumberFormatEdit_ scale
	ewcheckrx hFmt SetPositivePrefix_INumberFormatEdit_ U2W pospre
	ewcheckrx hFmt SetPositiveSuffix_INumberFormatEdit_ U2W possuf
	ewcheckrx hFmt SetNegativePrefix_INumberFormatEdit_ U2W negpre
	ewcheckrx hFmt SetNegativeSuffix_INumberFormatEdit_ U2W negsuf
	hFmt
)

CreateCurrencyFormat =: 3 : 0
	0 CreateCurrencyFormat y.
:
	scale =. x.
	if. scale > 0 do.
		decimals =. 0
	else.
		decimals =. 2
	end.
	code =. y.
	ind =. CurrencyCodes Find < code
	if. _1 = ind do.
		'pospre possuf' =. (code,' ');''
	else.
		symbol =. dtb ind {:: CurrencySymbols
		format =. dtb ind {:: CurrencyFormats
		decimals =. MakeNumber dtb ind {:: CurrencyDecimals
		if. '#' e. format do.
			pospre =. format {.~ format i. '#'
			possuf =. format }.~ >: format i: '#'
		else.
			if. 0 < #symbol do.
				pospre =. symbol
			else.
				if. 0 < #format do.
					pospre =. format
				else.
					pospre =. code,' '
				end.
			end.
			possuf =. ''
		end.
		if. ({:' ',pospre)e.'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz' do.
NB.			pospre =. pospre , ' '
		end.
		if. ({.possuf,' ')e.'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz' do.
NB.			possuf =. ' ',possuf
		end.
		negpre =. '(',pospre
		negsuf =. possuf,')'
	end.
	if. -. +./ code E. pospre do.
		pospre =. code , ' ' , pospre
	end.
	if. -. +./ code E. negpre do.
		negpre =. code , ' ' , negpre
	end.
	hFmt =. CreateNumberFormat DECIMALSEP_REGIONAL;THOUSANDSEP_REGIONAL;decimals;scale;pospre;possuf;negpre;negsuf
)

CreateReferenceFormat =: 3 : 0
	hHolder =. y.
	hFormat =. hHolder CreateObject 'AdaytumLookupFormat'
	ewcheckrx hFormat SetValueColumnId_ILookupFormatEdit_ TABLE_ITEMID
	ewcheckrx hFormat SetTextColumnId_ILookupFormatEdit_ TABLE_ITEMNAME
	hFormat
:
	hFormat =. CreateReferenceFormat y.
	ewcheckrx hFormat SetTable_ILookupFormatEdit_ x.
	hFormat
)

GetFormatReferenceList =: 3 : 0
	if. y. ([`QueryInterface)@.(*@[) 'ILookupFormatEdit' do.
		ewcheckrx y. GetTable_ILookupFormatEdit_ ''
	else.
		0
	end.
)

GetFormatReferenceLevel =: 3 : 0
	FindListLevels GetFormatReferenceList y.
)

GetLevelDimensionKeyFormat =: 3 : 0
	level =. y.
	dim =. level { LevelDims
	keylist =. dim { DimensionKeyLists
	'ids formats' =. keylist GetColumn&.> TABLE_ITEMNAME;TABLE_ITEMFORMAT
	iskeyid =. -. ids e. (dim {:: DimensionLevels) { LevelIds
	if. 1 ~: +/iskeyid do.
		keyformat =. 0
	else.
		keyformat =. {. iskeyid # formats
	end.
)

GetTypeFormat =: 3 : 0
	{.'' GetTypeFormat y.
:
	ref =. x.
	if. 1 = # , y. do.
		type =. {.,y.
		scale =. 0
		decimals =. 2
	else.
		'type scale decimals' =. y.
	end.

	fmt =. 0

	select. type
	case. MEASURE_TYPE_REFERENCE do.
		refind =. FindLevels ref
		if. 0 < refind do.
			fmt =. refind { LevelFormats
		else.
			ref Warn EW_WARNING_REFERENCE_NOT_FOUND , EW_ACTION_USE_TEXT
			type =. MEASURE_TYPE_TEXT
			fmt =. BaseFormats GetValue type
		end.
	case. MEASURE_TYPE_MONETARY do.
		if. Specification IsKey 'Consolidated Currency' do.
			fmt =. scale CreateCurrencyFormat Specification GetValue 'Consolidated Currency'
		else.
			fmt =. CreateNumberFormat DECIMALSEP_REGIONAL;THOUSANDSEP_REGIONAL;decimals;scale;,&.>'#';'';'(#';')'
		end.
	case. MEASURE_TYPE_PERCENTAGE do.
		fmt =. CreateNumberFormat DECIMALSEP_REGIONAL;THOUSANDSEP_REGIONAL;decimals;scale;,&.>'';'%';'(';'%)'
	case. MEASURE_TYPE_NUMBER do.
		fmt =. CreateNumberFormat DECIMALSEP_REGIONAL;THOUSANDSEP_REGIONAL;decimals;scale;,&.>'';'';'(';')'
	case. do.
		if. BaseFormats IsKey type do.
			fmt =. BaseFormats GetValue type
		else.
			Warn EW_WARNING_INVALID_TYPE , EW_ACTION_USE_NUMBER
			fmt =. BaseFormats GetValue MEASURE_TYPE_NUMBER
		end.
	end.
	fmt,type
)


NB.-----------------------------------------------------------------------------
NB.  Aggregation
NB.-----------------------------------------------------------------------------

IsAggregable =: 3 : 0
NB. takes an adjustment string
	-.(boxopen y.) e.<,'Z'
)

IsTimeAggregable =: 3 : 0
NB. takes an adjustment string
	(boxopen y.) e.'';'T:First';'T:Last';'T:Average'
)

IsDistributable =: 3 : 0
NB. takes an adjustment string
	(1&{.&.>boxopen y.) e. ,&.>'ZW'
)

IsTimeDistributable =: 3 : 0
NB. takes an adjustment string
	0 < #&> boxopen y.
)

TestAggregationAdjustment =: 4 : 0
	ClearMessages ''
	r =. x. AggregationAdjustment y.
	r;<Messages
)

DefaultAggregationFromType =: 3 : 0
	(y. e. MEASURE_TYPE_NUMBER,MEASURE_TYPE_COUNT){ 'unsupported';'sum'
)

AggregationAdjustment =: 3 : 0
	select. y.
	case. 'sum' do.
		adjustment =. ''
	case. 'unsupported' do.
		adjustment =. ,'Z'
	case. 'count' do.
		y. Warn EW_WARNING_AGG_TYPES, EW_ACTION_USE_SUM
		adjustment =. ''
	case. 'countDistinct' do.
		y. Warn EW_WARNING_AGG_TYPES, EW_ACTION_USE_SUM
		adjustment =. ''
	case. do.
		y. Warn EW_WARNING_AGG_TYPES, EW_ACTION_USE_NO_AGG
		adjustment =. ,'Z'
	end.
	adjustment
:
	if. '' -: x. do.
		adjustment =. AggregationAdjustment y.
	else.
		select. x.
		case. 'unsupported' do.
			select. y.
			case. 'unsupported' do.
				adjustment =. ,'Z'
			case. 'sum';'count' do.
				adjustment =. ,'T:Zero'
			case. do.
				y. Warn EW_WARNING_AGG_TIME_MISMATCH, EW_ACTION_IGNORE
				adjustment =. 'T:Zero'				
			end.
		case. 'sum';'count';'first';'last';'average' do.
			if. -. (<y.) e. 'sum';'count'  do.
				y. Warn EW_WARNING_AGG_TIME_MISMATCH, EW_ACTION_IGNORE
			end.
			adjustment =. (('sum';'count';'first';'last';'average')i.<x.){::'';'';'T:First';'T:Last';'T:Average'
		case. do.
			x. Warn EW_WARNING_AGG_TIME_NOT_SUPP, EW_ACTION_IGNORE
			adjustment =. AggregationAdjustment y.
		end.
	end.
	adjustment
)

NB.-----------------------------------------------------------------------------
NB.  Dimensions and Timescales
NB.-----------------------------------------------------------------------------

CreateDimension =: 3 : 0
	spec =. y.
	'dimid dimcap' =. GetIdentity spec

	isEList =. dimid -: elistId

	if. -. spec IsKey 'Columns' do.
		Warn EW_WARNING_NO_TABLE_COLUMNS,EW_ACTION_DIMENSION_IGNORED
		if. isEList do.
			Error EW_ERROR_NO_ELIST
		end.
		Return
		return.
	end.
	cols =. spec GetValue 'Columns'
	'idcol colcaps role type level locale ref' =. cols GetTextColumns ;:'TextId Caption Role Type Level Locale Reference'
	type =. MeasureTypeFromText&> type
	locale =. FindOrAddLocale locale
	ns =. ~: idcol
	if. 0 e. ns do.
		(V2TabString ~. (-.ns)#idcol) Warn EW_WARNING_DUPLICATE_COLUMNS,EW_ACTION_USE_FIRST
		'idcol colcaps role level locale' =. ns #L:0 _1 idcol;colcaps;role;level;<locale
	end.
	if. 0 = # idcol do.
		Warn EW_WARNING_NO_TABLE_COLUMNS,EW_ACTION_DIMENSION_IGNORED
		if. isEList do.
			Error EW_ERROR_NO_ELIST
		end.
		Return
		return.
	end.
	level =. MakeNumbers level
	if. isEList do.
		level =. elistLevelNum (bx role e. <'Attribute') } level
	end.
	roleatlevel =. level;"0 role
	isordinal =. role e. <'Ordinal'
	iskey =. isordinal +. role e. <'Key'
	levels =. sort ~. iskey # level
	if. -. levels -: ({.levels)+i.#levels do.
		Warn EW_WARNING_GAPS_IN_LEVELS,EW_ACTION_CONTINUE
	end.
	if. 0 < # level -. levels,0 do.
		(": level -. levels,0) Warn EW_WARNING_ORPHAN_LEVELS,EW_ACTION_IGNORE
	end.
	levelinds =. ((iskey#level)i.levels){ iskey#i.#level
	levelids =. levelinds { idcol
	levelnums =. levelinds { level
	levelcaps =. levelinds { colcaps
	levelcaps =. levelcaps SetBaseCaption L:0 levelids

	if. -. y. IsKey 'Data' do.
		Warn EW_WARNING_NO_TABLE_DATA,EW_ACTION_DIMENSION_IGNORED
		if. isEList do.
			Error EW_ERROR_NO_ELIST
		end.
		Return
		return.
	end.
	data =. y. GetValue 'Data'

	lkeys =. >data GetTextColumns levelids
	if. 0 e. $ lkeys do.
		Warn EW_WARNING_NO_TABLE_ROWS,EW_ACTION_DIMENSION_IGNORED
		if. isEList do.
			Error EW_ERROR_NO_ELIST
		end.
		Return
		return.
	end.

	ns =. ~:|:lkeys
	if. 0 e. ns do.
		(M2TabLfString ~.(-.ns)#|:lkeys)Warn EW_WARNING_DUPLICATE_DIM_ITEMS,EW_ACTION_USE_FIRST
		data =. (ns #L:0 _1 {:"1 data) 1}"0 1 data
		lkeys =. ns #"1 lkeys
	end.
	
	ckeys =. }.L:0 ,L:0/\ ',',L:0 lkeys				NB. composite keys with , separator

	for_lind. i.#levels do.							NB. replace Ordinal columns with <level#>_<ordinal>
		if. isordinal {~ lind { levelinds do.
			ckeys =. (((":lind{levels),'_'),L:0 lind { lkeys) lind } ckeys
		end.
	end.

	ukeys =. ~:"1 ckeys								NB. unique items at each level

	starttab =. lentab =. 0 $~$ lkeys
	istimescale =. 0 #~# levels
	for_lind. |. i.#levels do.
		startcol =. roleatlevel Find (lind{levels);'StartDate'
		if. _1 < startcol do.
			starts =. data GetValue startcol {:: idcol
			startnums =. ConvertDates starts
			endcol =. roleatlevel Find (lind{levels);'EndDate'
			if. _1 < endcol do.
				ends =. data GetValue endcol {:: idcol
				endnums =. ConvertDates ends
				lengths =. endnums - startnums - 1
			else.
				keys =. lind { ckeys
				nubsieve =. ~: keys
				indsinnub =. (i.~~.)~ keys
				NB. We have to calculate the period lengths, except the last
				if. lind { }.istimescale,0 do. NB. if the child level is a timescale then we can find its latest end date and thus the length of the last period
					maxend =. >:/ <: ((>:lind) { starttab) + (>:lind)  { lentab
				else.
					maxend =. _.
				end.
				lengths =. indsinnub { maxend GuessPeriodLengths nubsieve#startnums
			end.
		else.
			if. lind { }.istimescale,0 do. NB. if the child level is a timescale then we can aggregate the dates
				keys =. lind { ckeys
				indsinnub =. (i.~~.)~ keys
				startnums =. (>:lind) { starttab
				endnums =. <: startnums + (>:lind)  { lentab
				startnums =. indsinnub { indsinnub <.//. startnums
				endnums =. indsinnub { indsinnub >.//. endnums
				lengths =. endnums - startnums - 1
			else.
				NB. go to the next level without writing timescale information
				continue.
			end.				
		end.
		NB. write timescale information
		istimescale =. 1 lind } istimescale
		starttab =. startnums lind } starttab
		lentab =. lengths lind } lentab
	end.

	captab =. lkeys
	iscap =. (role e. <'Caption') *. locale e. 0 , BaseLocale
	if. +./iscap do.
		captab =. (>data GetValue iscap#idcol) (levels i. iscap#level) } captab
	end.

	hierarchyclass =. istimescale{'AdaytumHierarchy';'AdaytumDList'

	itemlists =. hierarchyclass CreateNamedObject&><"1 levelids ,. <'_Items'
	attlists =. 'AdaytumDList' CreateNamedObject"1 levelids ,. <'_Attributes'
	agglists =. hierarchyclass CreateNamedObject&><"1 levelids ,. <'_Aggregation'
	nonagglists =. 'AdaytumHierarchy' CreateNamedObject"1 levelids ,. <'_NonAggregation'
	keycubes =. 'AdaytumDCube' CreateNamedObject"1 levelids ,. <'_Keys'
	attcubes =. 'AdaytumDCube' CreateNamedObject"1 levelids ,. <'_Attributes'

	keylist =. 'AdaytumDList' CreateNamedObject dimid;'_Keys'

	guidtab =. >itemlists GetItemGuids&.> <"1 ckeys

	TABLE_ITEMCAPTION EnsureColumnInTable "1 0 keylist,itemlists,attlists,agglists,nonagglists

NB.	extrakeycols =. bx roleatlevel e. (0,>./levels);"0 'DimensionKey';'StartDate'
	extrakeycols =. bx roleatlevel e. ,:0;'DimensionKey'
	extrakeys =. data GetTextColumns extrakeycols { idcol

	keyids =. levelids , extrakeycols { idcol
	keycaps =. levelcaps , extrakeycols { colcaps
	keyfmts =. GetTypeFormat&> ((#levelids)#MEASURE_TYPE_TEXT),extrakeycols { type
	keyguids =. keylist GetItemGuids keyids

	keylist PopulateList (keyids;keycaps;keyguids;<keyfmts);<TABLE_ITEMNAME,TABLE_ITEMCAPTION,TABLE_ITEMGUID,:TABLE_ITEMFORMAT

	ewcheckrx keycubes SetDimensions_IDCubeEdit_ <"1 keylist ,. itemlists
	ewcheckrx attcubes SetDimensions_IDCubeEdit_ <"1 agglists ,. attlists NB. The order is reversed to avoid agglist currency formats overriding attlist formats

	for_lnum. levelnums do.
		LevelFrom =. lnum_index&{
		LevelRows =. (>:lnum_index)&{.

NB. items only
		hList =. LevelFrom itemlists
		itemlv =. LevelFrom ukeys
		ids =. itemlv # LevelFrom ckeys
		iids =. >:i.#ids
		caps =. itemlv # LevelFrom captab
		guids =. itemlv # LevelFrom guidtab
		if. LevelFrom istimescale do.
			starts =. itemlv # LevelFrom starttab
			lengths =. itemlv # LevelFrom lentab
			pinds =. i.#ids
			hList PopulateTimescale ids;iids;caps;guids;pinds;starts;lengths
		else.

			hList PopulateHierarchy guids;ids;caps;guids;<iids
		end.

NB. full hierarchy with aggregation
		hList =. LevelFrom agglists
		agglm =. LevelRows ukeys
		agglv =. ,agglm
		iids =. agglv # , |. ($agglm)$ +/\, |. agglm
		ids =. agglv # ,LevelRows ckeys
		caps =. agglv # ,LevelRows captab
		guids =. agglv # _38[\,LevelRows guidtab
		pguids =. agglv # _38[\,(0,i.lnum_index) { guidtab	NB. parent of first level item is itself
		if. LevelFrom istimescale do.
			starts =. agglv # ,LevelRows starttab
			lengths =. agglv # ,LevelRows lentab
			pinds =. guids i.pguids
			hList PopulateTimescale ids;iids;caps;guids;pinds;starts;lengths
			order =. guids i. hList GetColumn TABLE_ITEMGUID
		else.
			hList PopulateHierarchy guids;ids;caps;pguids;<iids
			order =. ewcheckrx hList GetOrderedIndices_IHierarchy_ ''
			ewcheckrx hList Reorder_ITableEdit_ order
		end.

NB. all hierarchy items but no aggregation - uses guids as pguids - no timescale information
		hList =. LevelFrom nonagglists
		hList PopulateHierarchy guids;ids;caps;guids;<iids
		ewcheckrx hList Reorder_ITableEdit_ order

NB. population of key values for each item at this level
		itemlv =. LevelFrom ukeys
		itemkeys =. itemlv #"1 lkeys
		levelid =. > LevelFrom levelids
		values =. >:i.$itemkeys
		strings =. ,itemkeys
		for_extrakeycol. extrakeycols do.
			vals =. itemlv # extrakeycol_index {:: extrakeys
			select. extrakeycol {:: type
			fcase. MEASURE_TYPE_REFERENCE do.
				(extrakeycol {:: idcol) Warn EW_WARNING_REFDIMKEY_NOT_ALLOWED,EW_ACTION_USE_TEXT
			case. MEASURE_TYPE_TEXT do.
				base =. >:#strings
				strings =. strings , vals
				vals =. base + i.#vals
			case. MEASURE_TYPE_NUMBER;MEASURE_TYPE_PERCENTAGE;MEASURE_TYPE_COUNT do.
				vals =. MakeNumbers vals
			case. MEASURE_TYPE_DATE do.
				vals =. ConvertDates vals
			end.
			values =. values , vals
		end.
		keycube =. LevelFrom keycubes
		blockguids =. (ewcheckrx keycube GetDimensions_ICube_'') GetColumn&.> <TABLE_ITEMGUID
		aggitems =. 0"1 L:0 blockguids
		block =. CreateFreeObject 'AdaytumDCubeBlock'
		version =. ewcheckrx keycube GetVersionId_IDCubeEdit_''	
		ewcheckrx block InitialiseBlock_IDCubeBlock_ (GetObjectId keycube);version;_1;blockguids;<aggitems
		ewcheckrx block SetData_IDCubeBlock_ ,values
		ewcheckrx block SetTextStrings_IDCubeBlock_ U2W strings
		ewcheckrx block SetTextIds_IDCubeBlock_ >:i.#strings
		ewcheckrx keycube SetBlocks_IDCubeEdit_ ,block
	end.

	if. isEList do.
		if. spec IsKey 'Users' do.
			userspec =. spec GetValue 'Users'
			for_userlevel. GetKeys userspec do.
				userlevel =. > userlevel
				userlevelind =. levelids Find <userlevel
				if. _1 = userlevelind do.
					userlevel Warn EW_WARNING_USERS_LEVEL_MISSING,EW_ACTION_IGNORE
					continue.
				end.
				cols =. userspec GetValue userlevel
				if. 0 e. ; cols IsKey (>:userlevelind){.levelids do.
					userlevel Warn EW_WARNING_USERS_INCOMPLETE_KEY,EW_ACTION_IGNORE
					continue.
				end.
				if. -. cols IsKey 'CAMID' do.
					userlevel Warn EW_WARNING_USERS_NO_CAMID,EW_ACTION_IGNORE
					continue.
				end.
				camid =. cols GetValue 'CAMID'
				keys =. |: >cols GetValue (>:userlevelind) {. levelids
				itemlv =. userlevelind { ukeys
				items =. itemlv # |:(>:userlevelind){.lkeys
				inds =. items Find keys
				notfound =. _1 = inds
				if. +./notfound do.
					(M2TabLfString notfound # keys)Warn EW_WARNING_USERS_ITEMS_MISSING,EW_ACTION_IGNORE
					camid =. (-.notfound) # camid
					inds =. inds -. _1
				end.
				RegisterUsers (inds { itemlv # userlevelind { guidtab);camid;<camid
			end.
		end.
	end.

	formats =. itemlists CreateReferenceFormat"0 [ 0

	CUBE_TYPE_KEY RegisterCubes keycubes;<keylist #~# keycubes
	levelinds =. (dimid;(+./istimescale);keylist) RegisterDimensionLevels levelids;levelnums;formats;itemlists;attlists;agglists;nonagglists;keycubes;<attcubes

	for_lnum. levelnums do.
		itemlv =. lnum_index { ukeys
		ids =. itemlv # lnum_index { ckeys
		transcols =. bx (level = lnum) *. (role e. <'Caption') *. -. locale e. 0 , BaseLocale
		if. 0 < # transcols do.
			caps =. itemlv #"1 > data GetTextColumns transcols { idcol
			(lnum_index{levelinds) RegisterItemCaptions (transcols{locale);ids;<caps
		end.
	end.

	alliids =. +/\"1 ukeys
	for_pair. levelnums PairWhereGreater i.#levelnums do.
		RegisterCorrespondence (pair { levelinds);(~.&.|: pair { alliids);0
	end.

	FindDimensions dimid
)

CreateCurrencies =: CreateTimescale =: CreateDimension

GuessPeriodLengths =: 4 : 0
NB. if maxenddate is _.then we guess the last period length as the mode of the others
	maxenddate =. x.
	starts =. y.
	ordered =. /:~ starts
	gaps =. 2-~/\ ordered
	if. _. = maxenddate do.
		Warn EW_WARNING_NO_ENDDATES,EW_ACTION_USE_MODE
		gaps =. gaps , Mode gaps
	else.
		gaps =. gaps , maxenddate - (>./starts) - 1
	end.
	(ordered i. starts){gaps
)

Mode =: 3 : 0
	vector =. y.
	frequency =. #/.~vector
	(frequency i.>./frequency){~.vector
)

GetItemGuid =: 4 : 0
	hDim =. x.
	sItem =. y.
	sItem =. GetShortName sItem
	iItem =. hDim FindInColumn (,<sItem);TABLE_ITEMNAME
	gItem =. ewcheckrx hDim GetCell_ITableRead_ iItem;TABLE_ITEMGUID
	gItem
)

CreateAttributeTables =: 3 : 0
	old =. GetCurrentObject''
	for_spec. Specification GetValues 'Dimension' do.
		'Dimension' SetCurrentObject >spec
		CreateAttributeTable >spec
	end.
	for_spec. Specification GetValues 'Timescale' do.
		'Timescale' SetCurrentObject >spec
		CreateAttributeTable >spec
	end.
	RestoreCurrentObject old
	Return
)

CreateAttributeTable =: 3 : 0
	spec =. y.
	'dimid dimcap' =. GetIdentity spec
	levelinds =. (FindDimensions dimid) {:: DimensionLevels

	'columns data' =. spec GetValue ;:'Columns Data'
	'allids allcaptions alltypes allscales alldecs allrefs allroles alllevels' =. columns GetTextColumns ;:'TextId Caption Type Scale Decimals Reference Role Level'
	'allids allcaptions alltypes allscales alldecs allrefs allroles alllevels' =. (-.allroles e. 'Key';'Caption') #L:0 _1 allids;allcaptions;alltypes;allscales;alldecs;allrefs;allroles;<alllevels
	alllevels =. MakeNumbers alllevels
	allscales =. MakeNumbers allscales
	alldecs =. MakeNumbers alldecs
	if. dimid -: elistId do.
		alllevels =. elistLevelNum (bx allroles e. <'Attribute') } alllevels
	end.
	alltypes =. MeasureTypeFromText &> alltypes


	for_levelind. levelinds do.
		'hAttList hItemList hAttCube levelnum' =. levelind {&>LevelAttLists;LevelItemLists;LevelAttCubes;<LevelNums
		colinds =. bx alllevels = levelnum
		if. 0 < # colinds do.
			'ids captions types scales decs refs' =. colinds {L:0 _1 allids;allcaptions;alltypes;allscales;alldecs;<allrefs
			guids =. hAttList GetItemGuids ids
			'formats types' =. <"1 |: refs GetTypeFormat&> <"1 types,.scales,.decs
			adjustments =. (#formats)#<,'Z'
			cube =. (dimid;CUBE_TYPE_ATTRIBUTE;hAttCube;hAttList;<,levelind) RegisterCubeMeasures ids;captions;types;ROLE_ATTRIBUTE;guids;(0#~#ids);formats;<(#ids)#<,'Z'
			PopulateMeasureList cube
			hAttCube PopulateCubeData columns;<data
			cubedata =. GetCubeAsNumber hAttCube
			cubelists =. ewcheckrx hAttCube GetDimensions_ICube_''
			if. hAttList ~: {. cubelists do.
				cubedata =. |: cubedata
			end.
			realitemlist =. {. cubelists -. hAttList NB. If the dimension is the elist then the realitemlist will be the LevelAggList
			fromiids =. hItemList GetColumn TABLE_ITEMID
			realiids =. realitemlist GetColumn TABLE_ITEMID
			for_refind. bx * #&>refs do.
				tolevel =. FindLevels refind { refs
				toiids =. (realiids i. fromiids) { refind { cubedata
				RegisterCorrespondence (levelind , tolevel);(fromiids,:toiids);1
			end.
		end.
	end.
	Return
)

PopulateCubeData =: 4 : 0
	hCube =. x.
	'columns data' =. y.

	'ids typenames roles refs' =. columns GetTextColumns ;:'TextId Type Role Reference'
	types =. MeasureTypeFromText&> typenames
	invalidtype =. types = MEASURE_TYPE_INVALID
	if. +./invalidtype do.
		(M2TabLfString invalidtype#ids,.typenames)Warn EW_WARNING_INVALID_TYPE,EW_ACTION_IGNORE
		'ids types roles refs' =. (-.invalidtype)#L:_ _1 ids;types;roles;<refs
	end.
	data =. >data GetTextColumns ids

	if. 0 e. $ data do.
		Warn EW_WARNING_NO_TABLE_ROWS,EW_ACTION_LEAVE_EMPTY
		Return
		return.
	end.

	alldims =. ewcheckrx hCube GetDimensions_ICube_''

	measuredim =. GetCubeMeasureList hCube
	measureids =. measuredim GetColumn TABLE_ITEMNAME
	measures =. FindMeasures measureids
	measureinds =. measureids Find ids
	measurecols =. bx _1 < measureinds
	if. 0 = # measurecols do.
		Warn EW_WARNING_NO_MEASURE_COLUMNS,EW_ACTION_LEAVE_EMPTY
		Return
		return.
	end.

	dims =. alldims -. measuredim
	levelinds =. FindListLevels dims
	rowinds =. 0 $~ (#dims) , {:$ data
	refids =. (*#&>refs) {"0 1 ids,.refs
	for_levelind. levelinds do.
		alllevels =. (levelind { LevelDims) {:: DimensionLevels
		levels =. alllevels #~ (alllevels { LevelNums) <: levelind { LevelNums
		levels =. levels /: levels { LevelNums

		keyids =. refids intersect levels { LevelIds
		keyinds =. ((levelind { LevelDims) { DimensionKeyLists) FindInColumn keyids;<TABLE_ITEMNAME
		
		datakeys =. data {~ refids i. keyids
		levelkeys =. keyinds { GetCubeAsText levelind { LevelKeyCubes

		rowinds =. (levelkeys Find&.|: datakeys) levelind_index } rowinds
	end.
	goodrows =. *./ _1 ~: rowinds
	if. 0 e. goodrows do.
		(M2TabLfString (-.goodrows)#|:data)Warn EW_WARNING_BAD_ROWS,EW_ACTION_IGNORE
		rowinds =. goodrows #"1 rowinds
		data =. goodrows #"1 data
	end.
	
	rowinds =. |: rowinds NB. transpose to ease the scatter-point indexing
	dimorder =. (measuredim,dims)i.alldims
	blockguids =. dimorder { (measuredim,levelinds{LevelItemLists) GetColumn&.> <TABLE_ITEMGUID
	aggitems =. 0"1 L:0 blockguids
	
	hBlock =. CreateFreeObject 'AdaytumDCubeBlock'
	version =. ewcheckrx hCube GetVersionId_IDCubeEdit_''
	ewcheckrx hBlock InitialiseBlock_IDCubeBlock_ (GetObjectId hCube);version;_1;blockguids;<aggitems

	strings =. 0#<''
	block =. 0$~#&>blockguids

	for_measurecol. measurecols do.
		vals =. measurecol { data
		select. ((measurecol{measureinds){measures) { MeasureTypes
		case. MEASURE_TYPE_TEXT do.
			base =. >:#strings
			strings =. strings , vals
			vals =. base + i.#vals
		case. MEASURE_TYPE_MONETARY;MEASURE_TYPE_NUMBER;MEASURE_TYPE_PERCENTAGE;MEASURE_TYPE_COUNT do.
			vals =. MakeNumbers vals
		case. MEASURE_TYPE_DATE do.
			vals =. ConvertDates vals
		case. MEASURE_TYPE_REFERENCE do.
			reflevel =. FindLevels measurecol {:: refs
			vals =. (reflevel { LevelItemLists) ItemIdsFromNames vals
		end.
		block =. vals (<"1 dimorder {"1 (measurecol{measureinds) ,"1 rowinds) } block
	end.
	ewcheckrx hBlock SetData_IDCubeBlock_ ,block
	ewcheckrx hBlock SetTextStrings_IDCubeBlock_ U2W strings
	ewcheckrx hBlock SetTextIds_IDCubeBlock_ >:i.#strings
	ewcheckrx hCube SetBlocks_IDCubeEdit_ ,hBlock
	Return
)

PopulateIfAssumption =: 3 : 0
	cube =. y.
	lists =. ewcheckrx cube GetDimensions_ICube_ ''
	if. -. hEList e. lists do.
		links =. ewcheckrx cube GetUpdateLinks_IDCubeEdit_ ''
		if. 0 < # links do.
			block =. CreateFreeObject 'AdaytumDCubeBlock'
			version =. ewcheckrx cube GetVersionId_IDCubeEdit_''
			blockguids =. lists GetColumn&.> <TABLE_ITEMGUID
			aggitems =. 0"1 L:0 blockguids
			ewcheckrx block InitialiseBlock_IDCubeBlock_ (GetObjectId cube);version;_1;blockguids;<aggitems
			ewcheckrx cube SetBlocks_IDCubeEdit_ ,block
	
			ewcheckrx links SetEnabled_IUpdate_ 1
			ewcheckrx links Execute_IDLinkExecute_<''
			ewcheckrx cube SetEnabled_IUpdate_ 1
			ewcheckrx cube Save_ICube_ ,:NULL_GUID
			ewcheckrx cube SetEnabled_IUpdate_ 0
			ewcheckrx links SetEnabled_IUpdate_ 0
		end.
	end.
	Return
)

NB.-----------------------------------------------------------------------------
NB.  Measures
NB.-----------------------------------------------------------------------------

CreateMeasure =: 3 : 0
	spec =. y.
	'dims columns' =. spec GetValue ;:'Dimensions Columns'
	'dimids levelnums' =. dims GetValue ;:'TextId Level'
	levelnums =. MakeNumbers levelnums
	levelinds =. levelnums FindLevels dimids
	if. ((<elistId)e.dimids)*.-.elistLevel e. levelinds do.
		Warn EW_WARNING_MEASURE_ELIST_LEVEL,EW_ACTION_IGNORE
		Return
		return.
	end.
	identity =. GetIdentity spec
	hMeasure =. 'AdaytumDCube' CreateNamedObject 0 {:: identity
	vhDims =. levelinds { LevelAggLists
	'id caption' =. identity
	hList =. 'AdaytumDList' CreateNamedObject id;'_Measures'
	'ids captions roles types scales decs aggtypes timeaggs refs' =. columns GetTextColumns 'TextId';'Caption';'Role';'Type';'Scale';'Decimals';'Aggregation';'Semi-Aggregate';'Reference'
	'ids captions types scales decs aggtypes timeaggs refs' =. (roles e. <'Attribute') #L:0 _1 ids;captions;types;scales;decs;aggtypes;timeaggs;<refs
	types =. MeasureTypeFromText&> types
	scales =. MakeNumbers scales
	decs =. MakeNumbers decs
	captions =. captions SetBaseCaption L:0 ids
	noaggtype =. bx 0 = #&>aggtypes
	aggtypes =. (DefaultAggregationFromType noaggtype{types) noaggtype } aggtypes
	adjustments =. timeaggs AggregationAdjustment L:0 aggtypes
	aggregates =. IsAggregable adjustments
	guids =. hList GetItemGuids ids
	'formats types' =. <"1 |: refs GetTypeFormat&> <"1 types,.scales,.decs
	cube =. (id;CUBE_TYPE_FACT;hMeasure;hList;<levelinds) RegisterCubeMeasures ids;captions;types;ROLE_IMPORT;guids;aggregates;formats;<adjustments
	PopulateMeasureList cube
	ewcheckrx hMeasure SetDimensions_IDCubeEdit_ vhDims,hList
	if. spec IsKey 'Data' do.
		hMeasure PopulateCubeData columns;<spec GetValue 'Data'
	end.
	ApplyMeasureAccess hMeasure
	Return
)

NB.-----------------------------------------------------------------------------
NB.  Measure Lists
NB.-----------------------------------------------------------------------------

PopulateMeasureList =: 3 : 0
	cube =. y.
	measures =. cube {:: CubeMeasures
	roles =. measures { MeasureRoles
	(measures;<roles) PopulateMeasureList cube
:
	'measures roles' =. x.
	cube =. y.
	levels =. cube {:: CubeLevels
	hList =. cube { CubeMeasureLists
	cubetype =. cube { CubeTypes
	'ids captions guids types adjustments formats' =. measures {L:0 _1 MeasureIds;MeasureCaptions;MeasureGuids;MeasureTypes;MeasureAdjustments;<MeasureFormats

	isref =. types = MEASURE_TYPE_REFERENCE
	roles =. ROLE_DATAENTRYLOOKUP (bx isref *. roles e. ROLE_DATAENTRY) } roles
	isrefpub =. isref *. roles e. ROLE_PUBLISH
	if. +./isrefpub do.
		'isrefpub measures ids captions guids types roles adjustments formats' =. (>:isrefpub)#L:0 _1 isrefpub;measures;ids;captions;guids;types;roles;adjustments;<formats
		islookup =. 2|+/\isrefpub
		ispubkey =. isrefpub *. -. islookup
		lookupinds =. bx islookup
		pubkeyinds =. bx ispubkey
		ids =. ((lookupinds{ids),L:0 '_LU') lookupinds } ids
		guids =. (CoCreateGuid"0 pubkeyinds) pubkeyinds } guids
		adjustments =. (<,'Z') pubkeyinds } adjustments
		formats =. (GetLevelDimensionKeyFormat&GetFormatReferenceLevel"0 pubkeyinds { formats) pubkeyinds } formats
		roles =. ROLE_PUBLISHLOOKUP lookupinds } ROLE_PUBLISHDIMKEY pubkeyinds } roles
	end.

	ismoney =. (MEASURE_TYPE_MONETARY = types) *. roles e. ROLE_DATAENTRY,ROLE_PUBLISH
	rates =. (ismoney#adjustments) FindExchangeRates levels
	if. 0 < # rates do.
		'ismoney measures ids captions guids types roles adjustments formats' =. (>:ismoney)#L:0 _1 ismoney;measures;ids;captions;guids;types;roles;adjustments;<formats
		isgroup =. 2|+/\ismoney
		islocal =. ismoney *. -. isgroup
		groupinds =. bx isgroup
		localinds =. bx islocal
		ids =. ((groupinds{ids),L:0 '_XTG') groupinds } ids
		ids =. ((localinds{ids),L:0 '_XTL') localinds } ids
		guids =. (hList GetItemGuids localinds { ids) localinds } guids
		adjustments =. (<,'Z') localinds } adjustments
		formats =. 0 localinds } formats
		uniquerates =. ~. rates
		rateinds =. uniquerates i. rates
		'rateids rateguids' =. uniquerates {L:0 _1 MeasureIds;MeasureGuids
		measures =. measures , uniquerates
		ismoney =. ismoney {.~ # ids
		ids =. ids , rateids
		captions =. captions , rateids
		guids =. guids , rateguids
		formats =. formats {.~ # ids
		adjustments =. adjustments , (<,'Z') #~# rateids
		calcs =. ('I:',L:0 (<"1 rateinds { rateguids) ,L:0 ';I:' ,L:0 (<"1 localinds { guids) ,L:0 ';F:multiply') groupinds } a:#~# ids
		priorities =. CALCPRIORITY_LOW groupinds } 0 #~# ids
		sequence =. (i.#groupinds) groupinds } 0 #~# ids
		if. cubetype = CUBE_TYPE_CONTRIBUTION do.
			roles =. ROLE_PUBLISHGROUP groupinds } ROLE_PUBLISHLOCAL localinds } roles , ROLE_CALCINPUTXRATE #~# rateids
		else.
			roles =. ROLE_DATAENTRYGROUP groupinds } ROLE_DATAENTRYLOCAL localinds } roles , ROLE_CALCINPUTXRATE #~# rateids
		end.
		hList PopulateList (ids;captions;guids;adjustments;calcs;priorities;sequence;<formats);<TABLE_ITEMNAME,TABLE_ITEMCAPTION,TABLE_ITEMGUID,DLIST_CALCADJUSTMENT,DLIST_CALCULATION,DLIST_CALCPRIORITY,DLIST_CALCSEQUENCE,:TABLE_ITEMFORMAT
	else.
		hList PopulateList (ids;captions;guids;adjustments;<formats);<TABLE_ITEMNAME,TABLE_ITEMCAPTION,TABLE_ITEMGUID,DLIST_CALCADJUSTMENT,:TABLE_ITEMFORMAT
	end.

	hList RegisterMeasureItems measures;ids;roles;guids
)

NB.-----------------------------------------------------------------------------
NB.  Contributions
NB.-----------------------------------------------------------------------------

CreateContribution =: 3 : 0
	spec =. y.
	'dims items' =. spec GetValue ;:'Dimensions Items'
	'dimids levelnums' =. dims GetValue ;:'TextId Level'
	levelnums =. MakeNumbers levelnums
	levelinds =. levelnums FindLevels dimids
	if. -. (<elistId) e. dimids do.
		Warn EW_WARNING_CONTRIB_NO_ELIST,EW_ACTION_IGNORE
		Return
	end.
	'id caption' =. GetIdentity spec
	hContribution =. 'AdaytumDCube' CreateNamedObject id
	hList =. 'AdaytumDList' CreateNamedObject id;'_contributions'
	TABLE_ITEMCAPTION EnsureColumnInTable hList
	vhDims =. levelinds { LevelAggLists
	'ids captions roles types scales decs aggtypes timeaggs refs' =. items GetTextColumns 'TextId';'Caption';'Role';'Type';'Scale';'Decimals';'Aggregation';'Semi-Aggregate';'Reference'
	types =. MeasureTypeFromText&> types
	scales =. MakeNumbers scales
	decs =. MakeNumbers decs
	captions =. captions SetBaseCaption L:0 ids
	noaggtype =. bx 0 = #&>aggtypes
	aggtypes =. (DefaultAggregationFromType noaggtype{types) noaggtype } aggtypes
	adjustments =. timeaggs AggregationAdjustment L:0 aggtypes
	guids =. hList GetItemGuids ids
	'formats types' =. <"1 |: refs GetTypeFormat&> <"1 types,.scales,.decs
	aggregates =. IsAggregable adjustments
	roles =. ROLE_PUBLISHCURRENCY (bx roles e. <'CurrencyCode') } ROLE_PUBLISH #~# roles

	cube =. (id;CUBE_TYPE_CONTRIBUTION;hContribution;hList;<levelinds) RegisterCubeMeasures ids;captions;types;roles;guids;aggregates;formats;<adjustments

	PopulateMeasureList cube

	ewcheckrx hContribution SetDimensions_IDCubeEdit_ vhDims,hList

	ApplyMeasureAccess hContribution

	(ROLE_PUBLISHCURRENCY,ROLE_CALCINPUTXRATE) LinkMeasuresByRole cube
		
	Return
)

NB.-----------------------------------------------------------------------------
NB.  Link Measures across cubes
NB.-----------------------------------------------------------------------------

LinkMeasuresByRole =: 3 : 0
	(0#0) LinkMeasuresByRole y.
:
	roles =. x.
	cube =. y.
	list =. cube { CubeMeasureLists
	items =. bx MeasureItemLists = list
	if. 0 < #,roles do.
		items =. items #~ (items { MeasureItemRoles) e. roles
	end.
	hCube =. cube { CubeCubes
	for_item. items do.
		select. item { MeasureItemRoles
		case. ROLE_PUBLISHCURRENCY do.
			levelinds =. cube {:: CubeLevels
			diminds =. levelinds { LevelDims

			currencyatts =. bx (CUBE_TYPE_ATTRIBUTE = MeasureCubes { CubeTypes) *. CurrencyLevel = GetFormatReferenceLevel"0 MeasureFormats
			if. 0 = # currencyatts do.
				continue.
			end.
			currattdims =. (;(currencyatts { MeasureCubes) { CubeLevels) { LevelDims

			if. +./ diminds e. currattdims do.
				curratt =. {. (currattdims e. diminds)#currencyatts
				(2 1 38$,(curratt{MeasureGuids),item{MeasureItemGuids)LinkMeasures ((curratt{MeasureCubes){CubeCubes),hCube
			end.
		case. ROLE_CALCINPUT;ROLE_CALCINPUTXRATE;ROLE_DISPLAY do.
			source =. CubeCubes {~ MeasureCubes {~ MeasureItemMeasures {~ item
			(,:item { MeasureItemGuids) LinkMeasures source,hCube
		case. ROLE_DATAENTRY do.
			target =. CubeCubes {~ MeasureCubes {~ MeasureItemMeasures {~ item
			(,:item { MeasureItemGuids) LinkMeasures hCube,target
		case. ROLE_DATAENTRYLOOKUP do.
			target =. CubeCubes {~ MeasureCubes {~ MeasureItemMeasures {~ item
			(,:item { MeasureItemGuids) LinkMeasures hCube,target
			(item { MeasureItemMeasures) LinkLookupDimKeys target
		case. ROLE_DATAENTRYLOCAL do.
			targetmeasure =. item { MeasureItemMeasures
			targetcube =. targetmeasure { MeasureCubes
			targetlist =. targetcube { CubeMeasureLists
			targetitem =. {.1{.bx (MeasureItemMeasures = targetmeasure) *. (MeasureItemLists = targetlist) *. MeasureItemRoles = ROLE_PUBLISHLOCAL
			if. 0 < targetitem do.
				targetguid =. targetitem { MeasureItemGuids
				(2 1 38$,(item,targetitem){MeasureItemGuids)LinkMeasures hCube,targetcube{CubeCubes
			end.
		case. do.
		end.
	end.
)

LinkLookupDimKeys =: 4 : 0
	measure =. x.
	tgtcube =. y.
	tgtcubeind =. CubeCubes i. tgtcube
	tgtlist =. tgtcubeind { CubeMeasureLists
	items =. bx (MeasureItemLists = tgtlist) *. MeasureItemMeasures = measure
	roles =. items { MeasureItemRoles
	keyitem =. {. items #~ roles = ROLE_PUBLISHLOOKUP
	tgtitem =. {. items #~ roles = ROLE_PUBLISHDIMKEY
	keyguid =. keyitem { MeasureItemGuids
	tgtguid =. tgtitem { MeasureItemGuids
	'tgtformats tgtguids' =. tgtlist GetColumn&.>TABLE_ITEMFORMAT;TABLE_ITEMGUID
	'keyind tgtind' =. tgtguids i. keyguid,:tgtguid
	srclookuplist =. GetFormatReferenceList keyind { tgtformats
	srclevel =. FindListLevels srclookuplist
	srccube =. srclevel { LevelKeyCubes
	srcdim =. srclevel { LevelDims
	srclist =. srcdim { DimensionKeyLists
	'srcids srcguids' =. srclist GetColumn&.> TABLE_ITEMNAME;TABLE_ITEMGUID
	srcguids =. srcguids #~ -. srcids e. GetShortName (srcdim {:: DimensionLevels) { LevelIds
	select. # srcguids
	case. 0 do.
	case. 1 do.
		srcguid =. {. srcguids
		hLink =. CreateFreeObject 'AdaytumLookupLink'
		ewcheckrx hLink SetMode_IDLinkEdit_ COMBINATIONFN_SET
		ewcheckrx hLink SetSource_IDLinkEdit_ srccube
		ewcheckrx hLink SetTarget_IDLinkEdit_ tgtcube
		ewcheckrx hLink SetCorrespondences_IDLinkEdit_ , (2 1 38$,srcguid,tgtguid) CreateItemAllocation srclist,tgtlist
		ewcheckrx hLink SetLookupDimension_ILookupLinkEdit_ tgtlist
		ewcheckrx hLink SetLookupCorrespondences_ILookupLinkEdit_ , CreateListMatch~ srclevel { LevelItemLists
		ewcheckrx hLink SetLookupItems_ILookupLinkEdit_ ,<,:keyguid
		ewcheckrx tgtcube SetUpdateLinks_IDCubeEdit_ hLink,~ ewcheckrx tgtcube GetUpdateLinks_IDCubeEdit_ ''
	case. do.
		(measure {:: MeasureIds) Warn EW_WARNING_MULTIKEY_LU_CON,EW_ACTION_IGNORE
	end.
)

NB.-----------------------------------------------------------------------------
NB.  Access Tables
NB.-----------------------------------------------------------------------------

CreateAccessTable =: 3 : 0
	spec =. y.
	identity =. GetIdentity spec
	'id caption' =. identity
	if. -. spec IsKey 'Columns' do.
		Warn EW_WARNING_NO_TABLE_COLUMNS,EW_ACTION_IGNORE
		Return
		return.
	end.
	if. -. spec IsKey 'Data' do.
		Warn EW_WARNING_NO_TABLE_DATA,EW_ACTION_IGNORE
		Return
		return.
	end.
	if. -. spec IsKey 'Items' do.
		Warn EW_WARNING_ACCESS_NO_MEASURES,EW_ACTION_IGNORE
		Return
		return.
	end.
	'columns data measures' =. spec GetValue ;:'Columns Data Items'
	
	'colids refs' =. columns GetValue ;:'TextId Reference'

	levels =. FindLevels refs
	if. 0 e. levels do.
		(V2TabString refs#~0=levels) Warn EW_WARNING_REFERENCE_NOT_FOUND,EW_ACTION_IGNORE
		Return
		return.
	end.
	if. 0 e. data IsKey colids do.
		(V2TabString colids#~-.data IsKey colids) Warn EW_WARNING_REFERENCE_NOT_FOUND,EW_ACTION_IGNORE
		Return
		return.
	end.

	data =. |:>data GetTextColumns colids
	'cubeids types' =. measures GetTextColumns 'Item';'Application Method'
	dims =. ~. levels { LevelDims
	items =. (data ,&# dims)$<''
	for_dim. dims do.
		lv =. dim = levels { LevelDims
		dimlevels =. lv # levels
		dimdata =. lv #"1 data
		dimlevel =. ({./: dimlevels { LevelNums) { dimlevels
		levelinds =. (dim { DimensionKeyLists) FindInColumn (lv#refs);<TABLE_ITEMNAME
		keys =. |: levelinds { GetCubeAsText dimlevel { LevelKeyCubes
		ukeys =. ~. keys
		levelitems =. (dimlevel { LevelItemLists) GetColumn TABLE_ITEMNAME
		keyedlevelitems =. keys </. levelitems
		dimitems =. (ukeys i. dimdata) { keyedlevelitems
		items = (#&>dimitems) # items
		items =. (;dimitems) dim_index }"0 1 items
	end.

	RegisterMask id;caption;dims;items;cubeids;<types
	Return
)

ApplyMeasureAccess =: 3 : 0
	hCube =. y.
	accesslevel =. ewcheckrx hCube GetAccessLevel_IDCubeEdit_''
	vhLists =. ewcheckrx hCube GetDimensions_ICube_ ''
	hMeasureList =. GetCubeMeasureList hCube
	vhLevelLists =. vhLists -. hMeasureList
	levels =. FindListLevels vhLevelLists
	dims =. levels { LevelDims
	vsMeasureIds =. hMeasureList GetColumn TABLE_ITEMNAME
	measures =. 0 -.~ FindMeasures vsMeasureIds
	cubes =. measures { MeasureCubes
	keyedmeasures =. cubes </. measures
	cubes =. ~. cubes
	hAccessTable =. 0
	for_cube. cubes do.
		cubeid =. cube { CubeIds NB. boxed
		cubemeasures =. cube_index {:: keyedmeasures
		measureexpr =. 'I:', , hMeasureList ItemGuidsFromNames cubemeasures { MeasureIds
		if. CUBE_TYPE_XRATE = cube { CubeTypes do.
			if. 0 = hAccessTable do.
				hAccessTable =. CreateFreeObject 'AdaytumAccessTable'
				ewcheckrx hAccessTable SetDimensions_IAccessTableEdit_ vhLists
				'measurecolid levelcolids' =. ({.;}.) hAccessTable GetAccessTableColumnIds hMeasureList , vhLevelLists
			end.
			ewcheckrx hAccessTable Append_ITableEdit_ ((,ACCESS_HIDDEN);<,<measureexpr);<ACCESSTABLE_LEVEL,:measurecolid
		else.
			masks =. bx ; cubeid e.L:1 MaskCubeIds
			types =. ((masks { MaskCubeIds) i.L:1 cubeid) {&> masks { MaskTypes
			dimsused =. 0 #~# dims
			cubeexprs =. 1 0$<''
			cubecolids =. EMPTY_GUID_LIST
			for_mask. masks do.
				oldcurrobj =. 'Access Table' SetCurrentObject ,:'TextId';mask {:: MaskNames
				maskdims =. mask {:: MaskDimensions
				if. +./ dimsused *. dims e. maskdims do.
					(>cubeid) Warn EW_WARNING_ACCESS_OVERLAP,EW_ACTION_IGNORE
					continue.
				end.
				if. +./ -. maskdims e. dims do.
					(>cubeid) Warn EW_WARNING_ACCESS_TOO_FINE,EW_ACTION_IGNORE
					continue.
				end.
				if. 'Exclusion' -: mask_index {:: types do.
					(>cubeid) Warn EW_WARNING_ACCESS_EXCL_NOTIMPL,EW_ACTION_IGNORE
					continue.
				end.
				dimsused =. dimsused +. dims e. maskdims
				maskdiminds =. dims i. maskdims
				maskitems =. mask {:: MaskItems
				maskexprs =. ($maskitems)$<''
				for_maskdim. maskdims do.
					dimlist =. (maskdim_index { maskdiminds) { vhLevelLists
					dimitemnames =. ',',~&.>dimlist GetColumn TABLE_ITEMNAME
					dimitemids =. dimlist GetColumn TABLE_ITEMGUID
					maskdimitems =. ',',~&.>maskdim_index {"1 maskitems
					maskitemexprs =. 'I:',L:0 (maskdimitems{.@E.&>"0 1 dimitemnames)<@,@#"1 _ dimitemids
					maskexprs =. maskitemexprs maskdim_index }"0 1 maskexprs
				end.
				if. 0 = hAccessTable do.
					hAccessTable =. CreateFreeObject 'AdaytumAccessTable'
					ewcheckrx hAccessTable SetDimensions_IAccessTableEdit_ vhLists
					'measurecolid levelcolids' =. ({.;}.) hAccessTable GetAccessTableColumnIds hMeasureList , vhLevelLists
				end.
				cubecolids =. cubecolids , maskdiminds { levelcolids
				cubeexprs =. ,.&.|: cubeexprs ,"1/ maskexprs
				RestoreCurrentObject oldcurrobj
			end.
			if. 0 ~: hAccessTable do.
				ewcheckrx hAccessTable Append_ITableEdit_ ((,ACCESS_NODATA);<,<measureexpr);<ACCESSTABLE_LEVEL,:measurecolid
				ewcheckrx hAccessTable Append_ITableEdit_ ((accesslevel#~#cubeexprs);<"1|:(<measureexpr),.cubeexprs);<ACCESSTABLE_LEVEL,measurecolid,cubecolids
			end.
		end.
	end.
	if. 0 ~: hAccessTable do.
		ewcheckrx hCube SetAccessTables_IDCubeEdit_ ,hAccessTable
		ewcheckrx hModel SetAccessTables_IModelEdit_ hAccessTable ,~ ewcheckrx hModel GetAccessTables_IModelEdit_ ''
	end.
)

NB.------------------------------------------------------------------------------
NB.  Dependence Sequence - important in order to be able to derive dimensionality
NB.------------------------------------------------------------------------------

CreateDerivedCubesInSequence =: 3 : 0
	old =. GetCurrentObject''
	formulae =. Specification GetValues 'Formula'
	allIds =. 0#a:
	depTable =. 0 2$a:
	specs =. 0#a:
	if. *#formulae do.
		allIds =. allIds , formulae GetValue L:_1 0 'TextId'
		depTable =. depTable , >,&.>/GetFormulaDependence &.> formulae
		specs =. specs , formulae
	end.
	derivations =. Specification GetValues 'Derivation'
	if. *#derivations do.
		allIds =. allIds , derivations GetValue L:_1 0 'TextId'
		depTable =. depTable , >,&.>/GetDerivationDependence &.> derivations
		specs =. specs , derivations
	end.
	sequence =. allIds GetDependenceSequence depTable
	isFormula =. (i.#allIds)<#formulae
	for_index. sequence do.
		spec =. index {:: specs
		if. index { isFormula do.
			'Formula' SetCurrentObject spec
			CreateFormula spec
		else.
			'Derivation' SetCurrentObject spec
			CreateDerivation spec
		end.
	end.
	RestoreCurrentObject old
)

GetDependenceSequence =: 3 : 0
	(~.{."1 y.)GetDependenceSequence y.
:
	original =. x.
	deptable =. y.
	'user uses' =. <"1|:deptable
	lv =. user *.&(e.&original) uses
	user =. lv # user
	uses =. lv # uses
	done =. original -. user , uses
	whilst. next *.&(*@#) uses do.
		next =. ~. uses -. user
		done =. done , next
		lv =. -. uses e. next
		uses =. lv # uses
		user =. lv # user
	end.
	'circular dependence' assert 0 = # uses
	original i. ~. done , original
)

GetFormulaDependence =: 3 : 0
	spec =. y.
	old =. 'Formula' SetCurrentObject spec
	id =. spec GetValue 'TextId'
	values =. (spec GetValue 'Parameters') GetValue 'Value'
	NB. values =. (-.IsNumber values)#values
	RestoreCurrentObject old
	dependence =. ((#values)#<id),.values
)

GetDerivationDependence =: 3 : 0
	spec =. y.
	old =. 'Derivation' SetCurrentObject spec
	id =. spec GetValue 'TextId'
	objects =. (spec GetValue 'Parameters') GetValue 'Object'
	RestoreCurrentObject old
	dependence =. ((#objects)#<id),.objects
)

NB.-----------------------------------------------------------------------------
NB.  Derived Dimensionality
NB.-----------------------------------------------------------------------------

ResultDimensionality =: 3 : 0
	(0#0) ResultDimensionality y.
:
	ignoredims =. x.
	measures =. y.
	RemoveDims =. 4 : 'x. #~ -. (x. { LevelDims) e. y.'
	resultlevels =. 0#0
	adjustments =. measures { MeasureAdjustments
	isagg =. IsAggregable adjustments
	istimeagg =. IsTimeAggregable adjustments
	isdist =. IsDistributable adjustments
	istimedist =. IsTimeDistributable adjustments
	cubes =. measures { MeasureCubes
	levels =. cubes { CubeLevels
	levels =. levels RemoveDims L:0  ignoredims
	if. elistDim e. (;levels) { LevelDims do.
		levels =. levels RemoveDims L:0 elistDim
		resultlevels =. resultlevels , elistLevel
	end.
	commonlevels =. > intersect L:0 / levels
	resultlevels =. resultlevels , commonlevels
	noncomlevels =. levels -. L:0 commonlevels
	if. 0 < # ; noncomlevels do.
		commondims =. ~. > intersect  L:0 / noncomlevels {L:0 LevelDims
		if. 0 < # commondims do.
			resultlevels =. resultlevels , commondims CommonDimensionLevel"0 1 measures
			noncomlevels =. noncomlevels RemoveDims L:0 commondims
		end.
		if. 0 < # ; noncomlevels do.
			candidates =. 0&,.@,.~ &.> noncomlevels
			for_measure. measures do.
				measurecandidates =. measure_index {:: candidates
				measurenoncomlevels =. measure_index {:: noncomlevels
				timescales =. (measurenoncomlevels { LevelDims) { DimensionIsTimescale
				if. measure_index { isagg do.
					corrs =. bx ({."1 CorrespondenceFromTo)e.(-.timescales)#measurenoncomlevels
					measurecandidates =. measurecandidates , corrs { CorrespondenceDistances ,. CorrespondenceFromTo
				end.
				if. measure_index { isdist do.
					corrs =. bx ({:"1 CorrespondenceFromTo)e.(-.timescales)#measurenoncomlevels
					measurecandidates =. measurecandidates , corrs { CorrespondenceDistances ,. |."1 CorrespondenceFromTo
				end.
				if. measure_index { istimeagg do.
					corrs =. bx (0=CorrespondenceDistances)*.({."1 CorrespondenceFromTo)e.timescales#measurenoncomlevels
					measurecandidates =. measurecandidates , corrs { CorrespondenceDistances ,. CorrespondenceFromTo
				end.
				if. measure_index { istimedist do.
					corrs =. bx (0=CorrespondenceDistances)*.({:"1 CorrespondenceFromTo)e.timescales#measurenoncomlevels
					measurecandidates =. measurecandidates , corrs { CorrespondenceDistances ,. |."1 CorrespondenceFromTo
				end.
				measurecandidates =. /:~measurecandidates NB. sort by distance then source
				candidates =. (<measurecandidates) measure_index } candidates
			end.
			candidatelevels =. {:"1 L:0 candidates
			candidatesources =. 1&{"1 L:0 candidates
			commoncandidates =. ~. > intersect L:0 / candidatelevels
			commoncandidates =. commoncandidates \: +/ > commoncandidates e.L:0 noncomlevels NB. sort by number of originals
			for_candidate. commoncandidates do.
				if. *./ candidate e.&> candidatelevels do.
					resultlevels =. resultlevels , candidate
					sources =. (candidatelevels i. L:0 candidate) {&.> candidatesources
					noncomlevels =. noncomlevels -. &.> sources
					candidatelevels =. (candidatesources =&.> sources) #&.> candidatelevels
					candidatesources =. candidatesources -.&.> sources
				end.
			end.
			if. 0 < # ; noncomlevels do.
				noncomlevellist =. ~. ; noncomlevels
				simplelists =. noncomlevellist #~ (1&=@#&>) DimensionLevels {~ noncomlevellist { LevelDims
				resultlevels =. resultlevels ,L:0 simplelists
				noncomlevels =. noncomlevels -.L:0 simplelists
			end.
			if. 0 < # ; noncomlevels do.
				resultlevels =. resultlevels , isagg CommonDimensionality noncomlevels
				noncomlevels =. 0 #L:0 noncomlevels
			end.
		end.
	end.
	resultlevels
)

NB. Formulae, derivations and grids must have only the correct elist at the correct level
NB. If they do not have the one and only elist then they will be assumption cubes and cannot be linked into

NB. If formulae, derivations and grids do not contain the eList they should still be possible.
NB. However all linking must be forced before packing (perhaps before the elist is chosen) and then all links might need to be removed.
NB. This is really only an issue for grids and formulae. Derivations must contain the elist anyway.
NB. This functionality is not yet implemented.

NB. Takes a list of measure indices and determine the dimensionality of their combination
NB. Returns a list of level indices
FormulaDimensionality =: 3 : 0
	measureinds =. y.
	aggregates =. measureinds { MeasureAggregates
	cubes =. measureinds { MeasureCubes
	levels =. cubes { CubeLevels
	reslevels =. aggregates CommonDimensionality levels
	reslevels
)

NB. Takes a list of measure indices and determine the dimensionality of their combination
NB. Returns a list of level indices. At the front are the levels of the dimensions in x. followed by the additional dimensions from the measures in y.
DerivationDimensionality =: 4 : 0
	dimensioninds =. x.
	measureinds =. y.
	aggregates =. measureinds { MeasureAggregates
	cubes =. measureinds { MeasureCubes
	levels =. cubes { CubeLevels
	dims =. levels {L:0 LevelDims

NB. calculate the appropriate levels of the dimensions provided
	dimlevels =. 0 #~# dimensioninds
	for_dimensionind. dimensioninds do.
		lv =. dimensionind e.&> dims
		if. +./lv do.
			vlv =. dimensionind =L:0 dims
			level =. {. (lv # aggregates) CommonDimensionality lv # vlv #&.> levels
		else.
			level =. GetDimensionBaseLevel dimensionind
		end.			
		dimlevels =. level dimensionind_index } dimlevels
	end.

NB. calculate remaining dimensionality
	reslevels =. dimlevels , aggregates CommonDimensionality (dims -.@e.L:0 dimensioninds) #L:0 levels
)

NB. Find the common level of a dimension shared by a group of measures
NB. If there are no measures or if none vary by the dimension then the level of finest grain is returned
CommonDimensionLevel =: 4 : 0
	dim =. x.
	dimlevels =. dim {:: DimensionLevels
	if. 1 = # dimlevels do.
		level =. {. dimlevels
	else.
		levelnums =. dimlevels { LevelNums
		measures =. y.
		cubes =. measures { MeasureCubes
		measurelevels =. (cubes { CubeLevels) intersect L:0 dimlevels
		if. 0 = # ; measurelevels do.
			levelnum =. >./ levelnums
		else.
			adjustments =. measures { MeasureAdjustments
			if. dim { DimensionIsTimescale do.
				isagg =. IsTimeAggregable adjustments
				isdist =. IsTimeDistributable adjustments
			else.
				isagg =. IsAggregable adjustments
				isdist =. IsDistributable adjustments
			end.
			if. 0 = +/ -. isdist #~*#&>measurelevels do.
				levelnum =. >./ (;measurelevels) { LevelNums
			else.
				levelnum =. (<./levelnums) >. <./ (; measurelevels #~ -. isdist) { LevelNums
			end.
		end.
		level =. dimlevels {~ levelnums i. levelnum
	end.
	level
)

NB. If there are any measures that are aggregable it is assumed that they do not duplicate and so we return their maximum common dimensionality and level
NB. If none are aggregable then all can duplicate where necessary so we return the union of their dimensionality at the finest level of detail
NB. x.	for each of y. whether the associated measure aggregates or not
NB. y.	a list of strict dimensionalities (a strict dimensionality is list of levels from disparate set of dimensions)
CommonDimensionality =: 4 : 0
	aggregates =. x.
	levels =. y.
	dims =. levels {L:0 LevelDims
	select. +/aggregates
	case. 0 do.
		resdims =. ~.;dims
		reslevelnums =. (;dims) >.//. (;levels) { LevelNums
	case. 1 do.
		ind =. aggregates i. 1
		resdims =. ind {:: dims
		reslevelnums =. (ind {:: levels) { LevelNums
	case. do.
		aggdims =. aggregates#dims
		resdims =. ~. >intersect&.>/aggdims
		allaggdims =. ;aggdims
		allagglevels =. ; aggregates # levels
		inresult =. allaggdims e. resdims
		dimindsinresult =. resdims i. inresult # ; aggdims
		reslevelnums =. dimindsinresult <.//. (inresult # ; aggregates # levels){LevelNums
		reslevelnums =. (/:~.dimindsinresult) { reslevelnums
	end.
	reslevels =. reslevelnums FindLevels resdims { DimensionIds
	reslevels =. elistLevel (bx elistDim = resdims) } reslevels
	reslevels
)

NB.-----------------------------------------------------------------------------
NB.  Links
NB.-----------------------------------------------------------------------------

NB.	1.	Lists common to both cubes are linked with MatchNames
NB. 2.	Different lists of the same level are linked with MatchGuids
NB.	3.	Different levels of the same dimension are linked with an allocation based on the appropriate column of the key cube of the lower level
NB.	4.	Unmatched source lists are summed
NB.	5.	Unmatched target lists are duplicated
LinkMeasures =: 4 : 0
	mgItems =. x.
	'hSrcCube hTgtCube hSrcList hTgtList' =. 4 {. y.

	vhSrcLists =. ewcheckrx hSrcCube GetDimensions_ICube_ ''
	vhTgtLists =. ewcheckrx hTgtCube GetDimensions_ICube_ ''
	if. 0 = hSrcList do.
		hSrcList =. GetCubeMeasureList hSrcCube
	end.
	if. 0 = hTgtList do.
		hTgtList =. GetCubeMeasureList hTgtCube
	end.
	vhSrcLists =. _0.1,vhSrcLists -. hSrcList
	vhTgtLists =. _0.2,vhTgtLists -. hTgtList

NB. Match the measure items according to x.
	vhCorrs =. , mgItems CreateItemAllocation hSrcList,hTgtList

NB. MatchNames for common lists
	commonlists =. vhSrcLists intersect vhTgtLists
	if. *#commonlists do.
		vhCorrs =. vhCorrs , CreateListMatch~"0 commonlists
		vhSrcLists =. vhSrcLists -. commonlists
		vhTgtLists =. vhTgtLists -. commonlists
	end.

NB. MatchGuids for different lists of the same level
	viSrcLevels =. FindListLevels vhSrcLists
	viTgtLevels =. FindListLevels vhTgtLists
	tgtinsrc =. (*viTgtLevels) * viSrcLevels FindOrZero viTgtLevels
	srcLevelsMatch =. (tgtinsrc -. 0) { vhSrcLists
	tgtLevelsMatch =. (0 < tgtinsrc) # vhTgtLists
	if. *#tgtLevelsMatch do.
		vhCorrs =. vhCorrs , srcLevelsMatch CreateListMatch"0 tgtLevelsMatch
		vhSrcLists =. vhSrcLists -. srcLevelsMatch
		vhTgtLists =. vhTgtLists -. tgtLevelsMatch
	end.

NB. Allocations for different levels of the same dimension
	viSrcLevels =. FindListLevels vhSrcLists
	viTgtLevels =. FindListLevels vhTgtLists
	'pairs tables' =. (}.viSrcLevels) FindLevelCorrespondences }.viTgtLevels
	for_pair. pairs do.
		'from to' =. pair
		'fromiids toiids' =. pair_index {:: tables
		hSrc =. vhSrcLists {~ viSrcLevels i. from
		hTgt =. vhTgtLists {~ viTgtLevels i. to
		vgSrcItems =. hSrc ItemGuidsFromIds fromiids
		vgTgtItems =. hTgt ItemGuidsFromIds toiids
		vhCorrs =. vhCorrs , (vgSrcItems,:vgTgtItems) CreateItemAllocation hSrc,hTgt
	end.
	vhSrcLists =. vhSrcLists #~ -. viSrcLevels e. {."1 pairs
	vhTgtLists =. vhTgtLists #~ -. viTgtLevels e. {: "1 pairs

	vhSrcLists =. }. vhSrcLists
	vhTgtLists =. }. vhTgtLists

NB. Source selection for unmatched source lists
	if. *#vhSrcLists -. vhTgtLists do.
		vhCorrs =. vhCorrs , 0 CreateDimSelnCorr"0 vhSrcLists -. vhTgtLists
	end.

NB. Target selection for unmatched target lists
	if. *#vhTgtLists -. vhSrcLists do.
		vhCorrs =. vhCorrs , 1 CreateDimSelnCorr"0 vhTgtLists -. vhSrcLists
	end.

	hLink =. CreateFreeObject 'AdaytumDLink'
	ewcheckrx hLink SetMode_IDLinkEdit_ COMBINATIONFN_SET
	ewcheckrx hLink SetSource_IDLinkEdit_ hSrcCube
	ewcheckrx hLink SetTarget_IDLinkEdit_ hTgtCube
	ewcheckrx hLink SetCorrespondences_IDLinkEdit_ vhCorrs

	ewcheckrx hTgtCube SetUpdateLinks_IDCubeEdit_ hLink,~ ewcheckrx hTgtCube GetUpdateLinks_IDCubeEdit_ ''

	hLink
)

CreateDimSelnCorr =: 4 : 0
	isTgt =. x.
	hDim =. y.
	
	hDimSel =. CreateFreeObject 'AdaytumDimensionSelection'
	ewcheckrx hDimSel SetDimension_IDimensionSelectionEdit_ hDim
	ewcheckrx hDimSel SetSelectionExpression_IDimensionSelectionEdit_ 'F:all;F:detail'
	
	hSelnCorr =. CreateFreeObject 'AdaytumSelectionCorrespondence'
	ewcheckrx hSelnCorr SetSelection_ISelectionCorrespondenceEdit_ hDimSel
	ewcheckrx hSelnCorr SetIsTarget_ISelectionCorrespondenceEdit_ isTgt
	hSelnCorr
)

CreateItemSelnCorr =: 4 : 0
	isTgt =. x.
	'hDim sItem' =. y.
	
	hDimSel =. CreateFreeObject 'AdaytumDimensionSelection'
	ewcheckrx hDimSel SetDimension_IDimensionSelectionEdit_ hDim
	ewcheckrx hDimSel SetSelectionExpression_IDimensionSelectionEdit_ 'I:',hDim GetItemGuid sItem
	
	hSelnCorr =. CreateFreeObject 'AdaytumSelectionCorrespondence'
	ewcheckrx hSelnCorr SetSelection_ISelectionCorrespondenceEdit_ hDimSel
	ewcheckrx hSelnCorr SetIsTarget_ISelectionCorrespondenceEdit_ isTgt
	
	hSelnCorr
)

CreateItemAllocation =: 4 : 0
	if. 2 = #$ x. do.
		vgSrcItems =. vgTgtItems =. x.
	else.
		'vgSrcItems vgTgtItems' =. <"_1 x.
	end.
	'hSrc hTgt' =. y.
	hAlloc =. CreateFreeObject 'AdaytumAllocation'
	ewcheckrx hAlloc SetSourceDimension_IAllocationEdit_ hSrc
	ewcheckrx hAlloc SetTargetDimension_IAllocationEdit_ hTgt
	hAllocTab =. CreateFreeObject 'AdaytumAllocationTable'
	ewcheckrx hAlloc SetAllocationTable_IAllocationEdit_ hAllocTab
	hTabEdit =. ewcheckrx hAllocTab GetAllocationTableForWrite_IAllocationTableEdit_''
	ewcheckrx hTabEdit SetLeftDimension_IAllocationTableEdit_ hSrc
	ewcheckrx hTabEdit SetRightDimension_IAllocationTableEdit_ hTgt
	allcolnames =. ewcheckrx hTabEdit GetAllColumnNames_ITableRead_''
	allcolids =. ewcheckrx hTabEdit GetAllColumnIds_ITableRead_''
	colids =. allcolids {~ allcolnames i. U2W ;: 'Left Right Negate'
	ewcheckrx hTabEdit Append_ITableEdit_ (vgSrcItems;vgTgtItems;<0#~#vgTgtItems);<colids
	hAlloc
)

CreateListMatch =: 4 : 0
	if. x. = y. do.
		hCorr =. CreateFreeObject 'AdaytumMatchNames'
		ewcheckrx hCorr SetSourceDimension_IMatchNamesEdit_ y.
		ewcheckrx hCorr SetTargetDimension_IMatchNamesEdit_ y.
	else.
		hCorr =. CreateFreeObject 'AdaytumMatchGuids'
		ewcheckrx hCorr SetSourceDimension_IMatchGuidsEdit_ x.
		ewcheckrx hCorr SetTargetDimension_IMatchGuidsEdit_ y.
	end.
	hCorr
)

CreateInterLevelAllocation =: 4 : 0
	hSrcList =. x.
	hTgtList =. y.
	srclevel =. FindListLevels hSrcList
	tgtlevel =. FindListLevels hTgtList
	dim =. srclevel { LevelDims
	assert dim = tgtlevel { LevelDims
	dimlevels =. dim {:: DimensionLevels

	srcnum =. srclevel { LevelNums
	tgtnum =. tgtlevel { LevelNums
	if. srcnum > tgtnum do.
		srcnames =. (srclevel { LevelItemLists) GetColumn TABLE_ITEMNAME
		tgtnames =. }.L:0 ,L:0/',',L:0 ] (>:dimlevels i. tgtlevel) {. GetCubeAsText srclevel { LevelKeyCubes
	else.
		srcnames =. }.L:0 ,L:0/',',L:0 ] (>:dimlevels i. srclevel) {. GetCubeAsText tgtlevel { LevelKeyCubes
		tgtnames =. (tgtlevel { LevelItemLists) GetColumn TABLE_ITEMNAME
	end.
	srcguids =. hSrcList ItemGuidsFromNames srcnames
	tgtguids =. hTgtList ItemGuidsFromNames tgtnames

	hAlloc =. (srcguids,:tgtguids)CreateItemAllocation hSrcList,hTgtList
	hAlloc
)

CopyLinkCorrespondence =: 4 : 0
	objsubmap =. x.
	corr =. y.
	vhSourceDims =. ewcheckrx corr GetSourceDimensions_ICorrespondence_ ''
	vhTargetDims =. ewcheckrx corr GetTargetDimensions_ICorrespondence_ ''
	vhNewSrcDims =. objsubmap GetValue vhSourceDims
	vhNewTgtDims =. objsubmap GetValue vhTargetDims
	corrclass =. >GetObjectClass corr
	newcorr =. CreateFreeObject corrclass
	select. corrclass
	case. 'AdaytumAllocation' do.
		ewcheckrx newcorr SetSourceDimension_IAllocationEdit_ {.vhNewSrcDims
		ewcheckrx newcorr SetTargetDimension_IAllocationEdit_ {.vhNewTgtDims
		ewcheckrx newcorr SetSourceSubColumns_IAllocationEdit_ ewcheckrx corr GetSourceSubColumns_IAllocationEdit_ ''
		ewcheckrx newcorr SetTargetSubColumns_IAllocationEdit_ ewcheckrx corr GetTargetSubColumns_IAllocationEdit_ ''
		ewcheckrx newcorr SetCaseSensitive_IAllocationEdit_ ewcheckrx corr GetCaseSensitive_IAllocationEdit_ ''
		ewcheckrx newcorr SetDumpItem_IAllocationEdit_ ewcheckrx corr GetDumpItem_IAllocationEdit_ ''
		alloctab =. ewcheckrx corr GetAllocationTable_IAllocationEdit_ ''
		select. >GetObjectClass alloctab
		case. 'AdaytumAllocationTable' do.
			newalloctab =. CreateFreeObject 'AdaytumAllocationTable'
			ewcheckrx newalloctab SetLeftDimension_IAllocationTableEdit_ {.vhNewSrcDims
			ewcheckrx newalloctab SetRightDimension_IAllocationTableEdit_ {.vhNewTgtDims
			rows =. ewcheckrx (3#alloctab) GetAllColumn_ITableRead_ <"1 GetAllocationTableColumnIds alloctab
			ewcheckrx newalloctab Append_ITableEdit_ rows;<GetAllocationTableColumnIds newalloctab
		case. 'AdaytumCubeAsAllocationTable' do.
			oldcubeseln =. ewcheckrx alloctab GetSelection_ICubeAsAllocationTableEdit_ ''
			oldcube =. ewcheckrx oldcubeseln GetCube_ICubeSelection_ ''
			if. oldcube ~: (objsubmap,oldcube) GetValue oldcube do.
				newcubeseln =. CreateFreeObject 'AdaytumCubeSelection'
				newrowaxis =. CreateFreeObject 'AdaytumAxis'
				newcolaxis =. CreateFreeObject 'AdaytumAxis'
				'oldrowaxis oldcolaxis' =. ewcheckrx oldcubeseln GetAxes_ICubeSelection_ ''
				ewcheckrx newrowaxis SetDimensions_IAxisEdit_ objsubmap GetValue ewcheckrx oldrowaxis GetDimensions_IAxis_ ''
				ewcheckrx newcolaxis SetDimensions_IAxisEdit_ objsubmap GetValue ewcheckrx oldcolaxis GetDimensions_IAxis_ ''
				ewcheckrx newrowaxis Append_ITableEdit_ (checkrx oldrowaxis GetAll_ITableRead_'');<checkrx newrowaxis GetAllColumnIds_ITableRead_ ''
				ewcheckrx newcolaxis Append_ITableEdit_ (checkrx oldcolaxis GetAll_ITableRead_'');<checkrx newcolaxis GetAllColumnIds_ITableRead_ ''
				ewcheckrx newcubeseln SetCube_ICubeSelectionEdit_ objsubmap GetValue oldcube
				ewcheckrx newcubeseln SetAxes_ICubeSelectionEdit_ newrowaxis,newcolaxis
				newcubeasalloc =. CreateFreeObject 'AdaytumCubeAsAllocationTable'
				ewcheckrx newcubeasalloc SetSelection_ICubeAsAllocationTableEdit_ newcubeseln
				ewcheckrx newcubeasalloc SetDataAsRightSide_ICubeAsAllocationTableEdit_ ewcheckrx alloctab GetDataAsRightSide_ICubeAsAllocationTableEdit_ ''
			else.
				newalloctab =. alloctab
			end.
		end.
		ewcheckrx newcorr SetAllocationTable_IAllocationEdit_ newalloctab
	case. 'AdaytumMatchGuids' do.
		ewcheckrx newcorr SetSourceDimension_IMatchGuidsEdit_ {.vhNewSrcDims
		ewcheckrx newcorr SetTargetDimension_IMatchGuidsEdit_ {.vhNewTgtDims
		ewcheckrx newcorr SetTargetCalculations_IMatchGuidsEdit_ ewcheckrx corr GetTargetCalculations_IMatchGuidsEdit_ ''
	case. 'AdaytumMatchNames' do.
		ewcheckrx newcorr SetSourceDimension_IMatchNamesEdit_ {.vhNewSrcDims
		ewcheckrx newcorr SetTargetDimension_IMatchNamesEdit_ {.vhNewTgtDims
		ewcheckrx newcorr SetSourceSubColumns_IMatchNamesEdit_ ewcheckrx corr GetSourceSubColumns_IMatchNamesEdit_ ''
		ewcheckrx newcorr SetTargetSubColumns_IMatchNamesEdit_ ewcheckrx corr GetTargetSubColumns_IMatchNamesEdit_ ''
		ewcheckrx newcorr SetCaseSensitive_IMatchNamesEdit_ ewcheckrx corr GetCaseSensitive_IMatchNamesEdit_ ''
		ewcheckrx newcorr SetDumpItem_IMatchNamesEdit_ ewcheckrx corr GetDumpItem_IMatchNamesEdit_ ''
		ewcheckrx newcorr SetTargetCalculations_IMatchNamesEdit_ ewcheckrx corr GetTargetCalculations_IMatchNamesEdit_ ''
	case. 'AdaytumSelectionCorrespondence' do.
		seln =. ewcheckrx corr GetSelection_ISelectionCorrespondenceEdit_ ''
		dim =. ewcheckrx seln GetDimension_IDimensionSelection_ ''
		newseln =. CreateFreeObject 'AdaytumDimensionSelection'
		ewcheckrx newseln SetDimension_IDimensionSelectionEdit_ objsubmap GetValue dim
		ewcheckrx newseln SetSelectionExpression_IDimensionSelectionEdit_ ewcheckrx seln GetSelectionExpression_IDimensionSelectionEdit_ ''
		ewcheckrx newcorr SetSelection_ISelectionCorrespondenceEdit_ newseln
		ewcheckrx newcorr SetIsTarget_ISelectionCorrespondenceEdit_ ewcheckrx corr GetIsTarget_ISelectionCorrespondenceEdit_ ''
	case. do.
		'Unsupported template link correspondence' assert 0
	end.
	newcorr
)

NB.-----------------------------------------------------------------------------
NB.  Formulae
NB.-----------------------------------------------------------------------------

CreateFormula =: 3 : 0
	spec =. y.
	'id caption' =. GetIdentity spec
	hFormula =. 'AdaytumDCube' CreateNamedObject id
	guid =. GetObjectId hFormula
	hList =. 'AdaytumDList' CreateNamedObject id;'_calculation'
	'expr parmtab' =. spec GetValue ;:'Expression Parameters'
	'parms vals' =. parmtab GetValue ;:'Parameter Value'
	if. spec IsKey 'Type' do.
		type =. MeasureTypeFromText spec GetValue 'Type'
	else.
		type =. MEASURE_TYPE_NUMBER
	end.
	if. spec IsKey 'Scale' do.
		scale =. MakeNumber spec GetValue 'Scale'
	else.
		scale =. 0
	end.
	if. spec IsKey 'Decimals' do.
		decs =. MakeNumber spec GetValue 'Decimals'
	else.
		decs =. 0
	end.

	format =. GetTypeFormat type,scale,decs
	measureinds =. FindMeasures vals
	isMeasure =. 0 < measureinds
	measureinds =. isMeasure # measureinds
	'vhParmCubes guids types captions formats adjustments' =. measureinds {L:0 _1 (MeasureCubes{CubeCubes);MeasureGuids;(MeasureCubes{CubeTypes);MeasureCaptions;MeasureFormats;<MeasureAdjustments
	measures =. isMeasure # vals
	expr =. ((-.isMeasure)#parms,.vals) ReplaceParameterConstants expr
	expr =. ParseExpression expr
	expr =. ((isMeasure#parms),.<"1 guids) ReplaceParameterItems expr
	ids =. id ; isMeasure # parms

	aggregation =. timeagg =. ''
	if. spec IsKey 'Aggregation' do.
		aggregation =. spec GetValue 'Aggregation'
	end.
	if. spec IsKey 'Time Aggregation' do.
		timeagg =. spec GetValue 'Time Aggregation'
	end.
	if. '' -: aggregation do.
		aggregation =. DefaultAggregationFromType type
	end.
	adjustment =. timeagg AggregationAdjustment aggregation

	isaggregable =. IsAggregable adjustment

	levelinds =. ResultDimensionality measureinds

	cube =. (id;CUBE_TYPE_FORMULA;hFormula;hList;<levelinds) RegisterCubeMeasures (,<id);(,<caption);(,type);ROLE_FORMULA;(,:guid);(,isaggregable);(,format);<,<adjustment
	formula =. {. cube {:: CubeMeasures

	DLIST_CALCULATION EnsureColumnInTable hList
	((formula,measureinds);<ROLE_FORMULA,ROLE_CALCINPUT #~# measureinds) PopulateMeasureList cube

	priority =. (IsAggregable adjustment) { CALCPRIORITY_HIGH , CALCPRIORITY_LOW
	ewcheckrx hList SetCell_ITableEdit_ (<expr);0;DLIST_CALCULATION
	ewcheckrx hList SetCell_ITableEdit_ priority;0;DLIST_CALCPRIORITY
	ewcheckrx hList SetCell_ITableEdit_ 0;0;DLIST_CALCSEQUENCE
	ewcheckrx hList SetCell_ITableEdit_ format;0;TABLE_ITEMFORMAT
	
	vhDims =. hList ,~ levelinds { LevelAggLists
	ewcheckrx hFormula SetDimensions_IDCubeEdit_ vhDims

	vvgParms =. vhParmCubes </. guids
	vhParmCubes =. ~. vhParmCubes
	ewcheckrx hFormula SetMeasuresDimension_IDCubeEdit_ 0
	
	vvgParms LinkMeasures&.> vhParmCubes,&.>hFormula

	PopulateIfAssumption hFormula	

	formula TestFormula spec

	ApplyMeasureAccess hFormula

	Return
)

ReplaceParameterConstants =: 4 : 0
	'parms vals' =. <"1|:x.
	tokens =. TokeniseExpression y.
	repinds =. bx tokens e. parms
	tokens =. ((parms i. repinds { tokens){vals) repinds } tokens
	FormExpression tokens
)

ReplaceParameterItems =: 4 : 0
	'parms guids' =. <"1|:x.
	stack =. ';',y.
	isparm =. _3 |. ';I:' E. stack
	stack =. }. (((-.isparm)#stack),,((;parms)i.isparm#stack){>guids)/:(bx-.isparm),38#bx isparm
)

Monads =: MapFromString 0 : 0
+		;F:sum
-		;F:negate
~		;C:0;F:equal
NOT		;C:0;F:equal
)

Dyads =: MapFromString 0 : 0
+		;F:add
-		;F:subtract
*		;F:multiply
/		;F:divide
=		;F:equal
|		;F:or
OR		;F:or
&		;F:and
AND		;F:and
^		;F:power
!=		;F:notequal
<>		;F:notequal
>		;F:greater
>=		;F:greaterorequal
<		;F:less
<=		;F:lessorequal
)

DyadStrengths =: MapFromString 0 : 0
^		7
*		6
/		6
+		5
-		5
>		4
>=		4
<		4
<=		4
=		3
!=		3
<>		3
&		2
AND		2
|		1
OR		1
)

Controls =: MapFromString 0 : 0
IF		ControlIfThenElse
SELECT	ControlSelectCase
)

TOKEN_TYPE_INVALID	=: 0
TOKEN_TYPE_SUBEXPR	=: 1
TOKEN_TYPE_PARAM	=: 2
TOKEN_TYPE_CONTROL	=: 3
TOKEN_TYPE_MONAD	=: 4
TOKEN_TYPE_DYAD		=: 5
TOKEN_TYPE_OPERATOR	=: 6
TOKEN_TYPE_CONSTANT	=: 7

IsValueType =: e.&(TOKEN_TYPE_SUBEXPR,TOKEN_TYPE_PARAM,TOKEN_TYPE_CONSTANT,TOKEN_TYPE_INVALID)
IsOperatorType =: e.&(TOKEN_TYPE_MONAD,TOKEN_TYPE_DYAD,TOKEN_TYPE_OPERATOR)
IsMonadType =: e.&(TOKEN_TYPE_MONAD,TOKEN_TYPE_OPERATOR)
IsDyadType =: e.&(TOKEN_TYPE_DYAD,TOKEN_TYPE_OPERATOR)
IsControlType =: =&TOKEN_TYPE_CONTROL

TokenType =: 3 : 0
	token =. y.
	if. '()' -: ({.,{:)token do.
		TOKEN_TYPE_SUBEXPR
		return.
	end.
	if. (<token) e. ParameterNames do.
		TOKEN_TYPE_PARAM
		return.
	end.
	if. (<token) e. ControlWords do.
		TOKEN_TYPE_CONTROL
		return.
	end.
	if. (<token) e. StrictMonadNames do.
		TOKEN_TYPE_MONAD
		return.
	end.
	if. (<token) e. StrictDyadNames do.
		TOKEN_TYPE_DYAD
		return.
	end.
	if. (<token) e. AmbivalentOperatorNames do.
		TOKEN_TYPE_OPERATOR
		return.
	end.
	if. _. ~: _. MakeNumber token do.
		TOKEN_TYPE_CONSTANT
		return.
	end.
	TOKEN_TYPE_INVALID
)

ControlIfThenElse =: 3 : 0
	;:'IF THEN ELSE'
:
	stack =. x.
	tokens =. y.
	controlinds =. bx tokens e. ;:'IF THEN ELSE'
	controls =. controlinds { tokens
	base =. 1,2*./\2 > +/\ (controls e. <'IF') - (controls e. <'ELSE') + 0,2*./\controls e. <'THEN'
	'thenpos elsepos' =. ((base#controls) i.'THEN';'ELSE'){ (base#controlinds),#tokens
	stack =. stack ParseExpression (1+thenpos) }. elsepos {. tokens
	if. elsepos = #tokens do.
		stack =. stack , Constant 0
	else.
		stack =. stack ParseExpression (1+elsepos) }. tokens
	end.
	stack =. stack ParseExpression }. thenpos {. tokens
	stack , ';F:ifthenelse'
)

ControlSelectCase =: 3 : 0
	;:'SELECT CASE THEN CASE THEN ELSE'
:
	stack =. x.
	tokens =. y.
1+a. TODO
	controlinds =. bx tokens e. ;:'IF THEN ELSE'
	controls =. controlinds { tokens
	base =. 1,2*./\2 > +/\ (controls e. <'IF') - (controls e. <'ELSE') + 0,2*./\controls e. <'THEN'
	'thenpos elsepos' =. ((base#controls) i.'THEN';'ELSE'){ (base#controlinds),#tokens
	stack =. stack ParseExpression (1+thenpos) }. elsepos {. tokens
	if. elsepos = #tokens do.
		stack =. stack , Constant 0
	else.
		stack =. stack ParseExpression (1+elsepos) }. tokens
	end.
	stack =. stack ParseExpression }. thenpos {. tokens
	stack , ';F:ifthenelse'
)

ControlWords =: (3 : ('r=.''''';('r=.r,',L:0(GetAllValues Controls),L:0''''''),<,'~.r'))'' 
WordChars =: a. {~ (a.i.'A')+i.26
ParameterNames =: ,&.>WordChars
AllMonadNames =: GetKeys Monads
AllDyadNames =: GetKeys Dyads
StrictMonadNames =: AllMonadNames -. AllDyadNames
StrictDyadNames =: AllDyadNames -. AllMonadNames
AllOperatorNames =: AllMonadNames , StrictDyadNames
SortedOperatorNames =: (\:(#&>)) AllOperatorNames
AmbivalentOperatorNames =: AllMonadNames -. StrictMonadNames

TokeniseExpression =: 3 : 0
	expression =. y.
	issubchar =. (expression=')') +. 0 < +/\(expression='(')-expression=')'
	iswordchar =. issubchar < expression e. WordChars
	isopchar =. (issubchar+.iswordchar) < expression e. ; AllOperatorNames
	isconchar =. (issubchar+.iswordchar+.isopchar) < expression ~: ' '
	istokenchar =. issubchar+.iswordchar+.isopchar+.isconchar
	istokenstart =. (2</\0,issubchar) +. (2</\0,iswordchar) +. (2</\0,isopchar) +. 2</\0,isconchar
	key =. +/\ istokenstart
	tokens =. key </.&(istokenchar&#)expression
	isoptoken =. istokenstart # isopchar
	optokens =. SplitOperatorToken &.> isoptoken # tokens
	tokens =. (((-.isoptoken)#tokens),;optokens)/:(bx-.isoptoken),;(#&>optokens)#&.>bx isoptoken
)

SplitOperatorToken =: 3 : 0
	token =. y.
	if. (<token)e. AllOperatorNames do.
		tokens =. ,<token
	else.
		tokens =. 0#<''
		while. 0 < #token do.
			ismatch =. SortedOperatorNames E.&> <token
			match =. ({."1 ismatch)i.1
			if. match = # ismatch do.
				badtoken =. ((+./ismatch)i.1){.token
				tokens =. tokens , <badtoken
				token =. (#badtoken) }. token
			else.
				matchtoken =. match {:: SortedOperatorNames
				tokens =. tokens , <matchtoken
				token =. (#matchtoken) }. token
			end.
		end.
	end.
	tokens
)

ParseExpression =: 3 : 0
	}.'' ParseExpression toupper y.
:
	stack =. x.
	tokens =. TokeniseExpression^:(0=L.y.) y.
	select. #tokens
	case. 1 do.
		token =. 0 {:: tokens
		select. TokenType token
		case. TOKEN_TYPE_INVALID do.
			token Warn EW_WARNING_EXP_INVALID_CONSTANT,EW_ACTION_USE_ZERO
			stack =. stack , Constant 0
		case. TOKEN_TYPE_SUBEXPR do.
			stack =. stack ParseExpression }. }: token
		case. TOKEN_TYPE_PARAM do.
			stack =. stack , ';I:',token,''
		case. TOKEN_TYPE_CONTROL do.
			token Warn EW_WARNING_EXP_INVALID_CONTROL,EW_ACTION_USE_ZERO
			stack =. stack , Constant 0
		case. TOKEN_TYPE_MONAD,TOKEN_TYPE_DYAD,TOKEN_TYPE_OPERATOR do.
			token Warn EW_WARNING_EXP_INVALID_OPERATOR,EW_ACTION_USE_ZERO
			stack =. stack , Constant 0
		case. TOKEN_TYPE_CONSTANT do.
			stack =. stack , Constant token
		end.
	case. 2 do.
		'monad right' =. tokens
		stack =. stack ParseExpression right
		stack =. stack , Monads GetValue monad
	case. 3 do.
		'left dyad right' =. tokens
		stack =. stack ParseExpression left
		stack =. stack ParseExpression right
		stack =. stack , Dyads GetValue dyad
	case. do.
		if. ({.tokens)e. GetKeys Controls do.
			stack =. stack (Controls GetValue 0{::tokens)f. tokens
		else.
			expression =. FormExpression tokens
			if. +./tokens e. GetKeys Controls do.
				expression Warn EW_WARNING_EXP_INVALID_CONTROL,EW_ACTION_USE_ZERO
				stack =. stack , Constant 0
			else.
				newexpression =. ImplementOperatorPrecedence expression
				if. expression -: newexpression do.
					expression Warn EW_WARNING_EXP_INVALID,EW_ACTION_USE_ZERO
					stack =. stack , Constant 0
				else.
					stack =. stack ParseExpression newexpression
				end.
			end.
		end.
	end.
	stack
)

Constant =: 3 : 0
	';C:',": y.
)

ImplementOperatorPrecedence =: 3 : 0
	expression =. y.
	whilst. repeat do.
		repeat =. 0
		tokens =. TokeniseExpression expression
		types =. TokenType&>tokens
		lastdyad =. _.
		for_token. tokens do.
			token =. > token
			type =. token_index { types
			if. type = TOKEN_TYPE_OPERATOR do.
				if. IsValueType token_index{_1,types do.
					type =. TOKEN_TYPE_DYAD
				else.
					type =. TOKEN_TYPE_MONAD
				end.
				types =. type token_index } types
			end.
			if. IsDyadType type do.
				lastdyad =. token_index
			end.
			if. IsValueType type do.
				if. (IsMonadType token_index{_1,types)*.(token_index=1)+.IsOperatorType token_index{_1 _1,types do.
					repeat =. 1
					tokens =. (('(',(token_index-1){::tokens);token,')')(token_index-1 0) } tokens
				else.
					if. (0 < token_index)*.(lastdyad~:_.)*. token_index < (#tokens)-1 do.
						if. IsDyadType (token_index+1){types do.
							repeat =. 1
							if. </ MakeNumbers DyadStrengths GetValue (lastdyad,token_index+1){tokens do.
								token =. '(',token
							else.
								token =. token,')'
							end.
							lastdyad =. _.
							tokens =. (<token) token_index } tokens
						end.
					end.
				end.
			end.
		end.
		if. repeat do.
			expression =. CorrectlyParenthesise FormExpression tokens
		end.
	end.
	expression
)

FormExpression =: 3 : 0
	tokens =. y.
	}. ; ' ',&.> tokens
)

CorrectlyParenthesise =: 3 : 0
	expression =. y.
	left =. - <./ 0, +/\ ('('=expression) - expression=')'
	right =. - <./ 0, +/\ |. (expression=')') - '('=expression
	expression =. (left#'('),expression,right#')'
	expression
)

NB.-----------------------------------------------------------------------------
NB.  Derivations
NB.-----------------------------------------------------------------------------

LoadDerivationTemplates =: 3 : 0
	derivspecs =. Specification GetValues 'Derivation'
	if. 0 = # derivspecs do.
		DerivationTemplates =: 0 2$<''
	else.
		templates =. StripName derivspecs GetValue L:_1 0 'Template'
		DerivationTemplates =: templates,.<''
		for_template. templates do.
			name =. >template
			hTemplate =. ewcheckrx 0 Unpack DerivationTemplateXml GetValue name
			spec =. DerivationTemplateSpecs GetValue name
			'dims measures' =. spec GetValue ;:'Dimensions Measures'
			prefix =. 'Template_' , name , '_'

			cubes =. ewcheckrx hTemplate GetCubes_IModelEdit_''
			cubenames =. W2U GetObjectName cubes
			(U2W prefix ,L:0 cubenames) SetObjectName cubes
			0 SetParent cubes
		
			elist =. ewcheckrx hTemplate GetNodeList_IModelEdit_ ''
			ewcheckrx elist DeleteAll_ITableEdit_''
			guids =. ,:CoCreateGuid''
			elist PopulateHierarchy guids;(,<'Dummy');(<'Dummy');guids;<,1
			parmlistnames =. GetAllValues dims
			lists =. ewcheckrx hTemplate GetDimensions_IModelEdit_ ''
			listnames =. W2U GetObjectName lists
			(U2W prefix ,L:0 listnames) SetObjectName lists
			parmlists =. lists {~ listnames i. parmlistnames
			
			commonlists =. lists #~ -. (listnames e. parmlistnames) +. lists = elist
			copylists =. commonlists DetermineListsDependentOn parmlists , elist
			commonlists =. commonlists -. copylists
		
			if. 0<#commonlists do.
NB.				(U2W prefix ,L:0 W2U GetObjectName commonlists) SetObjectName commonlists
				0 SetParent commonlists
			end.
		
			assumptioncubes =. ewcheckrx hTemplate GetCubesWithoutNodeList_IModelEdit_ ''
			if. 0 < # assumptioncubes do.
				commoncubes =. assumptioncubes #~ (ewcheckrx assumptioncubes GetDimensions_ICube_ <'') *./@e.&> <commonlists
			else.
				commoncubes =. 0#0
			end.

			CUBE_TYPE_TEMPLATE RegisterCubes commoncubes;<0 #~#commoncubes
		
			spec =. spec , 'Handle';hTemplate
			spec =. spec , 'CubesToCopy';< cubes -. commoncubes
			spec =. spec , 'ListsToCopy';< copylists
			spec =. spec , 'ParameterLists';<(GetKeys dims),.<"0 parmlists
			spec =. spec , 'Lists';<listnames ,. <"0 lists
			spec =. spec , 'Cubes';<cubenames ,. <"0 cubes
		
			DerivationTemplates =: (name;<spec) template_index } DerivationTemplates
		end.
	end.
	Return
)

ListDependencies =: 3 : 0
	list =. y.
	if. TABLE_ITEMFORMAT e. ewcheckrx list GetAllColumnIds_ITableRead_ '' do.
		formats =. 0 -.~ ewcheckrx list GetAllColumn_ITableRead_ TABLE_ITEMFORMAT
		lookupformats =. formats #~ formats QueryInterface 'ILookupFormatEdit'
		if. 0<#lookupformats do.
			lookuptables =. ; ewcheckrx lookupformats GetTable_ILookupFormatEdit_ <''
		else.
			lookuptables =. 0#0
		end.
		lookuptables
	else.
		0#0
	end.
)

DetermineListsDependentOn =: 4 : 0
	candidates =. x.
	dependencies =. y.
	dependents =. 0#0
	whilst. 0 < # newdependents do.
		newdependents =. candidates #~ ; (ListDependencies &.> candidates) +./@e.&.> < dependents , dependencies
		candidates =. candidates -. newdependents
		dependents =. dependents , newdependents
	end.
	dependents
)

RemapListReferences =: 4 : 0
	hList =. x.
	refmap =. y.
	if. TABLE_ITEMFORMAT e. ewcheckrx hList GetAllColumnIds_ITableRead_ '' do.
		formats =. ewcheckrx hList GetAllColumn_ITableRead_ TABLE_ITEMFORMAT
		lvlookup =. (0~:formats) expand (formats-.0) QueryInterface 'ILookupFormatEdit'
		lookuptables =. lvlookup expand ; ewcheckrx (lvlookup#formats) GetTable_ILookupFormatEdit_ <''
		lvreplace =. lookuptables e. GetKeys refmap
		if. +./lvreplace do.
			replace =. lvreplace # lookuptables
			old =. ~. replace
			new =. 0 CreateReferenceFormat~"0 refmap GetValue old
			ewcheckrx hList Set_ITableEdit_ (new {~ old i. replace);(bx lvreplace);<,:TABLE_ITEMFORMAT
		end.
	end.
	Return
)

InsertDimensionsAfterEList =: 4 : 0
	dimlist =. x.
	toinsert =. y.
	splitpoint =. >: dimlist i. hEList
	newdimlist =. (splitpoint {. dimlist) , toinsert , splitpoint }. dimlist
	newdimlist
)

CreateDerivation =: 3 : 0
	spec =. y.
	identity =. GetIdentity spec
	'id caption' =. identity
	'parms objs' =. (spec GetValue 'Parameters') GetValue ;:'Parameter Object'
	parms =. 2 StripName parms

	if. spec IsKey 'Type' do.
		type =. MeasureTypeFromText spec GetValue 'Type'
	else.
		type =. MEASURE_TYPE_NUMBER
	end.

	parmmap =. parms ,. objs
	template =. DerivationTemplates GetValue StripName spec GetValue 'Template'
	'hTemplate cubestocopy listmap cubemap liststocopy parmlists measureparms resultparm' =. template GetValue ;:'Handle CubesToCopy Lists Cubes ListsToCopy ParameterLists Measures Result'

	aggregation =. timeagg =. ''
	if. spec IsKey 'Aggregation' do.
		aggregation =. spec GetValue 'Aggregation'
	else.
		if. template IsKey 'Aggregation' do.
			tempagg =. template GetValue 'Aggregation'
			if. tempagg IsKey 'Standard' do.
				aggregation =. tempagg GetValue 'Standard'
			end.
		end.
	end.
	if. spec IsKey 'Time Aggregation' do.
		timeagg =. spec GetValue 'Time Aggregation'
	else.
		if. template IsKey 'Aggregation' do.
			tempagg =. template GetValue 'Aggregation'
			if. tempagg IsKey 'Time' do.
				timeagg =. tempagg GetValue 'Time'
			end.
		end.
	end.
	if. '' -: aggregation do.
		aggregation =. DefaultAggregationFromType type
	end.
	adjustment =. timeagg AggregationAdjustment aggregation
	aggregates =. IsAggregable adjustment
	
	tempelist =. ewcheckrx hTemplate GetNodeList_IModelEdit_ ''
	tempcubenames =. GetKeys cubemap
	tempcubes =. ; cubemap GetValue tempcubenames
	templistnames =. GetKeys listmap
	templists =. ; listmap GetValue templistnames
	
	tempsublists =. ; GetAllValues parmlists
	subparms =. GetKeys parmlists
	subdimids =. parmmap GetValue subparms
	subdims =. FindDimensions subdimids
	
	if. 0 e. subdims do.
		(V2TabString (0=subdims)#subdimids)Warn EW_WARNING_DIMENSION_NOT_FOUND,EW_ACTION_IGNORE
		Return
		return.
	end.

	if. elistDim e. subdims do.
		Warn EW_WARNING_DIMENSION_PARM_ELIST,EW_ACTION_IGNORE
		Return
		return.
	end.

	inputmeasures =. FindMeasures parmmap GetValue GetKeys measureparms

	derivationlevels =. }.(elistDim,subdims) DerivationDimensionality inputmeasures
	sublevels =. (#subdims) {. derivationlevels
NB.	sublists =. sublevels { aggregates {:: LevelNonAggLists;<LevelAggLists
	sublists =. sublevels { LevelAggLists
	additionallevels =. (#subdims) }. derivationlevels
NB.	additionallists =. additionallevels { aggregates {:: LevelNonAggLists;<LevelAggLists
	additionallists =. additionallevels { LevelAggLists

NB. !!!!!!!!!! ELIST - which one at which level
NB. has to be the one and only EList else we are linking into assumption cubes
	
	listcopies =. CreateObjectCopy"0 liststocopy
	listsubmap =. (tempelist,tempsublists,liststocopy),.hEList,sublists,listcopies
	listcopies RemapListReferences &>< listsubmap
	listsubmap =. listsubmap , 2#"0 templists -. GetKeys listsubmap
	listnamemap =. ((templists i. GetKeys listsubmap){templistnames) ,. <"0 GetAllValues listsubmap
	
	inputcubes =. inputmeasures { MeasureCubes
	
	resultcube =. tempcubes {~ tempcubenames i. < resultparm GetValue 'Cube'
	resultdims =. ewcheckrx resultcube GetDimensions_ICube_ ''

	derivationdims =. listsubmap GetValue resultdims
	derivationdims =. derivationdims -. listnamemap GetValue resultparm GetValue 'List'
	derivationdims =. derivationdims InsertDimensionsAfterEList additionallists
	derivationlevels =. FindListLevels derivationdims

	if. -. aggregates do.
		NB. Replace all aggregating hierarchies with their non-aggregating forms
		NB. We must leave the aggregating elist as otherwise we cannot link into the cube
		derivationdims =. hEList (derivationlevels i. elistLevel) } derivationlevels { LevelNonAggLists
	end.
	
	NB. All cubes must be copied before any links are modified so that all substituted sources exist
	copiedcubes =. 0"0 cubestocopy

	for_hCube. cubestocopy do.
		vhDims =. listsubmap GetValue ewcheckrx hCube GetDimensions_ICube_ ''
		if. hEList e. vhDims do.
			vhDims =. vhDims InsertDimensionsAfterEList additionallists
		end.
		hNewCube =. 'AdaytumDCube' CreateNamedObject id;'_',W2U >GetObjectName hCube
		ewcheckrx hNewCube SetDimensions_IDCubeEdit_ vhDims
		ewcheckrx hNewCube SetBreakBackEnabled_IDCubeEdit_ ewcheckrx hCube GetBreakBackEnabled_IDCubeEdit_''
		ewcheckrx hNewCube SetBaseFormat_IDCubeEdit_ ewcheckrx hCube GetBaseFormat_IDCubeEdit_''
		copiedcubes =. hNewCube hCube_index } copiedcubes
	end.

	CUBE_TYPE_TEMPLATE RegisterCubes copiedcubes;<0 #~# copiedcubes

	cubenamemap =. ((tempcubes i. cubestocopy,tempcubes-.cubestocopy){tempcubenames) ,. <"0 copiedcubes , tempcubes -. cubestocopy

	objsubmap =. listsubmap , cubestocopy ,. copiedcubes
	
	NB. Link the parameters to the appropriate locations in the new cubes
	for_measureparm. measureparms do.
		'parmname spec' =. measureparm
		measure =. parmmap GetValue parmname
		ind =. FindMeasures measure
		(0<ind) assert~ 'Measure ',measure,' not found'
		hMeasureCube =. (ind { MeasureCubes) { CubeCubes
		gMeasureItem =. ind { MeasureGuids
		'cubename listname itemname' =. spec GetValue ;:'Cube List Item'
		hTgtCube =. cubenamemap GetValue cubename
		hTgtList =. listnamemap GetValue listname
		gTgtItem =. hTgtList GetItemGuid itemname
		(2 1 38$,gMeasureItem,gTgtItem) LinkMeasures hMeasureCube,hTgtCube,0,hTgtList
	end.

	NB. Make new copies of all inter-cube links, using existing correspondences and adding correspondences for the added dimensionality
	NB. We need to create all the cubes before any of the links so that all sources exist
	NB. If a link source is not part of the template then we don't change it and the added correspondences are full target selections
	for_cubes. copiedcubes ,. cubestocopy do.
		'hNewCube hCube' =. cubes
		if. hEList e. ewcheckrx hNewCube GetDimensions_ICube_'' do.
			vhLinks =. ewcheckrx hCube GetUpdateLinks_IDCubeEdit_''
			vhNewLinks =. 0"0 vhLinks
			for_hLink. vhLinks do.
				class =. >GetObjectClass hLink
				hNewLink =. CreateFreeObject class
				vhNewLinks =. hNewLink hLink_index } vhNewLinks
		
				hSource =. ewcheckrx hLink GetSource_IDLinkEdit_''
				hNewSource =. (cubestocopy i. hSource) { copiedcubes , hSource
				ewcheckrx hNewLink SetSource_IDLinkEdit_ hNewSource
				ewcheckrx hNewLink SetTarget_IDLinkEdit_ hNewCube
		
				oldcorrs =. ewcheckrx hLink GetCorrespondences_IDLinkEdit_''
				newcorrs =. 0 #~# oldcorrs
				for_corr. oldcorrs do.
					newcorrs =. (objsubmap CopyLinkCorrespondence corr) corr_index } newcorrs
				end.
				if. hEList e. ewcheckrx hNewSource GetDimensions_ICube_'' do.
					newcorrs =. newcorrs , CreateListMatch~"0 additionallists
				else.
					newcorrs =. newcorrs , 1 CreateDimSelnCorr"0 additionallists
				end.
				ewcheckrx hNewLink SetCorrespondences_IDLinkEdit_ newcorrs
		
				select. class
				case. 'AdaytumDLink' do.
				case. 'AdaytumConsolidationLink' do.
					ewcheckrx hNewLink SetConsolidationDimension_IConsolidationLinkEdit_ listsubmap GetValue ewcheckrx hLink GetConsolidationDimension_IConsolidationLinkEdit_ ''
					ewcheckrx hNewLink SetConsolidationCorrespondences_IConsolidationLinkEdit_ objsubmap CopyLinkCorrespondence"_ 0 ewcheckrx hLink GetConsolidationCorrespondences_IConsolidationLinkEdit_ ''
					ewcheckrx hNewLink SetConsolidationItems_IConsolidationLinkEdit_ ewcheckrx hLink GetConsolidationItems_IConsolidationLinkEdit_ ''
				case. 'AdaytumLookupLink' do.
					ewcheckrx hNewLink SetLookupDimension_ILookupLinkEdit_ listsubmap GetValue ewcheckrx hLink GetLookupDimension_ILookupLinkEdit_ ''
					ewcheckrx hNewLink SetLookupCorrespondences_ILookupLinkEdit_ objsubmap CopyLinkCorrespondence"_ 0 ewcheckrx hLink GetLookupCorrespondences_ILookupLinkEdit_ ''
					ewcheckrx hNewLink SetLookupItems_ILookupLinkEdit_ ewcheckrx hLink GetLookupItems_ILookupLinkEdit_ ''
				end.
		
				ewcheckrx hNewLink SetMode_IDLinkEdit_ ewcheckrx hLink GetMode_IDLinkEdit_''
				ewcheckrx hNewLink SetScale_IDLinkEdit_ ewcheckrx hLink GetScale_IDLinkEdit_''
				ewcheckrx hNewLink SetUseRounding_IDLinkEdit_ ewcheckrx hLink GetUseRounding_IDLinkEdit_''
				ewcheckrx hNewLink SetRoundingDigit_IDLinkEdit_ ewcheckrx hLink GetRoundingDigit_IDLinkEdit_''
				ewcheckrx hNewLink SetArrayAttributeId_IDLinkEdit_ ewcheckrx hLink GetArrayAttributeId_IDLinkEdit_''
			end.
			ewcheckrx hNewCube SetUpdateLinks_IDCubeEdit_ vhNewLinks ,~ ewcheckrx hNewCube GetUpdateLinks_IDCubeEdit_ ''
		end.
	end.

	NB. Identify the result
	'resultcube resultlist resultitem' =. resultparm GetValue ;:'Cube List Item'
	hResCube =. cubenamemap GetValue resultcube
	hResList =. listnamemap GetValue resultlist
	gResItem =. hResList GetItemGuid resultitem

	NB. Create the derivation measure
	hDerivation =. 'AdaytumDCube' CreateNamedObject id
	guid =. GetObjectId hDerivation
	hList =. 'AdaytumDList' CreateNamedObject id;'_Derivation'

	if. spec IsKey 'Scale' do.
		scale =. MakeNumber spec GetValue 'Scale'
	else.
		scale =. 0
	end.
	if. spec IsKey 'Decimals' do.
		decs =. MakeNumber spec GetValue 'Decimals'
	else.
		decs =. 0
	end.

	format =. GetTypeFormat type,scale,decs
	NB. If the result of the derivation is DList formatted then that must carry across
	hResItemFormat =. {. hResList ItemFormatsFromNames ,<resultitem
	if. 0 ~: hResItemFormat do.
		if. hResItemFormat QueryInterface 'ILookupFormatEdit' do.
			format =. hResItemFormat
		end.
	end.
	cube =. (id;CUBE_TYPE_DERIVATION;hDerivation;hList;<derivationlevels) RegisterCubeMeasures (,<id);(,<caption);(,type);ROLE_DERIVATION;(,:guid);(,aggregates);(,format);<,<adjustment
	derivation =. {. cube {:: CubeMeasures
	PopulateMeasureList cube
	ewcheckrx hDerivation SetDimensions_IDCubeEdit_ hList,~derivationdims
	ewcheckrx hDerivation SetMeasuresDimension_IDCubeEdit_ 0
	derivation TestDerivation spec

	NB. Link the result to the derivation measure
	(2 1 38$,gResItem,GetObjectId hDerivation) LinkMeasures hResCube,hDerivation,hResList,0

	ApplyMeasureAccess hDerivation

	Return
)

NB.-----------------------------------------------------------------------------
NB.  Currency Conversion
NB.-----------------------------------------------------------------------------



DetermineCurrencyConversion =: 3 : 0
	CurrencyConversion =: 0
	CurrencyLevel =: 0
	if. -. +./;Specification IsKey 'Consolidated Currency';'Currencies';'Multi-currency' do.
		Return
		return.
	end.

	if. -. Specification IsKey 'Consolidated Currency' do.
		Warn EW_WARNING_CURR_NO_CONSOL,EW_ACTION_NO_MULTI_CURR
		Return
		return.
	end.

	if. -. Specification IsKey 'Currencies' do.
		Warn EW_WARNING_CURR_NO_CURRS,EW_ACTION_NO_MULTI_CURR
		Return
		return.
	end.

	if. -. Specification IsKey 'Multi-currency' do.
		Warn EW_WARNING_CURR_NO_EXCHANGE,EW_ACTION_NO_MULTI_CURR
		Return
		return.
	end.

	'concurr multispec' =. Specification GetValue 'Consolidated Currency';'Multi-currency'

	CurrencyConversion =: 1
	CurrencyLevel =: 0
	ConsolidatedCurrency =: concurr
)

ImplementCurrencyConversion =: 3 : 0
	if. -.CurrencyConversion do. Return return. end.

	CurrencyConversion =: 1
	CurrencyLevel =: 0

	multispec =. Specification GetValue 'Multi-currency'

	if. -. *./; multispec IsKey ;:'Dimensions Columns Data' do.
		Warn EW_WARNING_CURR_BAD_EXCHANGE,EW_ACTION_NO_MULTI_CURR
		Return
		return.
	end.
	'dimtab columns data' =. multispec GetValue ;:'Dimensions Columns Data'
	
	if. -. *./; dimtab IsKey ;:'TextId Level' do.
		Warn EW_WARNING_CURR_BAD_EXCHANGE,EW_ACTION_NO_MULTI_CURR
		Return
		return.
	end.

	'dimids levelnums' =. dimtab GetValue ;:'TextId Level'
	levelnums =. MakeNumbers levelnums
	CurrencyLevel =: {.(>:/levelnums) FindLevels dimids
	currencylist =. CurrencyLevel { LevelItemLists
	currencycodes =. currencylist GetColumn TABLE_ITEMNAME

	ApplyCurrencyFormatsToLevelLists ''

	if. -. *./; columns IsKey ;:'TextId Role Type Reference' do.
		Warn EW_WARNING_CURR_BAD_EXCHANGE,EW_ACTION_NO_MULTI_CURR
		Return
		return.
	end.
	'colids roles types refs' =. columns GetValue ;:'TextId Role Type Reference'
	if. -. *./ (;:'Date Number Reference')e.types do.
		Warn EW_WARNING_CURR_BAD_EXCHANGE,EW_ACTION_NO_MULTI_CURR
		Return
		return.
	end.
	dateraterefcols =. types i. ;:'Date Number Reference'
	if. -. *./ ; data IsKey dateraterefcols { colids do.
		Warn EW_WARNING_CURR_BAD_EXCHANGE,EW_ACTION_NO_MULTI_CURR
		Return
		return.
	end.
	'rateenddates ratevalues ratecodes' =. data GetValue dateraterefcols { colids
	if. 0 = # ratevalues do.
		Warn EW_WARNING_NO_TABLE_ROWS,,EW_ACTION_NO_MULTI_CURR
		Return
		return.
	end.
	rateenddates =. _1 ConvertDates rateenddates
	ratevalues =. _1 MakeNumbers ratevalues
	ratecurrinds =. currencycodes Find ratecodes
	badrows =. +./ _1 = rateenddates,ratevalues,:ratecurrinds
	if. +./ badrows do.
		Warn EW_WARNING_BAD_ROWS,EW_ACTION_IGNORE
		Return
		return.
	end.
	'rateenddates ratevalues ratecodes' =. (-.badrows)#"1 rateenddates,ratevalues,:ratecurrinds
	if. -.+./-.badrows do.
		Warn EW_WARNING_NO_TABLE_ROWS,EW_ACTION_IGNORE
		Return
		return.
	end.

	for_timescale. bx DimensionIsTimescale do.
		timelevel =. {:timescale{::DimensionLevels
		timelist =. timelevel{LevelItemLists
		timehierarchy =. timelevel{LevelAggLists

		starts =. timelist GetColumn DLIST_TIME_START
		lengths =. timelist GetColumn DLIST_TIME_LENGTH
		ends =. starts + lengths - 1

		start =. <./starts
		end =. >./ends

		shape =. (#currencycodes), 1+end-start
		changeinds =. <"1 ratecurrinds ,. end - start >. rateenddates <. end
		changemat =. ratevalues changeinds } shape $ 0 
		changepoints =. 1 changeinds } shape $ 0
		ratemat =. 1 $~$ changemat

		for_currencyindex. i.#changemat do.
			lv =. currencyindex { changepoints
			if. +./lv do.
				changes =. lv # currencyindex { changemat
				rates =. +/\lv#^:_1]2-~/\0,changes
				ratemat =. (|.rates) currencyindex } ratemat
			end.
		end.

		opening =. (starts-start){"1 ratemat
		average =. |:(+/%#)"1 &> ( (starts-start) <@(+i.)"0 lengths ) {"1 L:0 ratemat
		closing =. (ends-start){"1 ratemat

		measurecaps =. ;:'Opening Average Closing'
		adjustments =. 'T:First';'T:Average';'T:Last'
		aggregates =. IsAggregable adjustments

		basecubeid =. (timescale {:: DimensionIds),'_BaseXrates'
		basemeasureids =. (<basecubeid,'_') ,&.> measurecaps
		basemeasurelist =. 'AdaytumDList' CreateNamedObject basecubeid;'_Measures'
		basemeasurelist PopulateList (basemeasureids;<adjustments);<TABLE_ITEMNAME,:DLIST_CALCADJUSTMENT
		basemeasureguids =. basemeasurelist GetColumn TABLE_ITEMGUID
		basecube =. 'AdaytumDCube' CreateNamedObject basecubeid
		ewcheckrx basecube SetDimensions_IDCubeEdit_ basemeasurelist,currencylist,timehierarchy

		importcubeid =. (timescale {:: DimensionIds),'_ImportXrates'
		importmeasureids =. (<importcubeid,'_') ,&.> measurecaps
		importmeasurelist =. 'AdaytumDList' CreateNamedObject importcubeid;'_Measures'
		importmeasurelist PopulateList (importmeasureids;<adjustments);<TABLE_ITEMNAME,:DLIST_CALCADJUSTMENT
		importmeasureguids =. importmeasurelist GetColumn TABLE_ITEMGUID
		importcube =. 'AdaytumDCube' CreateNamedObject importcubeid
		ewcheckrx importcube SetDimensions_IDCubeEdit_ hEList,importmeasurelist,timehierarchy

		(basecubeid;CUBE_TYPE_XRATE;basecube;basemeasurelist;<timelevel,CurrencyLevel) RegisterCubeMeasures basemeasureids;measurecaps;(MEASURE_TYPE_XRATE#~#measurecaps);ROLE_XRATESOURCE;basemeasureguids;aggregates;(0#~#measurecaps);<adjustments
		(importcubeid;CUBE_TYPE_XRATE;importcube;importmeasurelist;<timelevel,elistLevel) RegisterCubeMeasures importmeasureids;measurecaps;(MEASURE_TYPE_XRATE#~#measurecaps);ROLE_XRATESOURCE;importmeasureguids;aggregates;(0#~#measurecaps);<adjustments

		(basemeasureguids,:importmeasureguids) LinkMeasures basecube,importcube

		blockguids =. (basemeasurelist,currencylist,timelist) GetColumn&.> <TABLE_ITEMGUID
		aggitems =. 1"1 L:0 blockguids
		block =. CreateFreeObject 'AdaytumDCubeBlock'
		version =. ewcheckrx basecube GetVersionId_IDCubeEdit_''
		ewcheckrx block InitialiseBlock_IDCubeBlock_ (GetObjectId basecube);version;_1;blockguids;<aggitems
		ewcheckrx block SetData_IDCubeBlock_ ,opening,average,:closing
		ewcheckrx basecube SetBlocks_IDCubeEdit_ ,block
	end.
	CurrencyConversion =: 1
	Return
)

ApplyCurrencyFormatsToLevelLists =: 3 : 0
	currencylist =. CurrencyLevel { LevelItemLists
	currencycodes =. currencylist GetColumn TABLE_ITEMNAME
	currencyiids =. currencylist GetColumn TABLE_ITEMID
	currencyformats =. CreateCurrencyFormat&> currencycodes

	for_correspondence. bx CurrencyLevel = {:"1 CorrespondenceFromTo do.
		target =. {. correspondence { CorrespondenceFromTo
		'tgtiids srciids' =. <"1 correspondence {:: CorrespondenceTables
		for_list. target {&> LevelItemLists;LevelAggLists;LevelNonAggLists do.
			iids =. list GetColumn TABLE_ITEMID
			inds =. iids i. tgtiids
			fmts =. (currencyiids i. srciids) { currencyformats
			TABLE_ITEMFORMAT EnsureColumnInTable list
			ewcheckrx list Set_ITableEdit_ (,<fmts);inds;<,:TABLE_ITEMFORMAT
		end.
	end.
)

FindExchangeRates =: 4 : 0
	adjustments =. x.
	levels =. y.

	if. (-. CurrencyConversion) +. 0 = # adjustments do. 0#0 return. end.

	ratetypes =. (('T:First';'T:Last')i.adjustments){'Opening';'Closing';'Average'
	dims =. levels{LevelDims
	if. -. +./ dims { DimensionIsTimescale do. 0#0 return. end.
	timedim =. {. dims #~ dims { DimensionIsTimescale
	corrs =. bx CorrespondenceFromTo e. levels ,. CurrencyLevel
	if. 0 = # corrs do. 0#0 return. end.

	distances =. corrs { CorrespondenceDistances
	corr =. corrs {~ distances i. <./distances
	cubecurrlevel =. {. corr { CorrespondenceFromTo
	if. cubecurrlevel = elistLevel do.
		ratesource =. (timedim{::DimensionIds),'_ImportXrates'
	else.
		ratesource =. (timedim{::DimensionIds),'_BaseXrates'
	end.
	rateids =. ratesource ,L:0 '_' ,L:0 ratetypes
	rateinds =. FindMeasures rateids
	rateinds
)

AddCurrencyConversionMeasures =: 4 : 0
)

NB.-----------------------------------------------------------------------------
NB.  Grids
NB.-----------------------------------------------------------------------------

RestrictLevelsToContribution =: 4 : 0
	levels =. x.
	restrictions =. y.
	if. 0 = # restrictions do.
		levels
		return.
	end.
	dims =. levels { LevelDims
	resdims =. restrictions { LevelDims
	for_bad. bx -. levels e. restrictions,_1 do.
		if. (bad { dims) e. resdims do.
			((bad{levels){::LevelIds)Warn EW_WARNING_GRID_LEVEL_NON_CON,EW_ACTION_GRID_LEVEL_CONFORMED
			levels =. ((resdims i. bad { dims){restrictions) bad } levels
		else.
			((bad{levels){::LevelIds)Warn EW_WARNING_GRID_LEVEL_NON_CON,EW_ACTION_IGNORE
			levels =. _2 bad } levels
		end.
	end.
	levels =. levels -. _2
)


FindGridParmLevels =: 4 : 0
	measures =. x.
	parmvalues =. y.
	if. 0 = # parmvalues do.
		0#0
		return.
	end.
	levels =. FindLevels parmvalues
	for_level. levels do.
		if. 0 = level do.
			dim =. FindDimensions level_index {:: parmvalues
			if. dim = elistDim do.
				level =. elistLevel
			else.
				level =. dim CommonDimensionLevel measures
			end.
		else.
			dim =. level { LevelDims
			if. (dim = elistDim) *. level ~: elistLevel do.
				level =. elistLevel
				parmvalue Warn EW_WARNING_GRID_LEVEL_ELIST,EW_ACTION_USE_CONTRIB_LEVEL
			end.
		end.
		levels =. level level_index } levels
	end.
	levels
)

CreateGrid =: 3 : 0
	spec =. y.
	'id caption' =. GetIdentity spec
	hGrid =. 'AdaytumDCube' CreateNamedObject id
	'templateId parms' =. spec GetValue ;:'Template Parameters'
	templateId =. StripName templateId
	'parms objects' =. parms GetValue ;:'Parameter Object'
	parmtab =. (2 StripName parms),.objects
	impl =. GridTemplateSpecs GetValue templateId
	'cube view' =. impl GetValue ;:'Cube View'

	hMeasureList =. 'AdaytumDList' CreateNamedObject id;'_measures'
	measureParms =. cube GetValue 'Measure Dimension'
	measureIds =. 0 # <''
	for_measure. measureParms do.
		measureIds =. measureIds , parmtab GetValues ;measure
	end.
	measureInds =. FindMeasures measureIds
	for_notfound. measureIds #~ 0 = measureInds do.
		notfound =. > notfound
		notfound Warn EW_WARNING_MEASURE_NOT_FOUND,EW_ACTION_PARAMETER_IGNORED
	end.
	measureIds =. measureIds #~ 0 < measureInds
	measureInds =. measureInds -. 0

	if. 0 = # measureIds do.
		Warn EW_WARNING_GRID_NO_MEASURES,EW_ACTION_IGNORE
		Return
		return.
	end.

	'cubes guids types measurelevels aggregates captions formats adjustments' =. measureInds {L:0 _1 (MeasureCubes{CubeCubes);MeasureGuids;(MeasureCubes{CubeTypes);(MeasureCubes{CubeLevels);MeasureAggregates;MeasureCaptions;MeasureFormats;<MeasureAdjustments

	isContribution =. (CUBE_TYPE_CONTRIBUTION = types) *. -. AreMeasuresContributed measureInds
	if. +./isContribution do.
		master =. isContribution i. 1
		conlevels =. isContribution # measurelevels
		deferrals =. (bx -. *./\ conlevels e. {.conlevels){ bx isContribution
		for_deferral. deferrals do.
			(deferral {:: measureIds) Warn EW_WARNING_GRID_CON_BAD_DIM,EW_ACTION_GRID_CON_DEFERRED
			isContribution =. 0 deferral } isContribution
		end.
		conlevels =. 0 {:: conlevels
	else.
		conlevels =. 0#0
	end.

	rowlevels =. 0#0
	rowparms =. view GetValue 'Row Axis'
	for_rowparm. rowparms do.
		rowparm =. ; rowparm
		if. rowparm -: '[Measure Dimension]' do.
			rowlevels =. rowlevels , _1
		else.
			rowlevels =. rowlevels , measureInds FindGridParmLevels parmtab GetValues rowparm
		end.
	end.
	rowlevels =. rowlevels RestrictLevelsToContribution conlevels
	collevels =. 0#0
	colparms =. view GetValue 'Column Axis'
	for_colparm. colparms do.
		colparm =. ; colparm
		if. colparm -: '[Measure Dimension]' do.
			collevels =. collevels , _1
		else.
			collevels =. collevels , measureInds FindGridParmLevels parmtab GetValues colparm
		end.
	end.
	collevels =. collevels RestrictLevelsToContribution conlevels
	if. view IsKey 'Page Axis' do.
		pagelevels =. 0#0
		pageparms =. view GetValue 'Page Axis'
		for_pageparm. pageparms do.
			pageparm =. ; pageparm
			if. pageparm -: '[Measure Dimension]' do.
				pagelevels =. pagelevels , _1
			else.
				pagelevels =. pagelevels , measureInds FindGridParmLevels parmtab GetValues pageparm
			end.
		end.
		pagelevels =. pagelevels RestrictLevelsToContribution conlevels
	else.
		pagelevels =. ((_1-.~rowlevels,collevels){LevelDims)ResultDimensionality measureInds
	end.

	if. +./ -. conlevels e. rowlevels,collevels,pagelevels do.
		pagelevels =. pagelevels , conlevels -. rowlevels,collevels,pagelevels
	end.

	if. -. _1 e. rowlevels,collevels,pagelevels do.
		pagelevels =. pagelevels , _1
	end.

	if. (elistLevel e. ; measurelevels) *. -. elistLevel e. rowlevels,collevels,pagelevels do.
		pagelevels =. pagelevels , elistLevel
	end.

	gridlevels =. _1 ,~ (rowlevels,collevels,pagelevels) -. _1

	hView =. CreateFreeObject 'AdaytumCubeView'
	grid =. (id;hGrid;hMeasureList;hView) RegisterGrid (gridlevels-._1);isContribution # measureInds
	cube =. grid { GridCubes
	(measureInds;< ROLE_DATAENTRY (bx isContribution) } ROLE_DISPLAY #~# measureInds) PopulateMeasureList cube

	gridlists =. gridlevels { LevelAggLists,hMeasureList
	ewcheckrx hGrid SetDimensions_IDCubeEdit_ gridlists
	ewcheckrx hGrid SetMeasuresDimension_IDCubeEdit_ <:#gridlists

	LinkMeasuresByRole cube

	PopulateIfAssumption hGrid

	ewcheckrx hView SetCube_ICubeView_ hGrid
	ewcheckrx hView SetOrientation_ICubeView_ (<gridlevels) i.&.> (rowlevels;collevels),~,&.>pagelevels
	ewcheckrx hModel SetCubeViews_IModelEdit_ hView ,~ ewcheckrx hModel GetCubeViews_IModelEdit_''
	ewcheckrx hGrid SetAccessLevel_IDCubeEdit_ ACCESS_WRITE

	grid TestGrid spec

	ApplyMeasureAccess hGrid

	Return
)

NB.-----------------------------------------------------------------------------
NB.  Templates
NB.-----------------------------------------------------------------------------

LoadTemplates =: 3 : 0
	DerivationTemplateSpecs =: GetSpecs 'templates\derivation'
	DerivationTemplateXml =: 'xml' GetFiles 'templates\derivation'
	GridTemplateSpecs =: GetSpecs 'templates\grid'
	Return
)

GetTemplateVersions =: 3 : 0
	derivations =. 'txt'GetFiles'templates\derivation'
	grids =. 'txt'GetFiles'templates\grid'
	names =. ('DT_',L:0 {."1 derivations),'GT_',L:0 {."1 grids
	hashes =. ":&XorHash &.> GetTemplateSpecXml&.>names
	names ,. hashes
)

GetTemplateSpecXml =: 3 : 0
	id =. y.
	name =. StripName y.
	type =. ('DG'i.{.y.) {:: 'Derivation';'Grid'
	spec =. MapFromFile 'templates\',type,'\',name,'.txt'
	'parms doc' =. spec GetValue ;:'Parameter Documentation'
	'ids mins maxs parmtypes' =. parms GetValue ;:'Id Min Max Types'
	locnamedesc =. 0 3$<''
	parmlocnamedesc =. 0 4$<''
	for_localedoc. doc do.
		'locale locdoc' =. localedoc
		'name desc parmdoc' =. locdoc GetValue ;:'Name Description Parameter'
		locnamedesc =. locnamedesc , locale;name;desc
		'parmids parmnames parmdescs' =. parmdoc GetValue ;:'Id Name Description'
		parmlocnamedesc =. parmlocnamedesc , parmids ,. (<locale) ,. parmnames ,. parmdescs
	end.
	parmxmls =. (<'')#~#ids
	for_parm. ids,.mins,.maxs,.parmtypes do.
		'parmid min max parmtype' =. parm
		'parmloc parmname parmdesc' =. <"1|: (({."1 parmlocnamedesc)e.<parmid)#}."1 parmlocnamedesc
		parmxml =. }.PARAMETER_XML ParmSubString 'id';(id,'_',parmid);'locale';parmloc;'name';parmname;'description';parmdesc;'min';min;'max';max;'types';parmtype
		parmxmls =. (<parmxml) parm_index } parmxmls
	end.
	'locale name desc' =. <"1|: locnamedesc
	xml =. 1 |. TEMPLATE_XML ParmSubString 'id';id;'type';type;'locale';locale;'name';name;'description';desc;'parameters';<parmxmls
	xml
)

TEMPLATE_XML =: 0 : 0
<template xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	<PCATemplate id="%id%">
		<templateType>PCA_TT_%type%</templateType>
%*%		<language id="%locale%"><name>%name%</name><description>%description%</description></language>
%*%%parameters%
	</PCATemplate>
</template>
)

PARAMETER_XML =: 0 : 0
		<PCATmpltParam id="%id%">
%*%			<language id="%locale%"><name>%name%</name><description>%description%</description></language>
			<minCount>%min%</minCount>
			<maxCount>%max%</maxCount>
			<allowedObjects>%types%</allowedObjects>
		</PCATmpltParam>
)

NAMEDESC_XML =: 0 : 0
		<language id="%locale%">
			<name>%name%</name>
			<description>%description%</description>
		</language>
)

NB.-----------------------------------------------------------------------------
NB.  Tests
NB.-----------------------------------------------------------------------------

TestMeasure =: 4 : 0
	measure =. x.
	spec =. y.
	if. -. spec IsKey 'Tests' do.
		Return
		return.
	end.
	tests =. spec GetValue 'Tests'
	if. tests IsKey 'Levels' do.
		reqlevels =. tests GetValue 'Levels'
		actlevels =. ((measure { MeasureCubes) {:: CubeLevels) { LevelIds
		if. -. reqlevels -:&sort actlevels do.
			('Required :- ',(}.;';',&.>sort reqlevels),' Actual :- ',}.;';',&.>sort actlevels)Error EW_ERROR_TEST_FAILED_LEVELS
		end.
	end.
	Return
)

TestFormula =: TestMeasure
TestDerivation =: TestMeasure

TestGrid =: 4 : 0
	grid =. x.
	spec =. y.
	if. -. spec IsKey 'Tests' do.
		Return
		return.
	end.
	tests =. spec GetValue 'Tests'
	if. tests IsKey 'Levels' do.
		reqlevels =. tests GetValue 'Levels'
		actlevels =. ((grid { GridCubes) {:: CubeLevels) { LevelIds
		if. -. reqlevels -:&sort actlevels do.
			('Required :- ',(}.;';',&.>sort reqlevels),' Actual :- ',}.;';',&.>sort actlevels)Error EW_ERROR_TEST_FAILED_LEVELS
		end.
	end.
	Return
)
