18!:55 <'Utilities'
18!:4 <'Utilities'
(copath<'base')copath<'Utilities'
('Utilities';copath<'base')copath<'base'

Return =: 0 0$0
StripFileName =: (#~+./\@:('\'&=))&.|.
SortUnique =: ({~/:)@:~.
ColumnsFromTabLf =: <"1@|:@(-.&a:@(<;._1)@(TAB&,);._2)

U2W =: CP_UTF8_apicalls_&MultiByteToWideChar L:0

W2U =: 3 : 0
	if. 0=#y. do. y. return. end.
	codepage=. CP_UTF8_apicalls_
	widetext=. y.
	assert IsWideCharString widetext
	widetextlen=. ForceToInteger_array_ -: # widetext
	NULL =. <0
	First=. >@:{.
	dwFlags=.  0
	arg1=. codepage;dwFlags;(,widetext);widetextlen
	arg2=. 2#<NULL
	Arg=. (arg1&,) @:  (,&arg2) @: (#&({.a.) ; ]) NB. y. for this verb is the length of multibyte result buffer
	buflen=. First WideCharToMultiByte_apicalls_ arg1 , (NULL ; 0) ,arg2
	if. buflen > 0 do. 
		res=. WideCharToMultiByte_apicalls_ Arg buflen
		if. 0 < First res do.
			result=. First 3}. |. res
		else.
			'W2U 2nd call failed' assert 0
		end.
	else.
		'W2U 1st call failed' assert 0
	end.
	result
)

W2U =: W2U f. L:0

WBOM =: 255 254 { a.

UBOM =: W2U WBOM

DataType =: 3 : 0
	NB. 0 - number, 1 - character, 2 - boxed
	(,&.>0;' ';<a:)i.<1{.0#,y.
)

IsUuid =: 3 : 0
	if. 36 = #y. do.
		if. '----' -: 8 13 18 23 { y. do.
			if. *./ (y.-.'-')e.'0123456789abcdefABCDEF' do.
				1
				return.
			end.
		end.
	end.
	0
)

IndentString =: 3 : 0
	1 IndentString y.
:
	tabs =. x.#TAB
	string =. y.
	if. 0=#string do. string return. end.
	}. ; (LF,tabs) ,L:0 StringLines string
)

Split =: -.&a:@(<;._1)@,

StringLines =: 3 : 0
	LF Split y.
)

EscapeString =: 3 : 0
	('"\"';'\\\') EscapeString y.
:
	chars =. ,boxopen x.
	from =. {.&> chars
	to =. }.&.> chars
	string =. y.
	lv =. string e. from
	subs =. to {~ from i. lv # string
	;(/:/:lv){(<"0(-.lv)#string),subs
)

ParmParms =: 3 : 0
	line =. y.
	if. -.'%'e.line do.
		0#,a:
	else.
		a: -.~ {.|.|:_2]\<;._1 '%',line
	end.
)

ParmSubString =: 4 : 0
	table =. ('';,'%'),_2]\,y.
	string =. x.
	
	if. -.'%'e.string do.
		string
		return.
	end.
	output =. ''
	for_line. StringLines string do.
		if. '%' e. >line do.
			sets =. <;._1 '%',>line
			if. (2{.sets)e.(<''),.,&.>'*<>' do.
				repeat =. {.1{:: sets
				sets =. 2 }. sets
			else.
				repeat =. ' '
			end.
			lv =. 0 1$~$sets
			'text parms' =. lv</.sets
			subsmat =. table ParmSub parms
			select. {.repeat
			case. ' ' do.
				assert 1 = #subsmat
			case. '<' do.
				subsmat =. subsmat {.~ 1 <. # subsmat
			case. '>' do.
				subsmat =. }. subsmat
			end.
			for_subs. subsmat do.
				output =. output , LF, ; (/:/:lv){text,subs
			end.
		else.
			output =. output , LF, >line
		end.
	end.
	output
)

ParmSub =: 4 : 0
	names =. {."1 x.
	values =. {:"1 x.
	parms =. y.
	
	modifiers =. ('{$#"+^'e.~{.&(1&{.)&> parms){.&.>parms
	parms =. (#&>modifiers)}.&.>parms
	subs =. 0#<''
	for_parm. parms do.
		if. '_' = {.1{.>parm do.
			value =. ('ACE2',>parm)~
		else.
			assert parm e.names
			value =. values {::~ names i. parm
		end.
		select. DataType value
		case. 0 do.
			subs =. subs , < value
		case. 1 do.
			subs =. subs , < < value
		case. 2 do.
			subs =. subs , < value
		case. do.
			assert 0
		end.
	end.
	count =. >./$&>subs NB. empty vector if all scalar else maximum shape
	for_modifier. modifiers do.
		value =. modifier_index {:: subs
		select. {.1{.>modifier
		case. '{' do.
			value =. }.@}:L:0 value
		case. '$' do.
			value =. EscapeString L:0 value
		case. '#' do.
			value =. <":#value
		case. '"' do.
			value =. '_-' EscapeString L:0 (<&":`(":&.>)@.(#&$))value
		case. '+' do.
			value =. ":&.>value+i.count
		case. '^' do.
			value =. toupper L:0 value
		end.
		subs =. (<value) modifier_index } subs
	end.
	|:>,&.>(<>./$&>subs)$&.>subs NB. count could now be invalid because of #
)

LookUp =: 4 : 0
	table =. x.
	names =. y.
	(names i.~ {."1 table) { {:"1 table
)

NB. Returns _1 instead of #x. for a miss
Find =: ([: # [) |&.>: i.

NB."Safe" version of fread, that stops on failure
NB. Byte Order Mark sensitive. Returns UTF8 from UCS2.
FileRead=: 3 : 0
	result=.fread y.
	('Failure to read ',y.) assert -. _1 -: result
	select. a.i.2{.result
	case. 255 254 do.
		result =. W2U 2}.result
	case. 254 255 do.
		result =. W2U 2}.,|."1 [ _2[\ result
	case. 239 187 do.
		if. 191 = a.i.2{result do.
			result =. 3 }. result
		end.
	end.
	result
)


NB."Safe" version of fwrite, that stops on failure
FileWrite=: 4 : 0
	('Failure to write ',y.) assert _1 ~: x. fwrite y.
	0
)

NB. Replace line containing string with a new suffix 
ReplaceSuffix=: 4 : 0
	'string suffix'=.y.
	stringlist=.x.
	lx=.bx (1&e. @(string & E.)) &> stringlist
	('String ''',string,''' not found') assert 0<#lx
	('Duplicate occurrences found of string ''',string,'''') assert 1=#lx
	lx=.{.lx
	line=.>lx{stringlist
	line=.(((string E. line) i. 1){.line),string,suffix
	(<line) lx}stringlist
)

ParseMapValue =: 3 : 0
	lines =. y.
	if. 1 = # lines do.
		values =. }. TAB Split ; lines
		if. 1 = # values do.
			>{.values
		else.
			values
		end.
	else.
		select. }.TAB Split 0 {:: lines
		case. <'Table' do.
			names =. TAB Split 1 {:: lines
			values =. <"1 |: > (#names)({.!.(<''))&.> <;._1&.>2 }.lines
			names ,. values
		case. do.
			lines =. }.&.>}.lines
			if. TAB e. ; lines do.
				MakeMap lines
			else.
				lines
			end.
		end.
	end.
)

MakeMat =: 3 : 0
	> y.
:
	(>(<:x.){.&.>y.),.(<:x.)}.&.>y.
)

MakeMap =: 3 : 0
	lines =. y. #~ +./@(TAB&~:)&> y.
	parts =. (+/\TAB ~: {.&>lines)</.lines
	namelines =. {.&>parts
	names =. {.@ (TAB&Split)&>namelines
	values =. ParseMapValue &.> parts
	names,.values
)

MapFromString =: 3 : 0
	MakeMap LF Split LF ,~ CR -.~ y.
)

MapFromFile =: 3 : 0
	MapFromString FileRead SCRIPT_PATH,'..\',y.
)

MapFromTableFile =: 3 : 0
	1{::,MapFromString 'Dummy',TAB,'Table',LF,IndentString FileRead SCRIPT_PATH,'..\',y.
)

GetValues =: 4 : 0
	'names values' =. <"1|:x.
	(names e.<y.)#values
)

GetValues =: GetValues f. L:_ 0

GetValue =: 4 : 0
	'names values' =. <"1|:x.
	if. 0 = L. names do.
		(names i. y.){values
	else.
		(names i.<y.){::values
	end.
)

GetValue =: GetValue f. L:_ 0

GetTextColumns =: 4 : 0
	'names values' =. <"1|:x.
	lv =. y. e. names
	if. +./-.lv do.
NB.		(V2TabString (-.lv)#y.)Warn EW_WARNING_MISSING_COLUMNS,EW_ACTION_USE_EMPTY_STRINGS
	end.
	if. +./lv do.
		data =. x. GetValue lv # y.
		fill =. (<'')#~#0{::data
		data =. (data , (+/-.lv) # <fill) /:\: lv
	else.
		data =. (#y.)#<0#<''
	end.
	data
)
	

GetKeys =: 3 : 0
	'names values' =. <"1|:y.
	~. names
)

GetAllValues =: 3 : 0
	'names values' =. <"1|:y.
	values
)

SubStringsWhere =: 4 : 0
	string =. x.
	where =. y.
	key =. where * +/\2 </\ 0,where
	key </.&(where&#) string
)

IsKey =: 4 : 0
	'names values' =. <"1|:x.
	if. 0 = L. names do.
		y. e. names
	else.
		(<y.)e.names
	end.
)

IsKey =: IsKey f. L:_ 0

IsNumber =: 3 : 0
	string =. y.
	result =. _. ". string
	if. 0 < #$result do.
		0
	else.
		-. result e. _ _.
	end.
)

IsNumber =: >L:1@(IsNumber f. L: 0)

MakeNumber =: 3 : 0
	0 MakeNumber y.
:
	{.1({.!.x.)x.".y.
)

MakeNumbers =: MakeNumber&>

StripName =: 3 : 0
	1 StripName y.
:
	}. y. #~ x. <: +/\'_'=y.
)

StripName =: StripName f. L:0

GetFiles =: 3 : 0
	'*' GetFiles y.
:
	ext =. x.
	path =. y.
	names =. {."1]1!:0 SCRIPT_PATH,'..\',path,'\*.',ext
	files =. FileRead L:0 (SCRIPT_PATH,'..\',path,'\'),L:0 names
	if. -. '*' -: ext do.
		names =. (-1+#ext)}.L:0 names
	end.
	names ,. files
)

GetSpecs =: 3 : 0
	'names files' =. <"1|: 'txt' GetFiles y.
	names ,. MapFromString L:0 files
)

DateStamp =: 3 : 0
	'- :' DateStamp y.
:
	}.;(3 1 2#x.),&.>(-4 2 2 2 2 2){.&.>'0000',L:0":&.><.0.5+6!:0''
)

DateFileName =: 3 : 0
	'txt' DateFileName y.
:
	y. , '_',('-_-'DateStamp''),'.',x.
)

XorHash =: 3 : 0
	31 XorHash y.
:
	bits =. x.
	string =. y.
	hash =. #.(+.*.*:)"1/(-bits)[\,#:255,a.i.string
)

ROLE_SUFFIX_MAX_LENGTH =: 15

GetShortName =: 3 : 0
	(TABLE_ITEMNAME_MAXIMUM_CHARACTERS_systemcolumn_-ROLE_SUFFIX_MAX_LENGTH) GetShortName y.
:
	maxlen =. 2 * 12 >. x.
	name =. U2W y.
	if. (#name) > maxlen do.
		hash =. ":XorHash |.name
		shortname =. ((maxlen-2*1+#hash){.name), U2W '_',hash
	else.
		shortname =. name
	end.
	W2U shortname
)

GetShortName =: GetShortName f. L:0

IsUnique =: (i.=i:)~

PairWhereGreater =: ((#~>/"1)&(>@,@{@(2&#)@<))~
0 0$0 : 0	NB. examples
   5 3 3 8 PairWhereGreater i.4
1 0
2 0
2 1
3 0
3 1
3 2
   5 3 3 8 PairWhereGreater i.4
0 1
0 2
3 0
3 1
3 2
)