// SOAP send/receive
var oXMLHTTP
var cafId
var camPassportId

var protoRequest = 
'<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:bus="http://developer.cognos.com/schemas/bibus/3/" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/">'+
'	<SOAP-ENV:Header>'+
'        <bus:biBusHeader xsi:type="bus:biBusHeader">'+
'            <bus:CAF xsi:type="bus:CAF">'+
'                <contextID xsi:type="xsd:string">$$contextID$$</contextID>'+
'            </bus:CAF>'+
'            <bus:CAM xsi:type="bus:CAM">'+
'            <bus:CAMPassport xsi:type="bus:CAMPassport">'+
'               <id xsi:type="xs:string">$$passportID$$</id>'+
'            </bus:CAMPassport>'+
'          </bus:CAM>'+
'       </bus:biBusHeader>'+
'	</SOAP-ENV:Header>'+
'	<SOAP-ENV:Body>'+
'       <rns1:runSpecification xmlns:rns1=\"http://developer.cognos.com/schemas/reportService/1\">'+
'           <specification xsi:type=\"bus:planningRuntimeServiceSpecification\">'+
'               <bus:value xsi:type=\"bus:specification\">'+
'                   &lt;epSOAPBody&gt;'+
'                   &lt;className&gt;EPXML&lt;/className&gt;'+
'                   &lt;methodName&gt;$$Page$$&lt;/methodName&gt;'+
'                   &lt;keepAlive&gt;0&lt;/keepAlive&gt;'+
'                   &lt;objectHandle&gt;00000000$&lt;/objectHandle&gt;'+
'                   &lt;numArguments&gt;$$NumArguments$$&lt;/numArguments&gt;'+
'                   &lt;timeout&gt;0&lt;/timeout&gt;'+
'                   &lt;asyncMode&gt;0&lt;/asyncMode&gt;'+
'                   &lt;timeInterval&gt;0&lt;/timeInterval&gt;'+
'                   &lt;argument&gt;$$applicationID$$&lt;/argument&gt;'+
'                   &lt;/epSOAPBody&gt;'+
'               </bus:value>'+
'           </specification>'+
'           <parameterValues xsi:type=\"SOAP-ENC:Array\" SOAP-ENC:arrayType=\"bus:parameterValue[]\"/>'+
'           <options xsi:type=\"SOAP-ENC:Array\" SOAP-ENC:arrayType=\"bus:option[]\">'+
'              <item xsi:type=\"bus:runOptionInt\">'+
'                  <value xsi:type=\"xsd:int\">0</value>'+
'                   <name xsi:type=\"bus:runOptionEnum\">primaryWaitThreshold</name>'+
'               </item>'+
'               <item xsi:type=\"bus:runOptionInt\">'+
'                  <value xsi:type=\"xsd:int\">0</value>'+
'                   <name xsi:type=\"bus:runOptionEnum\">secondaryWaitThreshold</name>'+
'               </item>'+
'           </options>'+
'       </rns1:runSpecification>'+
'   </SOAP-ENV:Body>'+
'</SOAP-ENV:Envelope>'

function getXml(contributorParameters, page, onReadyStateChangedEvent)
{
    try
    {
        if (arguments.length < 3) {
            return getXml(contributorParameters, page, null)
        }
        
        setCookies()
    
        var docRequest = new ActiveXObject("Microsoft.XMLDOM");
    
        var sRequest = protoRequest
        sRequest = sRequest.replace("$$contextID$$", contributorParameters['ui.cafcontextid'])
        sRequest = sRequest.replace("$$passportID$$", camPassportId)
        sRequest = sRequest.replace("$$applicationID$$", contributorParameters['ui.appname'])
        sRequest = sRequest.replace("$$Page$$", page)
    
        if (!docRequest.loadXML( sRequest )) {
            var failMsg = "@" + docRequest.parseError.line + "," + + docRequest.parseError.linepos + 
                ": "+docRequest.parseError.reason
            alert(failMsg)
            throwOrAssignApplicationError( null, null,  'planning12.js::getXml', 'errorFailedToLoadXML')
        }
        oXMLHTTP = new ActiveXObject( "Msxml2.XMLHttp" );
        var sURL = contributorParameters['ui.gateway']
        oXMLHTTP.Open( "POST", sURL, onReadyStateChangedEvent != null );
    
        if (onReadyStateChangedEvent)
        {
            oXMLHTTP.onreadystatechange = onReadyStateChangedEvent;
        }
    
        oXMLHTTP.setRequestHeader( "Content-Type", "text/xml; charset=utf-8" );
        oXMLHTTP.setRequestHeader( "SOAPAction", "planningRuntimeService" );
        oXMLHTTP.setRequestHeader( "Set-Cookie", "caf=" + cafId);
        oXMLHTTP.setRequestHeader( "Set-Cookie", "cam_passport=" + camPassportId);
        oXMLHTTP.Send( docRequest );
    
        if (onReadyStateChangedEvent)
        {
            return oXMLHTTP
        }
        else
        {
            var responseXml = oXMLHTTP.responsexml
            checkForSoapFault(responseXml)
            return responseXml
        }
    }
    catch(eCaught)
    {
        throwOrAssignApplicationError( null, eCaught, 'planning12.js::errorCheckThrow', 'errorServerReturnedError');
    }
}

function checkForSoapFault(responseXml)
{
    var faultNode = responseXml.selectSingleNode('/SOAP-ENV:Envelope/SOAP-ENV:Body/SOAP-ENV:Fault')
    if (faultNode != null) {
        var msg = ""
        msgNode = faultNode.selectSingleNode('faultstring')
        if (msgNode != null) msg += msgNode.text + '<BR>'
        msgNode = faultNode.selectSingleNode('//messageString')
        if (msgNode != null) msg += msgNode.text
        throwOrAssignApplicationError( null, new Error(0, msg), 'planning12.js::checkForSoapFault', 'errorServerReturnedError');
    }
}

function setCookies()
{
    var cookieValues = document.cookie.split(";");

    for (var i = 0; i < cookieValues.length; i++)
    {
        if (cookieValues[i].match(/^\s*cam_passport=/i))
        {
            camPassportId = decodeURIComponent(cookieValues[i].split("=")[1]);
        } else if (cookieValues[i].match(/^\s*caf=/i))
        {
            cafId = decodeURIComponent(cookieValues[i].split("=")[1]);
        }
   }
}

