//
// Copyright (C) 2004  Cognos Incorporated.   All Rights Reserved.
//
// client script include file for most pages


// -<>---------------------------------------------------------------------------------------------
// Function: webLogMessage
// Purpose:  client side implementation
// Comment:  here there is no error log as such, so use debug output window
// -><---------------------------------------------------------------------------------------------

var logLevelNone         = 0;
var logLevelError        = 1;
var logLevelWarning      = 2;
var logLevelInformation  = 3;
var logLevelVerbose      = 4;

function webLogMessage(logLevel, msg)
{
    try
    {
        debugLog(msg);
    }
    catch(e)
    {
	// supress any caught error
    }
}



// -<>---------------------------------------------------------------------------------------------
//     Name: finalMessage
//  Purpose: display final (error) message in place of contributor application 
//  Comment: Replaces finalmessage.htm. Might do this with XML and a style sheet if get time
// -><---------------------------------------------------------------------------------------------
function finalMessage(title, caption, retry)
{
	var doc = window.document.open();
	
	var s='';
	s += '<head>';
	s += '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">';
	s += '<META HTTP-EQUIV="Expires" CONTENT="-1">';
	s += '</head>';
	s += '<body><table width="80%" height="80%" border="0" align="center" border="1">';
	s += '<tr>';
	s += '<td colspan="3" valign="center" align="center">';
	s += '<h2>' + caption + '</h2>';
	s += '</tr>';

	if (retry)
	{
		//s += '<tr><td align="center"><a href="javascript:window.history.back();">';
		s += '<tr><td align="center"><a href="planning00.asp">';
		s += retryCaption;
		s += '</a></td></tr>';
	}

 	s += '</table></body>';

	doc.write(s);
	doc.close();

	doc.title=title;

    return true;
}


function finalMessageXml(theXml)
{
	var doc = window.document.open();
	
	var s='';
	s += '<head>';
	s += '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">';
	s += '<META HTTP-EQUIV="Expires" CONTENT="-1">';
        s += '<META HTTP-EQUIV="ContentType" CONTENT="text/xml">';
	s += '</head>';
	s += theXml;
	doc.write(s);
	doc.close();
	return true;

}





// -<>---------------------------------------------------------------------------------------------
//     Name: errorLookupStringsAtClient
//  Purpose:
//  Comment: (client side implementation of errorLookupStrings )
//          
// -><---------------------------------------------------------------------------------------------
function errorLookupStringsAtClient(e, url)
{ 
    webLogMessage(logLevelInformation, '...errorLookupStringsAtClient');
    try
    {
        errorDefaultStrings(e);
    
        // go get the strings
        var xmlhttp = new ActiveXObject('Msxml2.XMLHttp');

        if (!xmlhttp)
        {
            e.thisPageErrorDescription= 'Error definitions XML: cannot create Msxml2.XMLHttp<br>';
            return; 
        }
    
//these do not work: last commented out one does
        //xmlhttp.open('GET', 'http://wyorbatesk-xp:8080/cognos/contributor/planning70.asp?99', false); 
        //xmlhttp.open('GET', getURIStem() + 'planning70.asp?99', false); 
        //xmlhttp.open('GET', 'http://localhost/cognos8/contributor/en/errorstrings.xml', false);

        //xmlhttp.open('GET', '/cognos8/contributor/en/errorstrings.xml', false);  

        //alert('planning77.js::errorLookupStringsAtClient=' + url);

        xmlhttp.open('GET', url, false); 
        xmlhttp.send();
  
        var doc = new ActiveXObject('Msxml2.DOMDocument');
  
        if (!doc)
        {
            e.thisPageErrorDescription= 'Error definitions XML: cannot create Msxml2.DOMDocument<br>';
            return; 
        }

        doc.load(xmlhttp.responseXML);

        var xNodeErrorDefinitions = doc.documentElement.selectSingleNode('/contributor/errorDefinitions');
        errorLookupStrings(e, xNodeErrorDefinitions);

    }
    catch(eCaught)
    {
         e.thisPageErrorDescription= 'Error definitions XML: errorLookupStringsAtClient: ' + eCaught.description + '<br>';
    }
 
    return;
}



// -<>---------------------------------------------------------------------------------------------
//     Name: furtherInformationClick
//  Purpose:
//  Comment: handler for generated error page 
// -><---------------------------------------------------------------------------------------------
function furtherInformationClick()
{
    if (window.furtherInformationText.style.visibility=='hidden' )
    {
        window.furtherInformationText.style.visibility='visible';
        window.furtherInformationButton.src = 'images/detailsbuttons/details_up_off.gif';
    }
    else
    {
        window.furtherInformationText.style.visibility='hidden';
        window.furtherInformationButton.src = 'images/detailsbuttons/details_down_off.gif';
    }
}




// -<>---------------------------------------------------------------------------------------------
//
//     Name: errorFinalMessage
//  Purpose: display final (error) message in place of contributor application 
//  Comment: To do : parameter substitution, or display the error chain (e.allOtherErrors)
//
//  Pass in theWindow as the first parameter, so that pages of the frameset can replace the top level
//  frame - the window (parameter) should support a productLanguage property
// -><---------------------------------------------------------------------------------------------
function errorFinalMessage(theWindow, e, productLanguage, applicationPhaseId, applicationErrorSource, applicationErrorId)
{
    try
    {
        webLogMessage(logLevelVerbose, 'errorFinalMessage');

        var eFinal = new Error(0, '');
        errorSetApplicationPhaseId(eFinal, e, applicationPhaseId,  applicationErrorSource, applicationErrorId ); 
  
        errorLookupStringsAtClient(eFinal, productLanguage + '/errorstrings_' + productLanguage + '.xml');  
        errorFormatStrings(eFinal);

        eFinal.browserKnownGood = true;
        theWindow.isFinalMessage= true;
		theWindow.enableEventHandling=false;
 
        var s = '<scr' + 'ipt language="javascript" src="planning77.js"></scr' + 'ipt>';
        s += errorFormatOutputTable(eFinal);

        errorWritePage(theWindow, s, eFinal.applicationErrorLookupTitle);
    }
    catch(eNested)
    {
       var s = errorNested();
       errorWritePage(theWindow, s, 'nested error');
    }
    
    return;
}

function errorWritePage(theWindow, s, windowTitle)
{
    var doc = theWindow.document.open();
    doc.write(s);
    doc.close();
    doc.title= windowTitle;
    return;
}


// -<>---------------------------------------------------------------------------------------------
//     Name: validateError
//  Purpose: ensure that the error object has all expected properties
//  Comment: 
//       
// -><---------------------------------------------------------------------------------------------
function validateError(e)
{
// lookup description in XML on error page, substitute parameters, default to making the description empty
// retry false
    window.document.xmlPage
	e.applicationErrorCaption = '';
	e.applicationErrorTitle='';
	e.retry = 0;
        e.componentErrorDescription='validateErrorPlaceholder';
        e.componentErrorNumber=60;
	return;
}



// -<>---------------------------------------------------------------------------------------------
//     Name: errorCheckThrow
//  Purpose: 
//  Comment: if the server has returned error information, convert it to an error object and throw it  
//
//  In this case we expect to have 3 errors in the chain
//  Main error : as reported from the server
//  error next : as reported from errorCheckThrow
//  error next : as reported from the page entry point    
// -><---------------------------------------------------------------------------------------------
function errorCheckThrow(root)
{
    webLogMessage(logLevelInformation, 'errorCheckThrow');
    if (!root)
    {
	var e = new Error(0, "page XML root node is NULL");
        throwOrAssignApplicationError(null, e, 'planning77.js::errorCheckThrow', 'errorXMLNodeNull');
    }

    var e=new Error(0, '');
    var  errorInformation = safeSelectSingleNode(e, root, 'errorInformation');
    if (!errorInformation.notFound)
    {
        var applicationPhaseId         = safeSelectSingleNode(null, errorInformation, 'applicationPhaseId').text;
        var applicationErrorSource     = safeSelectSingleNode(null, errorInformation, 'applicationErrorSource').text;
	var applicationErrorId         = safeSelectSingleNode(null, errorInformation, 'applicationErrorId').text;
        var s                          = safeSelectSingleNode(null, errorInformation,'componentErrorNumber/decimal').text;
        var componentErrorNumber       = parseInt(s, 10);

        var componentErrorDescription  = safeSelectSingleNode(null, errorInformation,'componentErrorDescription').text;
 
        var applicationErrorParameters = new Array();	// and the parameters eventually

        var e = new Error(0, '');
        assignApplicationError(e, true, componentErrorNumber, componentErrorDescription, applicationErrorSource, applicationErrorId, applicationErrorParameters);

        throwOrAssignApplicationError( null, e, 'planning77.js::errorCheckThrow', 'errorServerReturnedError');
    }
    return;
}


// recommended work around to avoid click to activate ActiveX control
// ref http://support.microsoft.com/kb/912945


function createTreeControl()
{
    var controlContainer = window.document.all('controlContainer');
    var s = '<object id="OUTLINE" ' +
           ' classid="clsid:FA39208D-C011-4495-A74C-E0BD567F4C15"  ' +
           ' width="100%" height="100%" >' +
           '</object>';

	controlContainer.innerHTML = s;
}